//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <math.h>
#include <io.h>
#include <errno.h>
#include <direct.h>

#include "BmpProc.h"


////////////////////////////// defines ///////////////////////////////////
#ifdef _DEBUG
//#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



// ڵĿļʾйCBmpProcʵ
// static DWORD GetObjectCount()Աʸñ
// ע⣺ñͷĺֻڵģʽ²ŻЧ
//		 תΪģʽǶʧЧʹGetObjectCount()
//		 ԱʱӦ#ifdef _DEBUG .... #endif
#ifdef _DEBUG
	DWORD CBmpProc::m_ObjectCount = 0;
#endif




/*************************************************************************
 * 캯ʼΪա
*************************************************************************/


CBmpProc::CBmpProc()
{
	// ʼΪ
	m_mark = FALSE;			// Ч־TRUE-ЧλͼΪFALSE
	m_type = IT_NULL;		// ͼ͡
	m_addInfo = 0;			// Ϣ
	m_cFileName.Empty();	// ļ·
	m_pInfo = NULL;			// DIBϢṹ
	m_hObject = NULL;		// DDBλͼԱ
	m_hClipRegion = NULL;

#ifdef _DEBUG
	CBmpProc::m_ObjectCount++;
#endif
}



/*************************************************************************
 * úȡCBmpProcĿĸ
*************************************************************************
#ifdef _DEBUG
DWORD CBmpProc::GetObjectCount()
{
	return m_ObjectCount;
}
#endif
*************************************************************************/


/*************************************************************************
 * ಻Ϊ
*************************************************************************/


CBmpProc::~CBmpProc()
{
	Clear();

#ifdef _DEBUG
	CBmpProc::m_ObjectCount--;
#endif
}




/*************************************************************************
 *
 * operator=()
 *
 * ˵
 * 
 * const CBmpProc& ds		- Դλͼ
 * 
 * ֵ
 * 
 * CBmpProc&				- 
 * 
 * 
 *
 * ȡָλͼ
 * 
 * ɹԭλͼеĻɾɹ
 * ԭλͼִб֮󣬿ɵøIsValid()жǷɹƣ
 * ֻʹûͼ࣬ǰоʹͼ񣬿==жϸ
 * ԴλͼǷͬͬʾƳɹͬ˵ʧܣ
 * 
 ************************************************************************/


CBmpProc& CBmpProc::operator=(const CBmpProc& ds)
{
	// ûͼֱӷ
	if (!ds.IsValid())
		return *this;

	ASSERT(ds.m_pInfo);
	ASSERT(ds.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// ԴͼϢ
	LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
		(LPVOID)ds.m_pInfo);
	if (!pInfo)
		return *this;

	// Դͼ
	CBitmap		tempBmp;
	HBITMAP		hBmp;

	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC = ::GetDC(hWnd);
	CDC dc;
	dc.Attach(hDC);

	if (tempBmp.CreateCompatibleBitmap(&dc, ds.Width(), ds.Height()))
	{
		CDC			compDC, compDC2;
		CBitmap		*pOldBmp, *pOldBmp2;

		// 뵱ǰʾ豸ݵڴ豸
		compDC.CreateCompatibleDC(NULL);
		compDC2.CreateCompatibleDC(NULL);

		pOldBmp	= compDC.SelectObject((CBitmap*)&tempBmp);
		pOldBmp2= compDC2.SelectObject((CBitmap*)&ds);

		// ָߴԴλͼĿλͼ
		compDC.BitBlt(0, 0, ds.Width(), ds.Height(), 
					&compDC2, 0, 0, SRCCOPY);

		compDC2.SelectObject(pOldBmp2);
		compDC.SelectObject(pOldBmp);

		hBmp = (HBITMAP)tempBmp.Detach();
		// ʧܣFALSE
		ASSERT(hBmp);
		if (!hBmp)
		{
			::ReleaseDC(hWnd, dc.Detach());
			::free((void*)pInfo);
			return *this;;
		}
		::ReleaseDC(hWnd, dc.Detach());

		// ɾԭͼ񣬲µλͼ
		if (!ClearAndSetData(IT_MEMORY,0,(LPCTSTR)"",pInfo,hBmp))
		{
			::free((void*)pInfo);
			::DeleteObject(hBmp);
			return *this;
		}
		return *this;
	}
	else
	{
		::ReleaseDC(hWnd, dc.Detach());
		::free((void*)pInfo);

		return *this;;
	}
}



/*************************************************************************
 *
 * operator=()
 *
 * ˵
 * 
 * const HBITMAP sou		- Դλͼ
 * 
 * ֵ
 * 
 * CBmpProc&				- 
 * 
 * 
 *
 * ȡָλͼ
 * 
 * ɹԭλͼеĻɾɹ
 * ԭλͼִб֮󣬿ɵøIsValid()жǷɹƣ
 * ֻʹûͼ࣬ǰоʹͼ񣬿==жϸ
 * ԴλͼǷͬͬʾƳɹͬ˵ʧܣ
 * ڲָλͼЧʧܡ
 * 
 ************************************************************************/


CBmpProc& CBmpProc::operator=(const HBITMAP sou)
{
	// ڼ
	if (!sou)
		return *this;

	CBmpProc tmp;

	if (!tmp.Attach(sou))
		return *this;

	ASSERT(sou == (HBITMAP)tmp);

	// ำֵ
	*this = tmp;
	// Դλͼֹɾ
	tmp.Detach();

	return *this;
}



/*************************************************************************
 *
 * operator==()
 *
 * ˵
 * 
 * const CBmpProc& ds		- Դλͼ
 * 
 * ֵ
 * 
 * BOOL						- ͬTRUEͬFALSE
 * 
 * 
 *
 * жԴλͼ뱾Ƿͬ
 * 
 * úͨȽλͼжǷͬͼ
 * 
 * ע# ඼ǿյģûͼ񣩣úǲͬ
 *
 ************************************************************************/


BOOL CBmpProc::operator==(const CBmpProc& ds)
{
	// һǿյģûͼ񣩣ú
	// ǲͬ
	if ((ds.IsValid()==FALSE)||(IsValid()==FALSE))
		return FALSE;

	// ȽϣֱӷTRUE
	if (this == &ds)
		return TRUE;

	ASSERT(m_pInfo);
	ASSERT(ds.m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));
	ASSERT(ds.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// Ϣ鳤ȱȽ
	if (::_msize(m_pInfo) != ::_msize(ds.m_pInfo))
		return FALSE;

	// ϢݱȽ
	if (::memcmp((const void*)m_pInfo, \
		(const void*)ds.m_pInfo,::_msize(m_pInfo)))
		return FALSE;

	// DIBλݵĻ
	LPSTR pBits1 = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		CalculateDIBitsSize((LPBITMAPINFOHEADER)m_pInfo));
	if (!pBits1)
		return FALSE;

	LPSTR pBits2 = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		CalculateDIBitsSize((LPBITMAPINFOHEADER)m_pInfo));
	if (!pBits2)
	{
		::free((void*)pBits1);
		return FALSE;
	}

	// λͼϢ飬ΪGetDIBits()пܻıɫ
	LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
		(LPVOID)m_pInfo);
	if (!pInfo)
	{
		::free((void*)pBits1);
		::free((void*)pBits2);
		return FALSE;
	}

	ASSERT(pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC;

	// ȡλͼDIBλ
	hDC = ::GetDC(hWnd);
	ASSERT(m_hObject);
	ASSERT(ds.m_hObject);
	if (!::GetDIBits(hDC,(HBITMAP)m_hObject,0,pInfo->bmiHeader.biHeight, \
			(LPVOID)pBits1,pInfo,DIB_RGB_COLORS))
	{
		::free((void*)pBits1);
		::free((void*)pBits2);
		::free((void*)pInfo);
		::ReleaseDC(hWnd, hDC);
		return FALSE;
	}
	if (!::GetDIBits(hDC,(HBITMAP)ds.m_hObject,0,pInfo->bmiHeader.biHeight, \
			(LPVOID)pBits2,pInfo,DIB_RGB_COLORS))
	{
		::free((void*)pBits1);
		::free((void*)pBits2);
		::free((void*)pInfo);
		::ReleaseDC(hWnd, hDC);
		return FALSE;
	}
	::ReleaseDC(hWnd, hDC);
	::free((void*)pInfo);

	// λݱȽ
	LONG leng = (LONG)CalculateDIBitsSize((LPBITMAPINFOHEADER)m_pInfo)/4;
	LPDWORD lp1 = (LPDWORD)pBits1;	// DIBλDWORD
	LPDWORD lp2 = (LPDWORD)pBits2;

	// Ϊmemcmp()ǷԱȽϴ64KݣԲŲ
	// ϱķ
	while(leng--)
	{
		if (*lp1 != *lp2) break;
		lp1++; lp2++;
	}

	// Ƚ֮λãͷ
	::free((void*)pBits1);
	::free((void*)pBits2);
	
	if (leng != -1L)
		return FALSE;	// λݲͬFALSE

	return TRUE;
}



/*************************************************************************
 *
 * operator!=()
 *
 * ˵
 * 
 * const CBmpProc& ds		- Դλͼ
 * 
 * ֵ
 * 
 * BOOL						- ͬTRUEͬFALSE
 * 
 * 
 *
 * жԴλͼǷ뱾಻ͬ
 * 
 * úͨȽλͼжǷͬͼ
 * 
 * ע# ඼ǿյģûͼ񣩣úǲͬ
 *
 ************************************************************************/


BOOL CBmpProc::operator!=(const CBmpProc& ds)
{
	return ((*this) == ds) ? FALSE:TRUE;
}



/*************************************************************************
 *
 * Draw()
 *
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * const CRect* rcDst		- Ŀ
 * const CRect* rcSrc		- Դ
 * 
 * ֵ
 *
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ָͼĿ豸ָԴ򣨼Σ
 * Ŀͬѹ
 * 
 * ԴκĿNULL,ζͼĳߴ
 * 
 * ûͼʲôҲֱӷ
 * Ƶͼڵǰڣֱӷ
 * 
 ************************************************************************/


BOOL CBmpProc::Draw(CDC& dc, const CRect* rcDst, const CRect* rcSrc)
{
	// ûͼֱӷ
	if (!IsValid())
		return TRUE;

	ASSERT(m_hObject);

	// ȱʡεͼߴ
	CRect DCRect(Rect());			// Ŀλ
	CRect DibRect(Rect());			// Դλ

	if (rcDst)
		DCRect = *rcDst;
	if (rcSrc)
		DibRect = *rcSrc;

	// Ƶͼڵǰڣֱӷ
	if (!dc.RectVisible(&DCRect))
		return TRUE;

	CDC			compDC;
	CBitmap		*pOldBmp;

	compDC.CreateCompatibleDC(NULL);
	pOldBmp	= compDC.SelectObject((CBitmap*)this);

	/* ĿDCģʽΪSTRETCH_DELETESCANSҲǲʾͼ */
	int srlold = dc.SetStretchBltMode(STRETCH_DELETESCANS);

	// ʾλͼ
	dc.StretchBlt(DCRect.left, DCRect.top, DCRect.Width(), DCRect.Height(), 
					&compDC, DibRect.left, DibRect.top, 
					DibRect.Width(), DibRect.Height(), SRCCOPY);
	
	// ָ豸ԭ
	dc.SetStretchBltMode(srlold);
	compDC.SelectObject(pOldBmp);

	return TRUE;
}



/*************************************************************************
 *
 * DrawTile()
 *
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * CRect* crArea			- 跶Χ꣩
 * 
 * ֵ
 *
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * еͼƽ̷ʽָ
 * 
 * ڲcrAreaNULL,FALSE겻Ϲ淶
 * ߵұߵ꣩Զ淶Ŀ
 * ߶0FALSE
 * 
 * ûͼʲôҲֱӷ
 * 
 ************************************************************************/


BOOL CBmpProc::DrawTile(CDC& dc, CRect* crArea)
{
	if (!crArea)
		return FALSE;

	// ûͼֱӷ
	if (!IsValid())
		return TRUE;

	CRect rect = *crArea;
	CRect tprc;

	// 淶
	rect.NormalizeRect();

	if ((rect.Width()==0)||(rect.Height()==0))
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_hObject);

	// ΪĴ뽫ı豸мãȽ䱣
	int savedc = dc.SaveDC();

	CRgn newrgn;
	newrgn.CreateRectRgnIndirect(&rect);
	// ֻʾָпɼĲ֣AND
	dc.SelectClipRgn(&newrgn, RGN_AND);

	for (int y=rect.top;y<rect.bottom;y+=Height())
	{
		for (int x=rect.left;x<rect.right;x+=Width())
		{
			// Ƭʽظʾͼ
			tprc.SetRect(x,y,x+Width(),y+Height());
			Draw(dc, &tprc);
		}
	}

	dc.RestoreDC(savedc);
	// ָ豸֮󣬽ľʾɾ
	// ΢ĵעҪCGdiObject::DeleteObject()
	//   ʾɾ֪ʲôԭ
	newrgn.CGdiObject::DeleteObject();

	return TRUE;
}



/*************************************************************************
 *
 * DrawCenter()
 *
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * CRect* crArea			- ʾΧ꣩
 * 
 * ֵ
 *
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ͼĿ豸ָ򣨾Σ룬ͼе
 * еغ
 * 
 * εĳߴСͼߴ磬ͼֻܲ᲻ɼ
 * ڲcrAreaNULLFALSE
 * ûͼʲôҲֱӷ
 * 겻Ϲ淶ߵұߵ꣩Զ
 * 淶ĿȻ߶0FALSE
 * 
 ************************************************************************/


BOOL CBmpProc::DrawCenter(CDC& dc, CRect* crArea)
{
	if (!crArea)
		return FALSE;

	// ûͼֱӷ
	if (!IsValid())
		return TRUE;

	CRect rect = *crArea;

	// 淶
	rect.NormalizeRect();

	if ((rect.Width()==0)||(rect.Height()==0))
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_hObject);

	// ȡָεе
	CPoint cpce = rect.CenterPoint();
	CRect  tprc(CPoint(cpce.x-Width()/2,cpce.y-Height()/2), Size());

	// ΪĴ뽫ı豸мãȽ䱣
	int savedc = dc.SaveDC();

	CRgn newrgn;
	newrgn.CreateRectRgnIndirect(&rect);
	// ֻʾָпɼĲ֣AND
	dc.SelectClipRgn(&newrgn, RGN_AND);

	Draw(dc, &tprc);

	dc.RestoreDC(savedc);
	newrgn.CGdiObject::DeleteObject();

	return TRUE;
}



/*************************************************************************
 *
 * DrawTranCenter()
 *
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * CRect* crArea			- ʾΧ꣩
 * COLORREF crColour		- Ҫ˵ɫȱʡֵǰɫ
 * int mode					- 0򽫲ʾָɫ1ָ
 *						      ɫȱʡֵΪ0
 * 
 * ֵ
 *
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ͼ͸ĻĿ豸ָ򣨾Σ룬ͼе
 * еغ
 * 
 * εĳߴСͼߴ磬򳬳εͼ񲿷ֻ᲻ɼ
 * ڲcrAreaNULLFALSE
 * ûͼʲôҲֱӷ
 * 겻Ϲ淶ߵұߵ꣩Զ
 * 淶ĿȻ߶0FALSE
 * 
 ************************************************************************/


BOOL CBmpProc::DrawTranCenter(CDC& dc, 
							  CRect* crArea, 
							  COLORREF crColour, 
							  int mode)
{
	if (!crArea)
		return FALSE;

	// ûͼֱӷ
	if (!IsValid())
		return TRUE;

	CRect rect = *crArea;

	// 淶
	rect.NormalizeRect();

	if ((rect.Width()==0)||(rect.Height()==0))
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_hObject);

	// ȡָεе
	CPoint cpce = rect.CenterPoint();
	CRect  tprc(CPoint(cpce.x-Width()/2,cpce.y-Height()/2), Size());

	// ΪĴ뽫ı豸мãȽ䱣
	int savedc = dc.SaveDC();

	CRgn newrgn;
	newrgn.CreateRectRgnIndirect(&rect);
	// ֻʾָпɼĲ֣AND
	dc.SelectClipRgn(&newrgn, RGN_AND);

	DrawTransparentInRect(dc, crColour, &tprc, NULL, mode);	// ʾ͸ͼ

	dc.RestoreDC(savedc);
	newrgn.CGdiObject::DeleteObject();

	return TRUE;
}



/*************************************************************************
 *
 * DrawTranTile()
 *
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * CRect* crArea			- ʾΧ꣩
 * COLORREF crColour		- Ҫ˵ɫȱʡֵǰɫ
 * int mode					- 0򽫲ʾָɫ1ָ
 *						      ɫȱʡֵΪ0
 * 
 * ֵ
 *
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * еͼƽ̲͸ķʽָ
 * 
 * ڲcrAreaNULL,FALSE겻Ϲ淶
 * ߵұߵ꣩Զ淶Ŀ
 * ߶0FALSE
 * 
 * ûͼʲôҲֱӷ
 * 
 ************************************************************************/


BOOL CBmpProc::DrawTranTile(CDC& dc, 
							CRect* crArea, 
							COLORREF crColour, 
							int mode)
{
	if (!crArea)
		return FALSE;

	// ûͼֱӷ
	if (!IsValid())
		return TRUE;

	CRect rect = *crArea;
	CRect tprc;

	// 淶
	rect.NormalizeRect();

	if ((rect.Width()==0)||(rect.Height()==0))
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_hObject);

	// ΪĴ뽫ı豸мãȽ䱣
	int savedc = dc.SaveDC();

	CRgn newrgn;
	newrgn.CreateRectRgnIndirect(&rect);
	// ֻʾָпɼĲ֣AND
	dc.SelectClipRgn(&newrgn, RGN_AND);

	for (int y=rect.top;y<rect.bottom;y+=Height())
	{
		for (int x=rect.left;x<rect.right;x+=Width())
		{
			// Ƭʽظʾͼ
			tprc.SetRect(x,y,x+Width(),y+Height());
			// ʾ͸ͼ
			DrawTransparentInRect(dc, crColour, &tprc, NULL, mode);
		}
	}

	dc.RestoreDC(savedc);
	newrgn.CGdiObject::DeleteObject();

	return TRUE;
}



/*************************************************************************
 *
 * Clear()
 *
 * ˵
 *
 *
 * ֵ
 *
 *
 * 
 *
 * еͼ
 * 
 * ɾеλͼе
 * 
 * ûͼʲôҲֱӷ
 * 
 ************************************************************************/


void CBmpProc::Clear()
{
	// ûЧBMPֱӷ
	if (m_mark == FALSE)
	{
		ASSERT(m_type == IT_NULL);
		ASSERT(m_pInfo == NULL);
		ASSERT(m_hObject == NULL);
		return;
	}

	switch(m_type)
	{
	case	IT_NULL:
		ASSERT(FALSE);	// ʱm_typeӦIT_NULL
		break;
	case	IT_DISKFILE:
		ASSERT(!m_cFileName.IsEmpty());	// ļԴλͼӦļ
	case	IT_RESOURCE:
	case	IT_MEMORY:
	case	IT_CLIP:
	case	IT_CREATE:
		m_cFileName.Empty();

		ASSERT(m_pInfo);
		::free((void*)m_pInfo);
		m_pInfo = NULL;

		// ȷԭBMPȻɾ
		ASSERT((HBITMAP)m_hObject);
		::DeleteObject(CGdiObject::Detach());
		m_hObject = NULL;

		m_addInfo = 0;
		m_type = IT_NULL;
		m_mark = FALSE;
		break;
	default:
		ASSERT(FALSE);
		break;
	}
}



/*************************************************************************
 *
 * Attach()
 *
 * ˵
 * 
 * HBITMAP hBmp				- ճλͼ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ָλͼ뱾С
 * 
 * ע
 * 
 * # hBmpһЧľNULLFALSE
 * # ԭͼúɹ֮ԭͼ񽫱ɾ
 * # hBmpһڵǰʾɫʽDDBλͼ
 * # ִгɹ󣬵ĳӦʹhBmpΪѱ
 * # ʧܣĳԿʹhBmp
 * 
 ************************************************************************/


BOOL CBmpProc::Attach(HBITMAP hBmp)
{
	ASSERT(hBmp);
	// hBmpNULL
	if (!hBmp)
		return FALSE;

	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC;
	BITMAP	bmp;

	// ȡλͼĿȡ߶ȼɫʽϢ
	if (::GetObject(hBmp, sizeof(BITMAP), (LPVOID)&bmp) != sizeof(BITMAP))
		return FALSE;

	// ʱλͼϢ飨ɫ
	LPBITMAPINFOHEADER lpbi = (LPBITMAPINFOHEADER)CreateMemoryBlockFromAddress(
		(LPVOID)NULL, sizeof(BITMAPINFOHEADER));
	if (!lpbi)
		return FALSE;

	// DIBϢ
	lpbi->biSize = sizeof(BITMAPINFOHEADER);
	lpbi->biWidth = bmp.bmWidth;
	lpbi->biHeight = bmp.bmHeight;
	lpbi->biPlanes = 1;
	// 16ɫϵͳУƽ4λ1DIBǲ
	lpbi->biBitCount = max(bmp.bmPlanes, bmp.bmBitsPixel);
	if ((lpbi->biBitCount==16)||(lpbi->biBitCount==32))
		lpbi->biCompression = BI_BITFIELDS;
	else
		lpbi->biCompression = BI_RGB;

	// 豸ֱ
	hDC = ::GetDC(hWnd);
	lpbi->biXPelsPerMeter = \
		(GetDeviceCaps(hDC,HORZRES)*1000)/GetDeviceCaps(hDC,HORZSIZE);
	lpbi->biYPelsPerMeter = \
		(GetDeviceCaps(hDC,VERTRES)*1000)/GetDeviceCaps(hDC,VERTSIZE);
	::ReleaseDC(hWnd, hDC);

	lpbi->biClrUsed = 0;
	lpbi->biClrImportant = 0;
	lpbi->biSizeImage = CalculateDIBitsSize(lpbi);

	// ɫĳߴ
	WORD wPalSize = PaletteSize(lpbi);

	// ɫϢ飬lpbiϢе
	LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
		(LPVOID)lpbi, sizeof(BITMAPINFOHEADER)+wPalSize);
	if (!pInfo)
	{
		::free((void*)lpbi);
		return FALSE;
	}

	ASSERT(pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// ʱýṹѾãͷ
	::free((void*)lpbi);

	// DIBλݵĻ
	LPSTR pBits = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		pInfo->bmiHeader.biSizeImage);
	if (!pBits)
	{
		::free((void*)pInfo);
		return FALSE;
	}

	// Ĵ벢ҪȡλͼDIBλݣҪȡλͼɫ
	// ɫںGetDIBits()óɹдpInfoṹ
	hDC = ::GetDC(hWnd);
	if (!::GetDIBits(hDC,hBmp,0,pInfo->bmiHeader.biHeight, \
			(LPVOID)pBits,pInfo,DIB_RGB_COLORS))
	{
		::free((void*)pBits);
		::free((void*)pInfo);
		::ReleaseDC(hWnd, hDC);
		return FALSE;
	}
	::ReleaseDC(hWnd, hDC);

	// ʱҪDIBλݣͷ
	::free((void*)pBits);

	// ɾԭͼ񣬲µλͼ
	if (!ClearAndSetData(IT_MEMORY,0,(LPCTSTR)"",pInfo,hBmp))
	{
		::free((void*)pInfo);
		// hBmpָλͼɾ
		return FALSE;
	}

	return TRUE;
}



/*************************************************************************
 *
 * Detach()
 *
 * ˵
 * 
 * 
 * ֵ
 * 
 * HBITMAP					- ɹطλͼ򷵻NULL
 * 
 * 
 *
 * еλͼ
 * 
 * ע
 * 
 * # ԭλͼɹ֮󣬱ཫ
 * # ԭûλͼNULL
 * 
 ************************************************************************/


HBITMAP CBmpProc::Detach()
{
	if (!IsValid())
		return NULL;

	ASSERT(m_pInfo);
	ASSERT(m_hObject);

	HBITMAP hBmp = (HBITMAP)CGdiObject::Detach();
	ASSERT(hBmp);
	if (!hBmp)
		return NULL;

	m_hObject = NULL;

	switch(m_type)
	{
	case	IT_NULL:
		ASSERT(FALSE);	// ʱm_typeӦIT_NULL
		break;
	case	IT_DISKFILE:
		ASSERT(!m_cFileName.IsEmpty());	// ļԴλͼӦļ
	case	IT_RESOURCE:
	case	IT_MEMORY:
	case	IT_CLIP:
	case	IT_CREATE:
		m_cFileName.Empty();

		ASSERT(m_pInfo);
		::free((void*)m_pInfo);
		m_pInfo = NULL;

		m_addInfo = 0;
		m_type = IT_NULL;
		m_mark = FALSE;
		break;
	default:
		ASSERT(FALSE);
		break;
	}

	return hBmp;
}



/*************************************************************************
 *
 * Save()
 *
 * ˵
 * 
 * LPCTSTR lpszNewFileName	- ָļNULL
 * WORD nBitsPerPixel		- ָɫʽÿضλ0
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * еλͼµĸʽµƱ浽ļ
 * 
 * ע
 * 
 * # ûָµļڲlpszNewFileNameָΪNULL
 *   ʹԭļԭûļʧܣFALSE
 * # ûָµλڲnBitsPerPixelָΪ0ʹ
 *   ԭλֵָλֵǷʧܣFALSEϷ
 *   λֵ1,4,8,16,24,32 ֮һ
 * # ԭûλͼࣩFALSE
 * # ļûд򿪻дļʱFALSE
 * # ִгɹ֮󣬱еļλΪֵ
 * # ۺɹ񣬱еλͼı
 * 
 ************************************************************************/


BOOL CBmpProc::Save(LPCTSTR lpszNewFileName, WORD nBitsPerPixel)
{
	// ԭûλͼFALSE
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	LPBITMAPINFO pInfo;
	BOOL bRet;
	CString cOldFN;

	// ԭĸʽ浽ԭļ
	if ((lpszNewFileName==NULL)&&(nBitsPerPixel==0))
	{
		// Ӧļ
		if (m_cFileName.IsEmpty())
			return FALSE;

		return SaveBaseSpecifyFileName((LPCTSTR)m_cFileName);
	}

	// ԭĸʽ浽µļ
	if ((lpszNewFileName!=NULL)&&(nBitsPerPixel==0))
	{
		bRet = SaveBaseSpecifyFileName((LPCTSTR)lpszNewFileName);

		if (bRet)
			m_cFileName = lpszNewFileName;

		return bRet;
	}

	// µĸʽ浽ԭļ
	if ((lpszNewFileName==NULL)&&(nBitsPerPixel!=0))
	{
		// λϷ
		if (!IsValidDibFormat(nBitsPerPixel))
			return FALSE;

		// Ӧļ
		if (m_cFileName.IsEmpty())
			return FALSE;

		bRet = SaveBaseSpecifyFormat(nBitsPerPixel);

		if (bRet)
		{
			pInfo = GetSpecifyFormatInfo(nBitsPerPixel);
			if (!pInfo)
				return FALSE;
			::free((void*)m_pInfo);
			m_pInfo = pInfo;
		}
		return bRet;
	}

	// µĸʽ浽µļ
	if ((lpszNewFileName!=NULL)&&(nBitsPerPixel!=0))
	{
		// λϷ
		if (!IsValidDibFormat(nBitsPerPixel))
			return FALSE;

		cOldFN = m_cFileName;
		m_cFileName = lpszNewFileName;

		bRet = SaveBaseSpecifyFormat(nBitsPerPixel);

		if (bRet)
		{	// ȡָʽϢ
			pInfo = GetSpecifyFormatInfo(nBitsPerPixel);
			if (!pInfo)
			{
				m_cFileName = cOldFN;
				return FALSE;
			}
			::free((void*)m_pInfo);
			m_pInfo = pInfo;
		}
		else
			m_cFileName = cOldFN;

		return bRet;
	}

	return FALSE;
}



/*************************************************************************
 *
 * SaveToClipboard()
 *
 * ˵
 * 
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * 汾еλͼ
 * 
 * ע
 * 
 * # ԭûλͼFALSE
 * # ڴ򿪻дʱFALSE
 * # ۺɹ񣬱еݶı
 * 
 ************************************************************************/


BOOL CBmpProc::SaveToClipboard()
{
	// ԭûλͼFALSE
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// 򿪼
	if (::OpenClipboard(NULL))
	{
		// ռ
		if (::EmptyClipboard())
		{
			DWORD DibSize = CalculateDIBSize((LPBITMAPINFOHEADER)m_pInfo);
			DWORD infosize =CalculateDIBInfoSize((LPBITMAPINFOHEADER)m_pInfo);

			// DIBڲʽڴ
			HANDLE hDib = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, DibSize);
			if (hDib)
			{
				LPSTR lpDib = (LPSTR)::GlobalLock(hDib);
				if (lpDib)
				{
					::memcpy((void*)lpDib, (const void*)m_pInfo, infosize);

					// ȡDIBλ
					HWND hWnd = ::GetDesktopWindow();
					ASSERT(hWnd);
					HDC hDC = ::GetDC(hWnd);
					if (!::GetDIBits(hDC,(HBITMAP)m_hObject,0,m_pInfo->bmiHeader.biHeight,\
							(LPVOID)((DWORD)lpDib+infosize),(LPBITMAPINFO)lpDib,DIB_RGB_COLORS))
					{
						::GlobalUnlock(hDib);
						::GlobalFree(hDib);
						::CloseClipboard();
						::ReleaseDC(hWnd, hDC);
						return FALSE;
					}
					::ReleaseDC(hWnd, hDC);

					::GlobalUnlock(hDib);

					// DIB
					if (::SetClipboardData(CF_DIB, hDib))
					{
						// ɹDIBӦͷ
						::CloseClipboard();
						return TRUE;		// ɹ
					}
					else
					{
						::GlobalFree(hDib);
						::CloseClipboard();
						return FALSE;		// ʧ
					}
				}
				::GlobalFree(hDib);
			}
		}
		::CloseClipboard();
	}

	return FALSE;	// ʧ
}



/*************************************************************************
 *
 * SaveBaseSpecifyFileName()
 *
 * ˵
 * 
 * LPCTSTR fn				- ָļ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * 汾еλͼָļ
 * 
 * ע
 * 
 * # ָļѾڣǸļ
 * # ԭûλͼFALSE
 * # ļûд򿪻дļʱFALSE
 * # ޸ļ
 * 
 ************************************************************************/


BOOL CBmpProc::SaveBaseSpecifyFileName(LPCTSTR fn)
{
	// ԭûλͼFALSE
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);

	// ûָļFALSE
	if (!fn)
		return FALSE;

	FILE *file;

	// ôʽļƣ
	file = ::fopen(fn, "w+b");
	if (!file)
		return FALSE;
	
	::fseek(file, 0, SEEK_SET);

	BITMAPFILEHEADER	bmf;

	bmf.bfType = DIB_HEADER_MARKER;		//((WORD) ('M' << 8) | 'B')
    bmf.bfSize = CalculateDIBFileSize((LPBITMAPINFOHEADER)m_pInfo);
    bmf.bfReserved1 = 0; 
    bmf.bfReserved2 = 0; 
    bmf.bfOffBits   = CalculateDIBitsOff((LPBITMAPINFOHEADER)m_pInfo);

	// дļͷϢ
	if (!::fwrite((const void *)&bmf, sizeof(BITMAPFILEHEADER), 1, file))
	{
		::fclose(file);
		return FALSE;
	}

	// Ϣݣ֮ԸϢֱʹm_pInfoΪ
	// GetDIBits()пܸıϢɫ
	int infosize = CalculateDIBInfoSize((LPBITMAPINFOHEADER)m_pInfo);
	ASSERT(infosize == (int)::_msize((void*)m_pInfo));
	LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
		(LPVOID)m_pInfo);
	if (!pInfo)
	{
		::fclose(file);
		return FALSE;
	}

	// дϢ
	if (!::fwrite((const void *)pInfo, infosize, 1, file))
	{
		::free((void*)pInfo);
		::fclose(file);
		return FALSE;
	}

	LPSTR pBits = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		CalculateDIBitsSize((LPBITMAPINFOHEADER)pInfo));
	if (!pBits)
	{
		::free((void*)pInfo);
		::fclose(file);
		return FALSE;
	}

	// ȡDIBλ
	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC = ::GetDC(hWnd);
	if (!::GetDIBits(hDC,(HBITMAP)m_hObject,0,pInfo->bmiHeader.biHeight,\
			(LPVOID)pBits,pInfo,DIB_RGB_COLORS))
	{
		::free((void*)pInfo);
		::free((void*)pBits);
		::fclose(file);
		::ReleaseDC(hWnd, hDC);
		return FALSE;
	}
	::ReleaseDC(hWnd, hDC);

	// Ϣãͷ
	::free((void*)pInfo);

	DWORD dwA, dwB, dwC;

	LPSTR lp = pBits;

	// ԷֶηʽдλݣÿγΪ32KB
	dwA = CalculateDIBitsSize((LPBITMAPINFOHEADER)m_pInfo);	// ܳ
	dwB = dwA/32768;			// 32768
	dwC = dwA - (dwB*32768);	// 

	for (;dwB!=0;dwB--)
	{
		if (!::fwrite((const void *)lp, 32768, 1, file))
		{
			::free((void*)pBits);
			::fclose(file);
			return FALSE;
		}
		lp = (LPSTR)((DWORD)lp+32768UL);
	}

	// дʣλ
	if (!::fwrite((const void *)lp, dwC, 1, file))
	{
		::free((void*)pBits);
		::fclose(file);
		return FALSE;
	}

	// λãͷ
	::free((void*)pBits);

	// رļ
	::fclose(file);

	return TRUE;
}



/*************************************************************************
 *
 * SaveBaseSpecifyFormat()
 *
 * ˵
 * 
 * WORD nBitsPerPixel		- ָĸʽÿռλ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ָɫʽ汾еλͼԭļ
 * 
 * ע
 * 
 * # ָļѾڣǸļ
 * # ԭûλͼFALSE
 * # ļûд򿪻дļʱFALSE
 * # ָλǷǷֵ1,4,8,16,24,32ǺϷֵFALSE
 * # ޸Ϣ
 * 
 ************************************************************************/


BOOL CBmpProc::SaveBaseSpecifyFormat(WORD nBitsPerPixel)
{
	// ԭûλͼFALSE
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);

	// Ӧļ
	if (m_cFileName.IsEmpty())
		return FALSE;

	// λϷ
	if (!IsValidDibFormat(nBitsPerPixel))
		return FALSE;

	LPBITMAPINFO pTempInfo;
	BOOL bRet;

	// ȡָʽDIBϢ
	LPBITMAPINFO pInfo = GetSpecifyFormatInfo(nBitsPerPixel);
	if (!pInfo)
		return FALSE;

	// ԭʼϢ
	pTempInfo = m_pInfo;

	m_pInfo = pInfo;			   // ԭļ洢
	bRet = SaveBaseSpecifyFileName((LPCTSTR)m_cFileName);
	m_pInfo = pTempInfo;

	::free((void*)pInfo);

	return bRet;
}



/*************************************************************************
 *
 * Create()
 *
 * ˵
 * 
 * int width				- λͼĿ
 * int height				- λͼĸ߶
 * WORD nBitCount			- λͼÿռλ
 * const void *lpBits		- λͼĳʼλݣNULL
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ָݴһλͼ뱾
 * 
 * ע
 * 
 * # ڲwidthheight0ָ0FALSE
 * # ڲnBitCountЧֵ1,4,8,16,24,32ֵΪǷ
 * # ԭͼúɹ֮ԭͼ񽫱ɾ
 * # ڲlpBitsNULL´λʼ
 * 
 ************************************************************************/


BOOL CBmpProc::Create(CSize size, 
					  WORD nBitCount, 
					  const void *lpBits)
{ 
	return Create(size.cx, size.cy, nBitCount, lpBits); 
}

BOOL CBmpProc::Create(int width, 
					  int height, 
					  WORD nBitCount, 
					  const void *lpBits)
{
	// Ⱥ͸߶ֵ
	if ((width==0)||(height==0))
		return FALSE;

	// λϷ
	if (!IsValidDibFormat(nBitCount))
		return FALSE;

	CBitmap		cBmp;
	HBITMAP		hBmp;
	int			iCurDevBitPix, iCurDevPlanes;

	// ȡǰϵͳʾɫʽλƽ
	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC = ::GetDC(hWnd);
	iCurDevBitPix = GetDeviceCaps(hDC,BITSPIXEL);
	iCurDevPlanes = GetDeviceCaps(hDC,PLANES);
	::ReleaseDC(hWnd, hDC);

	// ָߴ粢ݵǰʾɫʽλͼDDB
	if (!cBmp.CreateBitmap(width, height, iCurDevPlanes, iCurDevBitPix, lpBits))
		return FALSE;

	hBmp = (HBITMAP)cBmp.Detach();
	ASSERT(hBmp);
	if (!hBmp)
		return FALSE;

	// ʱλͼϢ飨ɫ
	LPBITMAPINFOHEADER lpbi = (LPBITMAPINFOHEADER)CreateMemoryBlockFromAddress(
		(LPVOID)NULL, sizeof(BITMAPINFOHEADER));
	if (!lpbi)
	{
		::DeleteObject(hBmp);
		return FALSE;
	}

	// DIBϢ
	lpbi->biSize = sizeof(BITMAPINFOHEADER);
	lpbi->biWidth = width;
	lpbi->biHeight = height;
	lpbi->biPlanes = 1;
	lpbi->biBitCount = nBitCount;
	if ((nBitCount==16)||(nBitCount==32))
		lpbi->biCompression = BI_BITFIELDS;
	else
		lpbi->biCompression = BI_RGB;

	// 豸ֱ
	hDC = ::GetDC(hWnd);
	lpbi->biXPelsPerMeter = \
		(GetDeviceCaps(hDC,HORZRES)*1000)/GetDeviceCaps(hDC,HORZSIZE);
	lpbi->biYPelsPerMeter = \
		(GetDeviceCaps(hDC,VERTRES)*1000)/GetDeviceCaps(hDC,VERTSIZE);
	::ReleaseDC(hWnd, hDC);

	lpbi->biClrUsed = 0;
	lpbi->biClrImportant = 0;
	lpbi->biSizeImage = CalculateDIBitsSize(lpbi);

	// ɫĳߴ
	WORD wPalSize = PaletteSize(lpbi);

	// ɫϢ飬lpbiϢе
	LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
		(LPVOID)lpbi, sizeof(BITMAPINFOHEADER)+wPalSize);
	if (!pInfo)
	{
		::free((void*)lpbi);
		::DeleteObject(hBmp);
		return FALSE;
	}

	ASSERT(pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// ʱýṹѾãͷ
	::free((void*)lpbi);

	// DIBλݵĻ
	LPSTR pBits = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		pInfo->bmiHeader.biSizeImage);
	if (!pBits)
	{
		::free((void*)pInfo);
		::DeleteObject(hBmp);
		return FALSE;
	}

	// Ĵ벢ҪȡλͼDIBλݣҪȡλͼɫ
	// ɫںGetDIBits()óɹдpInfoṹ
	hDC = ::GetDC(hWnd);
	if (!::GetDIBits(hDC,hBmp,0,height,(LPVOID)pBits,pInfo,DIB_RGB_COLORS))
	{
		::free((void*)pBits);
		::free((void*)pInfo);
		::ReleaseDC(hWnd, hDC);
		::DeleteObject(hBmp);
		return FALSE;
	}
	::ReleaseDC(hWnd, hDC);

	// ʱҪDIBλݣͷ
	::free((void*)pBits);

	// ɾԭͼ񣬲µλͼ
	if (!ClearAndSetData(IT_CREATE,0,(LPCTSTR)"",pInfo,hBmp))
	{
		::free((void*)pInfo);
		::DeleteObject(hBmp);
		return FALSE;
	}

	return TRUE;
}



/*************************************************************************
 *
 * CreateCompatible()
 *
 * ˵
 * 
 * int width				- λͼĿ
 * int height				- λͼĸ߶
 * CDC *pDC, 				- 豸NULL
 * const void *lpBits		- λͼĳʼλݣNULL
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ָݴһɫʽָλͼ뱾
 * 
 * ע
 * 
 * # ڲwidthheight0ָ0FALSE
 * # ڲpDCNULLʱǰʾɫʽλͼ
 *   pDCNULLָһЧ豸
 * # ԭͼúɹ֮ԭͼ񽫱ɾ
 * # ڲlpBitsNULL´λʼ
 * 
 ************************************************************************/


BOOL CBmpProc::CreateCompatible(int width, 
								int height, 
								CDC *pDC, 
								const void *lpBits)
{
	// Ⱥ͸߶ֵ
	if ((width==0)||(height==0))
		return FALSE;

	int	iCurDevBitPix, iCurDevPlanes;

	// ȡǰϵͳʾɫʽλƽ
	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	if (pDC == NULL)
	{
		// ûָ豸ʹõǰʾɫʽ
		HDC hDC = ::GetDC(hWnd);
		iCurDevBitPix = GetDeviceCaps(hDC,BITSPIXEL);
		iCurDevPlanes = GetDeviceCaps(hDC,PLANES);
		::ReleaseDC(hWnd, hDC);
	}
	else
	{
		iCurDevBitPix = GetDeviceCaps(pDC->GetSafeHdc(),BITSPIXEL);
		iCurDevPlanes = GetDeviceCaps(pDC->GetSafeHdc(),PLANES);
	}

	// 16ɫϵͳУÿصλ1ƽ4ߵ״
	if ((iCurDevPlanes!=1)&&(iCurDevBitPix==1))
	{
		iCurDevBitPix = iCurDevPlanes;
		iCurDevPlanes = 1;
	}

	// λͼDDB
	return Create(width, height, iCurDevBitPix, lpBits);
}



/*************************************************************************
 *
 * CopyFromObject()
 *
 * ˵
 * 
 * CBmpProc& souBmp			- ԴλͼĿ
 * CRect *pDesRect			- Ŀ
 * CRect *pSouRect			- Դ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ԴλͼĿָ򣨾Σͼ񵽱ͼָ
 * 
 * ڲpDesRectΪNULL,ĿεԴͼĳߴ
 * ڲpSouRectΪNULL,ԴĿεԴͼĳߴ
 * ڲpDesRectpSouRectͬúܻѹ
 * 
 * ע# ԭѴλͼҵ֮λͼᱻɾ
 *     # Դλͼǿյģ򷵻FALSE
 *	   # ûλͼFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::CopyFromObject(CBmpProc& souBmp, CRect *pDesRect, CRect *pSouRect)
{
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	if (!souBmp.IsValid())
		return FALSE;

	ASSERT(souBmp.m_pInfo);
	ASSERT(souBmp.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));


	// δָݣʹԴͼľ
	CRect dr;
	CRect sr;

	if (pDesRect == NULL)
		dr = souBmp.Rect();
	else
		dr = *pDesRect;

	if (pSouRect == NULL)
		sr = souBmp.Rect();
	else
		sr = *pSouRect;


	// Դͼ
	CDC			compDC, compDC2;
	CBitmap		*pOldBmp, *pOldBmp2;

	// 뵱ǰʾ豸ݵڴ豸
	compDC.CreateCompatibleDC(NULL);
	compDC2.CreateCompatibleDC(NULL);

	pOldBmp	= compDC.SelectObject((CBitmap*)this);
	pOldBmp2= compDC2.SelectObject((CBitmap*)&souBmp);

	// ĿDCģʽΪCOLORONCOLORҲǲʾͼ
	compDC.SetStretchBltMode(COLORONCOLOR);

	// ָߴԴλͼĿλͼ
	compDC.StretchBlt(dr.left, dr.top, dr.Width(), dr.Height(), 
			&compDC2, sr.left, sr.top, sr.Width(), sr.Height(), SRCCOPY);

	compDC2.SelectObject(pOldBmp2);
	compDC.SelectObject(pOldBmp);

	return TRUE;
}



/*************************************************************************
 *
 * CopyFromHbmp()
 *
 * ˵
 * 
 * HBITMAP souBmp			- Դλͼ
 * CRect *pDesRect			- Ŀ
 * CRect *pSouRect			- Դ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * Դλͼָ򣨾Σͼ񵽱ͼָ
 * 
 * ڲpDesRectΪNULL,ĿεԴͼĳߴ
 * ڲpSouRectΪNULL,ԴĿεԴͼĳߴ
 * ڲpDesRectpSouRectͬúܻѹ
 * 
 * ע# ԭѴλͼҵ֮λͼᱻɾ
 *     # Դλͼǿյģ򷵻FALSE
 *	   # ûλͼFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::CopyFromHbmp(HBITMAP souBmp, 
							CRect *pDesRect, 
							CRect *pSouRect)
{
	// ڲ
	if (!souBmp)
		return FALSE;

	// 鱾Ƿͼ
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	CBmpProc tmp;

	// ʱ
	if (!tmp.Attach(souBmp))
		return FALSE;

	BOOL ret = CopyFromObject(tmp, pDesRect, pSouRect);

	tmp.Detach();

	return ret;
}



/*************************************************************************
 *
 * CopyTran()
 *
 * ˵
 * 
 * CBmpProc& souBmp			- ԴλͼĿ
 * COLORREF crColour		- Ҫ˵ɫȱʡֵǰɫ
 * int x					- ĿϽX꣨ȱʡֵΪ0
 * int y					- ĿϽY꣨ȱʡֵΪ0
 * CRect *pSouRect			- ԴΣȱʡֵΪNULL
 * int mode					- 0򽫲ָɫ1ָ
 *						      ɫȱʡֵΪ0
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ͸ĸԴλͼĿָεͼ񵽱ͼָ
 * 
 * ڲpSouRectΪNULL,ԴĿεԴͼĳߴ硣
 * ѹ
 * ڲpSouRectΪNULLúѹ
 * 
 * ע# ԭѴλͼҵ֮λͼᱻɾ
 *     # Դλͼǿյģ򷵻FALSE
 *	   # вλͼFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::CopyTran(CBmpProc& souBmp, 
						COLORREF crColour, 
						int x, int y, 
						CRect *pSouRect, 
						int mode)
{
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	if (!souBmp.IsValid())
		return FALSE;

	ASSERT(souBmp.m_pInfo);
	ASSERT(souBmp.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	CRect dr(souBmp.Rect());
	dr.OffsetRect(x, y);

	return CopyTran(souBmp, crColour, &dr, pSouRect, mode);
}



/*************************************************************************
 *
 * CopyTran()
 *
 * ˵
 * 
 * CBmpProc& souBmp			- ԴλͼĿ
 * COLORREF crColour		- Ҫ˵ɫȱʡֵǰɫ
 * CRect *pDesRect			- ĿΣȱʡֵΪNULL
 * CRect *pSouRect			- ԴΣȱʡֵΪNULL
 * int mode					- 0򽫲ָɫ1ָ
 *						      ɫȱʡֵΪ0
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ͸ĸԴλͼĿָεͼ񵽱ͼָ
 * 
 * ڲpDesRectΪNULL,ĿεԴͼĳߴ硣
 * ڲpSouRectΪNULL,ԴĿεԴͼĳߴ硣
 * pDesRectpSouRectͬúѹ
 * 
 * ע# ԭѴλͼҵ֮λͼᱻɾ
 *     # Դλͼǿյģ򷵻FALSE
 *	   # вλͼFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::CopyTran(CBmpProc& souBmp, 
						COLORREF crColour, 
						CRect *pDesRect, 
						CRect *pSouRect, 
						int mode)
{
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	if (!souBmp.IsValid())
		return FALSE;

	ASSERT(souBmp.m_pInfo);
	ASSERT(souBmp.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));


	// δָݣʹԴͼľ
	CRect dr;
	CRect sr;

	if (pDesRect == NULL)
		dr = souBmp.Rect();
	else
		dr = *pDesRect;

	if (pSouRect == NULL)
		sr = souBmp.Rect();
	else
		sr = *pSouRect;

	// Դͼ
	CDC			compDC;
	CBitmap		*pOldBmp;

	// 뵱ǰʾ豸ݵڴ豸
	compDC.CreateCompatibleDC(NULL);
	pOldBmp	= compDC.SelectObject((CBitmap*)this);

	// ָߴԴλͼĿλͼ
	souBmp.DrawTransparentInRect(compDC, crColour, pDesRect, pSouRect, mode);

	compDC.SelectObject(pOldBmp);

	return TRUE;
}



/*************************************************************************
 *
 * CopyTranCenter()
 *
 * ˵
 * 
 * CBmpProc& souBmp			- ԴλͼĿ
 * CRect* crArea 			- еķΧȱʡֵΪNULL
 * COLORREF crColour		- Ҫ˵ɫȱʡֵǰɫ
 * int mode					- 0򽫲ָɫ1ָ
 *						      ɫȱʡֵΪ0
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * Դλͼ͸ĸƵָε
 * 
 * ڲcrAreaΪNULL,оεڱͼĳߴ硣
 * úѹ
 * 
 * ע# ԭѴλͼҵ֮λͼᱻɾ
 *     # Դλͼǿյģ򷵻FALSE
 *	   # вλͼFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::CopyTranCenter(CBmpProc& souBmp, 
							  CRect* crArea, 
							  COLORREF crColour, 
							  int mode)
{
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	if (!souBmp.IsValid())
		return FALSE;

	ASSERT(souBmp.m_pInfo);
	ASSERT(souBmp.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	CRect rect(Rect());

	if (crArea)
		rect = *crArea;

	// 淶
	rect.NormalizeRect();

	if ((rect.Width()==0)||(rect.Height()==0))
		return FALSE;

	// Դͼ
	CDC			compDC;
	CBitmap		*pOldBmp;

	// 뵱ǰʾ豸ݵڴ豸
	compDC.CreateCompatibleDC(NULL);
	pOldBmp	= compDC.SelectObject((CBitmap*)this);

	// ָߴԴλͼĿλͼ
	souBmp.DrawTranCenter(compDC, &rect, crColour, mode);

	compDC.SelectObject(pOldBmp);

	return TRUE;
}



/*************************************************************************
 *
 * CopyTranTile()
 *
 * ˵
 * 
 * CBmpProc& souBmp			- ԴλͼĿ
 * CRect* crArea 			- ƽ̵ķΧȱʡֵΪNULL
 * COLORREF crColour		- Ҫ˵ɫȱʡֵǰɫ
 * int mode					- 0򽫲ָɫ1ָ
 *						      ɫȱʡֵΪ0
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * Դλͼ͸ƽ̵ָ
 * 
 * ڲcrAreaΪNULL,ƽ̾εڱͼĳߴ硣
 * úѹԴλͼͼ
 * 
 * ע# ԭѴλͼҵ֮λͼᱻɾ
 *     # Դλͼǿյģ򷵻FALSE
 *	   # вλͼFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::CopyTranTile(CBmpProc& souBmp, 
							CRect* crArea, 
							COLORREF crColour, 
							int mode)
{
	// л
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	if (!souBmp.IsValid())
		return FALSE;

	ASSERT(souBmp.m_pInfo);
	ASSERT(souBmp.m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// ȱʡ跶ΧǱλͼĳߴ
	CRect rect(Rect());

	if (crArea)
		rect = *crArea;	// ָߴ

	// 淶
	rect.NormalizeRect();

	if ((rect.Width()==0)||(rect.Height()==0))
		return FALSE;

	// Դͼ
	CDC			compDC;
	CBitmap		*pOldBmp;

	// 뵱ǰʾ豸ݵڴ豸
	compDC.CreateCompatibleDC(NULL);
	pOldBmp	= compDC.SelectObject((CBitmap*)this);

	// ָߴԴλͼĿλͼ
	souBmp.DrawTranTile(compDC, &rect, crColour, mode);

	compDC.SelectObject(pOldBmp);
	
	return TRUE;
}



/*************************************************************************
 *
 * LoadFromClipboard()
 *
 * ˵
 * 
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ȡеDIBλͼ
 * 
 * ɹԭλͼеĻɾ
 * 
 ************************************************************************/


BOOL CBmpProc::LoadFromClipboard()
{
	// Ч
	if (!PasteAvailable())
		return FALSE;

	// 򿪼
	if (::OpenClipboard(NULL))
	{
		// ȡеDIB
		HANDLE h = ::GetClipboardData(CF_DIB);

		if (!h)
		{
			CloseClipboard();
			return FALSE;
		}

		LPSTR lpDIB = (LPSTR)CreateMemoryBlockFromHandle(h);
		if (!lpDIB)
		{	// ļݾҪͷţϵͳԶͷ
			CloseClipboard();
			return FALSE;
		}

		CloseClipboard();

		// DIBϢЧ
		if (*((DWORD*)lpDIB) != sizeof(BITMAPINFOHEADER))
		{
			::free((void*)lpDIB);
			return FALSE;
		}

		// Ϣ
		ASSERT(CalculateDIBInfoSize((LPBITMAPINFOHEADER)lpDIB) >= sizeof(BITMAPINFOHEADER));
		LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
			(LPVOID)lpDIB, CalculateDIBInfoSize((LPBITMAPINFOHEADER)lpDIB));
		if (!pInfo)
		{
			::free((void*)lpDIB);
			return FALSE;
		}

		// λ׵ַ
		LPSTR pBits = (LPSTR)FindDIBBits(lpDIB);
		ASSERT(pBits);

		// DDBλͼ
		HBITMAP hBmp;
		HWND hWnd = ::GetDesktopWindow();
		ASSERT(hWnd);
		HDC hDC = ::GetDC(hWnd);

		hBmp = ::CreateDIBitmap(hDC,		// DDBλͼDIBλ
			(BITMAPINFOHEADER *)pInfo,		// תΪDDBλݣ
			CBM_INIT, pBits, 
			(BITMAPINFO *)pInfo, 
			DIB_RGB_COLORS);

		::ReleaseDC(hWnd, hDC);

		// ߼λͼ󣬴Ӽжȡãͷ
		::free((void*)lpDIB);

		if (hBmp)	// ɹ
		{
			// ɾԭͼ񣬲µλͼ
			if (!ClearAndSetData(IT_CLIP,0,(LPCTSTR)"",pInfo,hBmp))
			{
				::free((void*)pInfo);
				::DeleteObject(hBmp);
				return FALSE;
			}
			return TRUE;
		}
		else	// ʧ
		{
			::free((void*)pInfo);
			return FALSE;
		}
	}

  return FALSE;
}



/*************************************************************************
 *
 * LoadFromFile()
 *
 * ˵
 * 
 * LPCTSTR lpszPathName		- λͼļƣ·
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ȡָλͼļ
 * 
 * ɹԭλͼеĻɾ
 * ڲָļڻһλͼļFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::LoadFromFile(LPCTSTR lpszPathName)
{
	CFile file;
	LPBITMAPINFO lpbi;
	LPSTR pBits;
	HBITMAP hBmp;

	if (!file.Open(lpszPathName, CFile::modeRead | CFile::shareDenyWrite))
		return FALSE;

	// жļǷЧBMPļ
	if (IsValidBmpFile(file) == FALSE)
	{
		file.Close();
		return FALSE;
	}

	// ȡBMPļϢ
	if ((lpbi=GetBmpFileInfo(file)) == NULL)
	{
		file.Close();
		return FALSE;
	}

	// ಻֧ѹλͼѹλͼ򷵻FALSE
	if ((lpbi->bmiHeader.biCompression==BI_RLE4)||(lpbi->bmiHeader.biCompression==BI_RLE8))
	{
		::free((void*)lpbi);
		file.Close();
		return FALSE;
	}

	// ȡBMPλ
	if ((pBits=GetBmpFileBits(file)) == NULL)
	{
		::free((void*)lpbi);
		file.Close();
		return FALSE;
	}


	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC = ::GetDC(hWnd);

	hBmp = ::CreateDIBitmap(hDC,		// DDBλͼDIBλ
		(BITMAPINFOHEADER *)lpbi,		// תΪDDBλݣ
		CBM_INIT, pBits, 
		(BITMAPINFO *)lpbi, 
		DIB_RGB_COLORS);

	::ReleaseDC(hWnd, hDC);

	// ߼λͼ󣬴ļжȡλãͷ
	::free((void*)pBits);

	file.Close();

	if (hBmp)	// ɹ
	{
		// ɾԭͼ񣬲µλͼ
		if (!ClearAndSetData(IT_DISKFILE,0,lpszPathName,lpbi,hBmp))
		{
			::free((void*)lpbi);
			::DeleteObject(hBmp);
			return FALSE;
		}
		return TRUE;
	}
	else	// ʧ
	{
		::free((void*)lpbi);
		return FALSE;
	}
}



/*************************************************************************
 *
 * LoadFromResourceID()
 *
 * ˵
 * 
 * UINT uID					- λͼԴƣʶֵ
 * HINSTANCE hInstance		- λͼԴʵľΪNULL
 *							  ֵΪǰӦọ́
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ȡָλͼԴ
 * 
 * ɹԭλͼеĻɾ
 * 
 ************************************************************************/


BOOL CBmpProc::LoadFromResourceID(UINT uID, HINSTANCE hInst) 
{ 
	return LoadFromResourceName((LPCTSTR)MAKEINTRESOURCE(uID), hInst); 
}



/*************************************************************************
 *
 * LoadFromResourceName()
 *
 * ˵
 * 
 * LPCTSTR lpResourceName	- λͼԴƣַ
 * HINSTANCE hInstance		- λͼԴʵľΪNULL
 *							  ֵΪǰӦọ́
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ȡָλͼԴ
 * 
 * ɹԭλͼеĻɾ
 * 
 ************************************************************************/


BOOL CBmpProc::LoadFromResourceName(LPCTSTR lpResourceName, 
									HINSTANCE hInstance)
{
	HINSTANCE	hInst = hInstance;
	HBITMAP hBmp = NULL;

	//ڲhInstanceNULLõǰӦó̵ʵ
	if (hInst == NULL)
		hInst = ::AfxGetResourceHandle();

	ASSERT(hInst);

	HRSRC hSrc = ::FindResource(hInst, lpResourceName, RT_BITMAP);
	BOOL bSuccess = FALSE;

	if (!hSrc)
		return bSuccess;

	// LoadResource()ԴĿ겻ҪʾɾWindows
	// ϵͳԶɾLockResource()ԴĿҲҪʾĽ
	HGLOBAL hResData = LoadResource(hInst, hSrc);
	if (hResData)
	{
		LPVOID lpResData = LockResource(hResData);
		if (lpResData)
		{
			// ЧDIBԴԴλӦBITMAPINFOHEADER
			// ṹ
			ASSERT(*((DWORD*)lpResData) == sizeof(BITMAPINFOHEADER));

			LPSTR pBits = FindDIBBits((LPSTR)lpResData);
			ASSERT(pBits > (LPSTR)lpResData);

			HWND hWnd = ::GetDesktopWindow();
			ASSERT(hWnd);
			HDC hDC = ::GetDC(hWnd);

			hBmp = CreateDIBitmap(hDC,			// DDBλͼDIBλ
				(BITMAPINFOHEADER *)lpResData,	// תΪDDBλݣ
				CBM_INIT, pBits, 
				(BITMAPINFO *)lpResData, 
				DIB_RGB_COLORS);

			::ReleaseDC(hWnd, hDC);

			if (hBmp)	// ɹ
			{
				DWORD dwInfoSize = (DWORD)((LPSTR)pBits-(LPSTR)lpResData);
				ASSERT(dwInfoSize > (DWORD)(sizeof(BITMAPFILEHEADER)));

				LPBITMAPINFO lpbi = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
					(LPVOID)NULL, dwInfoSize);
				if (lpbi)
				{
					// λͼϢ飬ΪlpResDataָڴ治ʱ̬
					// ڴ飬δCreateMemoryBlockFromAddress()
					// ĸƹ
					::memcpy((void*)lpbi, (const void*)lpResData, dwInfoSize);
				}
				else
				{
					::DeleteObject(hBmp);
					return FALSE;
				}

				if ((((DWORD)lpResourceName)>>16) == 0)
				{// ָԴʱʹõǱʶָĸ16λ0
					// ɾԭͼ񣬲µλͼ
					if (!ClearAndSetData(IT_RESOURCE,(DWORD)lpResourceName,(LPCTSTR)"",lpbi,hBmp))
					{
						::free((void*)lpbi);
						::DeleteObject(hBmp);
						return FALSE;
					}
				}
				else
				{
					// ɾԭͼ񣬲µλͼ
					if (!ClearAndSetData(IT_RESOURCE,0, lpResourceName,lpbi,hBmp))
					{
						::free((void*)lpbi);
						::DeleteObject(hBmp);
						return FALSE;
					}
				}
				bSuccess = TRUE;
			}
		}
	}

	return bSuccess;
}



/*************************************************************************
 *
 * LoadFromObject()
 *
 * ˵
 * 
 * CBmpProc& souBmp			- ԴλͼĿ
 * CRect *pSouRect			- ƾ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ȡԴλͼĿָ򣨾Σͼ
 * 
 * ڲpSouRectΪNULL,ԴĿλͼ
 * ڲpSouRectһľݣϽС½
 * ꣩
 * 
 * ɹԭλͼеĻɾ
 * 
 ************************************************************************/


BOOL CBmpProc::LoadFromObject(CBmpProc& souBmp, CRect *pSouRect)
{
	CRect souRect;

	// һ£Դͼ
	ASSERT(souBmp.IsValid());	
	if (souBmp.IsValid() == FALSE)
		return FALSE;

	// ȷҪԴλͼЩ
	if (pSouRect == NULL)
		souRect = souBmp.Rect();	// ȱʡΪ
	else
	{
		CRect sou = souBmp.Rect();
		souRect = *pSouRect;
		// ָľгԴͼĵطõ
		if (!sou.PtInRect((POINT)CPoint(souRect.left, souRect.top)))
			souRect.OffsetRect(-souRect.left, -souRect.top);

		if (!sou.PtInRect((POINT)CPoint(souRect.right, souRect.bottom)))
		{
			if (souRect.right > sou.right)
				souRect.right = sou.right;
			if (souRect.bottom > sou.bottom)
				souRect.bottom = sou.bottom;
		}
	}

	ASSERT(souBmp.m_pInfo);
	LPBITMAPINFO lpSouInfo = souBmp.m_pInfo;

	// ԴͼϢ
	LPBITMAPINFO pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress(
		(LPVOID)lpSouInfo);
	if (!pInfo)
		return FALSE;

	// ȷԴͼϢЧ
	ASSERT(pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// ޸Ϣе
	pInfo->bmiHeader.biWidth = souRect.Width();
	pInfo->bmiHeader.biHeight = souRect.Height();
	pInfo->bmiHeader.biSizeImage = CalculateDIBitsSize((LPBITMAPINFOHEADER)pInfo);

	CBitmap		tempBmp;
	HBITMAP		hBmp;

	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC = ::GetDC(hWnd);
	CDC dc;
	dc.Attach(hDC);

	if (tempBmp.CreateCompatibleBitmap(&dc, souRect.Width(), souRect.Height()))
	{
		CDC			compDC, compDC2;
		CBitmap		*pOldBmp, *pOldBmp2;

		// 뵱ǰʾ豸ݵڴ豸
		compDC.CreateCompatibleDC(NULL);
		compDC2.CreateCompatibleDC(NULL);

		pOldBmp	= compDC.SelectObject((CBitmap*)&tempBmp);
		pOldBmp2= compDC2.SelectObject((CBitmap*)&souBmp);

		// ָߴԴλͼĿλͼ
		compDC.BitBlt(0, 0, souRect.Width(), souRect.Height(), 
					&compDC2, souRect.left, souRect.top, SRCCOPY);

		compDC2.SelectObject(pOldBmp2);
		compDC.SelectObject(pOldBmp);

		::ReleaseDC(hWnd, dc.Detach());

		hBmp = (HBITMAP)tempBmp.Detach();
		// ʧܣFALSE
		ASSERT(hBmp);
		if (!hBmp)
		{
			::free((void*)pInfo);
			return FALSE;
		}

		// ɾԭͼ񣬲µλͼ
		if (!ClearAndSetData(IT_MEMORY,0,(LPCTSTR)"",pInfo,hBmp))
		{
			::free((void*)pInfo);
			::DeleteObject(hBmp);
			return FALSE;
		}
		return TRUE;
	}
	else
	{
		::ReleaseDC(hWnd, dc.Detach());
		::free((void*)pInfo);

		return FALSE;
	}
}



/*************************************************************************
 *
 * LoadFromHbmp()
 *
 * ˵
 * 
 * HBITMAP sou				- ԴλͼΪNULL
 * CRect *pSouRect			- ƾ
 * 
 * ֵ
 * 
 * BOOL						- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ȡԴλͼָεͼ
 * 
 * ڲpSouRectΪNULL,ԴĿλͼ
 * ڲpSouRectһľݣϽС½
 * ꣩
 * ڲָλͼ۳ɹ񶼲Ӱ
 * 
 * ɹԭλͼеĻɾ
 * 
 ************************************************************************/


BOOL CBmpProc::LoadFromHbmp(HBITMAP sou, CRect *pSouRect)
{
	// ڲ
	if (!sou)
		return FALSE;

	CBmpProc tmp;

	// ʱ
	if (!tmp.Attach(sou))
		return FALSE;

	BOOL ret = LoadFromObject(tmp, pSouRect);

	tmp.Detach();

	return ret;
}



/*************************************************************************
 *
 * CalculateDIBFileSize()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * DWORD					- DIBļĳߴ
 *
 * 
 *
 * ָϢʽDIBλͼĳߴ磨ֽΪλ
 *
 ************************************************************************/


DWORD CBmpProc::CalculateDIBFileSize(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));

	DWORD filesize;
	DWORD dwScanWidth = DIBSCANLINE_WIDTHBYTES(DIBWidth(lpbi)*GetBitsPerPixel(lpbi));
	DWORD dwPaletteSize = (DWORD)PaletteSize(lpbi);

	// ļͷߴ磫Ϣͷߴ磫ɫߴ磫λݳߴ
	filesize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 
		dwPaletteSize + dwScanWidth*DIBHeight(lpbi);

	return filesize;
}



/*************************************************************************
 *
 * CalculateDIBSize()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * DWORD					- DIBڲʽĳߴ
 *
 * 
 *
 * ָϢʽDIBڲʽĳߴ磨ֽΪλ
 *
 * ڲʽָȥļͷṹDIBļڴеʵ
 *
 ************************************************************************/


DWORD CBmpProc::CalculateDIBSize(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));

	DWORD dwScanWidth = DIBSCANLINE_WIDTHBYTES(DIBWidth(lpbi)*GetBitsPerPixel(lpbi));
	DWORD dwPaletteSize = (DWORD)PaletteSize(lpbi);

	// Ϣͷߴ磫ɫߴ磫λݳߴ
	return sizeof(BITMAPINFOHEADER)+dwPaletteSize+dwScanWidth*DIBHeight(lpbi);
}



/*************************************************************************
 *
 * CalculateDIBitsOff()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * DWORD					- DIBļλƫ
 *
 * 
 *
 * ָϢʽDIBλͼλƫƣֽΪλ
 *
 ************************************************************************/


DWORD CBmpProc::CalculateDIBitsOff(LPBITMAPINFOHEADER lpbi) const
{
	DWORD bitsoff;

	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));

	DWORD dwPaletteSize = (DWORD)PaletteSize(lpbi);

	// ļͷߴ磫Ϣͷߴ磫ɫߴ
	bitsoff = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + \
		dwPaletteSize;

	return bitsoff;
}



/*************************************************************************
 *
 * CalculateDIBInfoSize()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * DWORD					- DIBļϢĳ
 *
 * 
 *
 * ָϢʽDIBλͼϢĳȣֽΪλ
 *
 * ϢָBITMAPINFOṹע⣬кɫ!
 *
 ************************************************************************/


DWORD CBmpProc::CalculateDIBInfoSize(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));
	// Ϣͷߴ磫ɫߴ
	return sizeof(BITMAPINFOHEADER)+(DWORD)PaletteSize(lpbi);
}



/*************************************************************************
 *
 * CalculateDIBitsSize()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * DWORD					- DIBļλĳߴ
 *
 * 
 *
 * ָϢʽDIBλͼλģֽΪλ
 *
 ************************************************************************/


DWORD CBmpProc::CalculateDIBitsSize(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));

	DWORD s = DIBSCANLINE_WIDTHBYTES(DIBWidth(lpbi)*GetBitsPerPixel(lpbi));

	return s*DIBHeight(lpbi);
}



/*************************************************************************
 *
 * IsValidBmpFile()
 *
 * ˵
 *
 * CFile& file      - жϵļļѱ򿪣
 *
 * ֵ
 *
 * BOOL             - TRUEļЧBMPļ򷵻FALSE
 *
 * 
 *
 * жָļǷһЧBMPļ
 *
 * ע֧OS/2ϵͳBMPļļFALSE
 *
 ************************************************************************/


BOOL CBmpProc::IsValidBmpFile(CFile& file)
{
	BITMAPFILEHEADER bmfHeader;
	BITMAPINFOHEADER bmiHeader;
	DWORD dwSize, dwCurPos;
	UINT uRet, uRet2;

	/* ȡDIBļĳȣֽΪλ*/
	dwSize = file.GetLength();
	if (dwSize < (sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)))
		return FALSE;

	/* ȡDIBļͷṹЧ */
	dwCurPos = file.GetPosition();
	file.SeekToBegin();
	uRet  = file.Read((LPSTR)&bmfHeader, sizeof(BITMAPFILEHEADER));
	uRet2 = file.Read((LPSTR)&bmiHeader, sizeof(BITMAPINFOHEADER));
	file.Seek(dwCurPos, CFile::begin);

	if (uRet != sizeof(BITMAPFILEHEADER))
		return FALSE;
	if (bmfHeader.bfType != DIB_HEADER_MARKER) //((WORD) ('M' << 8) | 'B')
		return FALSE;

	if (uRet2 != sizeof(BITMAPINFOHEADER))
		return FALSE;
	// ֧OS/2ʽλͼ
	if (bmiHeader.biSize != sizeof(BITMAPINFOHEADER))
		return FALSE;

	int size = PaletteSize(&bmiHeader);

	if (bmfHeader.bfOffBits != \
		(sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+size))
		return FALSE;

	return TRUE;	// TRUEļЧBMPļ
}



/*************************************************************************
 *
 * GetBmpFileInfo()
 *
 * ˵
 *
 * CFile& file      - ȡϢλͼļļѱ򿪣
 *
 * ֵ
 *
 * LPBITMAPINFO		- λͼϢַʧܷNULL
 *
 * 
 *
 * ȡλͼļͼϢϢṹĵַ
 *
 * עλͼϢһڴ档ñǰӦλͼļЧ
 *
 ************************************************************************/


LPBITMAPINFO CBmpProc::GetBmpFileInfo(CFile& file)
{
	LPBITMAPINFO pDIB;
	BITMAPFILEHEADER bmfHeader;
	DWORD dwCurPos;
	UINT uRet, uDibInfoSize;

	/* ȡDIBļͷṹ */
	dwCurPos = file.GetPosition();
	file.SeekToBegin();
	uRet  = file.Read((LPSTR)&bmfHeader, sizeof(BITMAPFILEHEADER));
	file.Seek(dwCurPos, CFile::begin);

	if (uRet != sizeof(BITMAPFILEHEADER))
		return NULL;

	uDibInfoSize = bmfHeader.bfOffBits-sizeof(BITMAPFILEHEADER);

	// ڴ棬ڴϢͷɫУ
	pDIB = (LPBITMAPINFO)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		(DWORD)uDibInfoSize);
	if (!pDIB)
		return NULL;

	// ȡ
	dwCurPos = file.GetPosition();
	file.Seek((LONG)sizeof(BITMAPFILEHEADER), CFile::begin);
	uRet = file.Read((void *)pDIB, uDibInfoSize);
	file.Seek(dwCurPos, CFile::begin);

	if (uRet != uDibInfoSize)
	{
		::free((void*)pDIB);
		return NULL;
	}

	return pDIB;
}



/*************************************************************************
 *
 * GetBmpFileBits()
 *
 * ˵
 *
 * CFile& file      - ȡλݵλͼļļѱ򿪣
 *
 * ֵ
 *
 * LPSTR			- λͼλϢڴַʧܷNULL
 *
 * 
 *
 * ȡλͼļλݣĵַ
 *
 * עñǰӦļЧ
 *
 ************************************************************************/


LPSTR CBmpProc::GetBmpFileBits(CFile& file)
{
	BITMAPFILEHEADER bmfHeader;
	LPSTR pBits;
	DWORD dwSize, dwRet, dwCurPos;
	UINT uRet;

	/* ȡDIBļͷṹ */
	dwCurPos = file.GetPosition();
	file.SeekToBegin();
	uRet  = file.Read((LPSTR)&bmfHeader, sizeof(BITMAPFILEHEADER));
	file.Seek(dwCurPos, CFile::begin);

	if (uRet != sizeof(BITMAPFILEHEADER))
		return NULL;

	// ȡļ
	dwSize = file.GetLength();

	// ڴ棬ڴλ
	pBits = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		(DWORD)(dwSize-bmfHeader.bfOffBits));
	if (!pBits)
		return NULL;

	// ȡλ
	dwCurPos = file.GetPosition();
	file.Seek(bmfHeader.bfOffBits, CFile::begin);
	dwRet = file.ReadHuge((void*)pBits, (dwSize-bmfHeader.bfOffBits));
	file.Seek(dwCurPos, CFile::begin);

	if (dwRet != (dwSize-bmfHeader.bfOffBits))
	{
		::free(pBits);
		return NULL;
	}

	return pBits;
}



/*************************************************************************
 *
 * GetSpecifyFormatInfo()
 *
 * ˵
 *
 * WORD newBitCount			- ָĸʽÿռλָ0
 *
 * ֵ
 *
 * LPBITMAPINFO				- ɹµϢַʧܷNULL
 *
 * 
 *
 * еϢָ¸ʽһµϢ
 *
 * עλͼϢһڴ档
 *     ҪڴʱӦͷţfree()
 *     úӰе
 *     ԭûλͼNULL
 *     ڲָ0ֵѴڵϢһ
 *
 ************************************************************************/


LPBITMAPINFO CBmpProc::GetSpecifyFormatInfo(WORD newBitCount)
{
	// ԭûλͼNULL
	if (!IsValid())
		return NULL;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	int infosize;
	HWND hWnd = ::GetDesktopWindow();
	ASSERT(hWnd);
	HDC hDC;
	BITMAPINFOHEADER bmi;
	LPBITMAPINFO pInfo;
	LPSTR pBits;

	// ûָµĸʽµλָ0Ϣĸ
	if (newBitCount == 0)
	{
		pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress((LPVOID)m_pInfo);
		return pInfo;
	}

	// λϷ
	if (!IsValidDibFormat(newBitCount))
		return NULL;

	::memcpy((void*)&bmi, (const void*)m_pInfo, sizeof(BITMAPINFOHEADER));
	ASSERT(bmi.biSize == sizeof(BITMAPINFOHEADER));

	bmi.biBitCount = newBitCount;

	if ((bmi.biBitCount==16)||(bmi.biBitCount==32))
		bmi.biCompression = BI_BITFIELDS;
	else
		bmi.biCompression = BI_RGB;

	bmi.biSizeImage = CalculateDIBitsSize(&bmi);

	infosize = CalculateDIBInfoSize(&bmi);
	pInfo = (LPBITMAPINFO)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		(DWORD)infosize);
	if (!pInfo)
		return NULL;

	::memcpy((void*)pInfo, (const void*)&bmi, sizeof(BITMAPINFOHEADER));
	ASSERT(pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	pBits = (LPSTR)CreateMemoryBlockFromAddress((LPVOID)NULL, 
		CalculateDIBitsSize((LPBITMAPINFOHEADER)pInfo));
	if (!pBits)
	{
		::free((void*)pInfo);
		return NULL;
	}

	// ȡDIBɫ
	hDC = ::GetDC(hWnd);
	if (!::GetDIBits(hDC,(HBITMAP)m_hObject,0,pInfo->bmiHeader.biHeight,\
			(LPVOID)pBits,pInfo,DIB_RGB_COLORS))
	{
		::free((void*)pInfo);
		::free((void*)pBits);
		::ReleaseDC(hWnd, hDC);
		return NULL;
	}
	::ReleaseDC(hWnd, hDC);

	// λãͷ
	::free((void*)pBits);

	return pInfo;
}



/****************************** DIB Function ****************************/

/*
 DIB עͣ

  # ֧OS/2ϵͳDIBλͼ
  # ֧ѹλͼRLEѹ룩
  # FindDIBBits()ڲlpbiָϢͷɫλݵڴ
  # ڲlpbiָϢ飬BITMAPINFOHEADERṹ
  # ڲlpbiеݱЧ!

*/

/*************************************************************************
 *
 * FindDIBBits()
 *
 * ˵
 *
 * LPSTR lpbi       - ָڴDIB׵ַ
 *
 * ֵ
 *
 * LPSTR            - ָDIBλݵĵַ
 *
 * 
 *
 * DIBλݵַء
 *
 ************************************************************************/


LPSTR CBmpProc::FindDIBBits(LPSTR lpbi) const
{
	ASSERT(lpbi);
	ASSERT(((LPBITMAPINFOHEADER)lpbi)->biSize == sizeof(BITMAPINFOHEADER));
	return (lpbi + *(LPDWORD)lpbi + PaletteSize((LPBITMAPINFOHEADER)lpbi));
}



/*************************************************************************
 *
 * DIBWidth()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADER ṹ
 *
 * ֵ
 *
 * DWORD				- DIBĿ
 *
 * 
 *
 * ȡDIBĿȡأ
 *
 * BITMAPINFOHEADERṹbiWidthԱȡֵ
 *
 ************************************************************************/


DWORD CBmpProc::DIBWidth(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));
	return 	lpbi->biWidth;
}



/*************************************************************************
 *
 * DIBHeight()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * DWORD					- DIBĸ߶
 *
 * 
 *
 * ȡDIBĸ߶ȡأ
 *
 * BITMAPINFOHEADERṹbiHeightԱȡ߶ֵ
 *
 ************************************************************************/


DWORD CBmpProc::DIBHeight(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));
	return 	lpbi->biHeight;
}



/*************************************************************************
 *
 * PaletteSize()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * WORD						- DIBɫĳߴ磨ֽΪλ
 *
 * 
 *
 * ȡָDIBĵɫߴ磨ֽΪλ
 *
 * ȻȡDIBɫȻɫֵRGBQUADĽṹߴ硣
 *
 ************************************************************************/


WORD CBmpProc::PaletteSize(LPBITMAPINFOHEADER lpbi) const
{
	WORD size, wBitCount;

	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));
	// ÿռλ
	wBitCount = GetBitsPerPixel(lpbi);
				
	// 16λ32λλͼɫռDWORDֵʾ
	// 졢̡λе
	if ((wBitCount == 16)||(wBitCount == 32))
	{
		ASSERT(lpbi->biCompression == BI_BITFIELDS);
		size = sizeof(DWORD)*3;
	}
	else
	{
		// ֧ѹλͼ
		ASSERT(lpbi->biCompression == BI_RGB);
		size = (WORD)(DIBNumColors(lpbi) * sizeof(RGBQUAD));
	}

	return size;
}



/*************************************************************************
 *
 * DIBNumColors()
 *
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * WORD						- ɫɫĸ
 *
 * 
 *
 * ȡDIBɫеɫ
 * 
 * ͨDIBÿռλɫɫĸ
 * һռһλɫռλ16ɫռ8λ
 * 256ɫռ16λɫоûɫˡ
 *
 * ע⣺16λ32λλͼɫǿյģDWORD͵ֵ
 * Աʾ졢̡λе룬24λλͼɫǿյģɫ
 * ĳߴΪ0Ϊɫ16λ32λλͼ
 * Խ0λͼϢbiClrUsedԱ0ʹֵ
 * ȥ㣩
 ************************************************************************/

WORD CBmpProc::DIBNumColors(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));
	WORD wBitCount = GetBitsPerPixel(lpbi);  // DIBλ

	// λͼָɫɫĸֱʹֵ
	if (lpbi->biClrUsed)
		return (WORD)(lpbi->biClrUsed);

	/*  ͨDIBÿռλɫɫĸ */
	switch (wBitCount)
	{
		case 1:
			return 2;		// ɫλͼֻкڰɫ
		case 4:
			return 16;		// ׼VGAλͼ16ɫ
		case 8:
			return 256;		// SVGAλͼ256ɫ
		case	16:			// 64Kɫλͼ
		case	24:			// 16Mɫλͼɫ
		case	32:			// 16M+ɫλͼɫ
			return 0;		// ɫûɫݷ0
		default:
			ASSERT(FALSE);
			return 0;
	}
}



/*************************************************************************
 *
 * CreateMemoryBlockFromAddress()
 *
 * ˵
 *
 * LPVOID pSou		- ƵڴַNULLμעͣ
 * DWORD dwCount	- ƷΧֽڵĸ0μעͣ
 *
 * ֵ
 *
 * LPVOID           - µڴַʧܣNULL
 *
 * 
 *
 * ڴ顣Ҳڴڴ飩
 *
 * úȴһΪdwCountڴ棬´ڴʼΪ0Ȼ
 * pSouгΪdwCountݵµڴ顣pSouΪNULL򲻸
 *
 * ڲdwCountָΪ0ԭַݣڴ
 * ĳߴ罫Դַڴĳߴͬ
 * ڲpSoudwCountͬʱΪ0NULL
 * 
 * صڴ鲻ʹʱӦfree()ͷ
 *
 * pSouָڴmalloc(),calloc(),realloc()!!!
 * 
 ************************************************************************/


LPVOID CBmpProc::CreateMemoryBlockFromAddress(LPVOID pSou, DWORD dwCount)
{
	// ڲpSoudwCountͬʱΪ0
	if ((pSou==NULL)&&(dwCount==0))
		return NULL;

	LPSTR lpt;

	// ֻ
	if (pSou == NULL)
	{
		ASSERT(dwCount);
		lpt = (LPSTR)::malloc((size_t)dwCount);
		if (!lpt)
			return NULL;

		::memset((void *)lpt, 0xFF, dwCount);

		return lpt;
	}

	DWORD dwCopyNum, dwAllocNum;

	if (dwCount == 0)
	{
		dwCopyNum = (DWORD)::_msize((void*)pSou);
		dwAllocNum = dwCopyNum;
	}
	else
	{
		// pSouڴĳߴСdwCountֵָpSouе
		// ȫƵµڴУֻdwCountȵ
		dwCopyNum = min((DWORD)::_msize((void*)pSou), dwCount);
		dwAllocNum = dwCount;
	}

	lpt = (LPSTR)::malloc((size_t)dwAllocNum);

	if (!lpt)
		return NULL;

	// ʼڴ
	::memset((void *)lpt, 0xFF, dwAllocNum);

	// Դڴеݵµڴ
	::memcpy((void*)lpt, (const void*)pSou, (size_t)dwCopyNum);

	return (LPVOID)lpt;
}



/*************************************************************************
 *
 * CreateMemoryBlockFromHandle()
 *
 * ˵
 *
 * HANDLE handle	- ƵڴNULLμעͣ
 * DWORD dwCount	- ´ڴĳߴ磨0μעͣ
 *
 * ֵ
 *
 * LPVOID           - µڴַʧܣNULL
 *
 * 
 *
 * ָߴڴݵһµڴУҲڴڴ飩
 *
 * ע
 *
 * úȴһָȵڴ飬´ڴʼΪ0Ȼ
 * ƾhandleָСݵµڴС
 *
 * ڲhandleָΪNULLֻڴ棬
 * ڲdwCountָΪ0ԭݣڴ
 * ĳߴ罫Դĳߴͬ
 * ڲhandledwCountͬʱΪ0NULL
 *
 * صڴ鲻ʹʱӦfree()ͷ
 *
 ************************************************************************/


LPVOID CBmpProc::CreateMemoryBlockFromHandle(HANDLE handle, DWORD dwCount)
{
	// ڲhandledwCountͬʱΪ0
	if ((handle==NULL)&&(dwCount==0))
		return NULL;

	LPSTR lpt;

	// ֻ
	if (handle == NULL)
	{
		ASSERT(dwCount);
		lpt = (LPSTR)::malloc((size_t)dwCount);
		if (!lpt)
			return NULL;

		::memset((void *)lpt, 0xFF, dwCount);

		return lpt;
	}

	DWORD dwCopyNum, dwAllocNum;

	if (dwCount == 0)
	{
		dwCopyNum = ::GlobalSize((HGLOBAL)handle);
		dwAllocNum = dwCopyNum;
	}
	else
	{
		// ָĳߴֵھߴ磬ʹþߴֵ
		dwCopyNum = min(::GlobalSize((HGLOBAL)handle), dwCount);
		dwAllocNum = dwCount;
	}

	lpt = (LPSTR)::malloc((size_t)dwAllocNum);

	if (!lpt)
		return NULL;

	::memset((void *)lpt, 0xFF, dwAllocNum);

	// ڴݵµڴ
	void* lp = ::GlobalLock((HGLOBAL)handle);
	if (!lp)
	{
		::free((void*)lpt);
		return NULL;
	}
	::memcpy((void*)lpt, (const void*)lp, (size_t)dwCopyNum);
	::GlobalUnlock(handle);

	return (LPVOID)lpt;
}



/*************************************************************************
 *
 * GetBitsPerPixel()
 * 
 * ˵
 *
 * LPBITMAPINFOHEADER lpbi	- ָڴDIBBITMAPINFOHEADERṹ
 *
 * ֵ
 *
 * int						- ÿռλ
 *
 * 
 *
 * ȡָDIBÿռλ
 *
 ************************************************************************/


int	CBmpProc::GetBitsPerPixel(LPBITMAPINFOHEADER lpbi) const
{
	ASSERT(lpbi);
	ASSERT(lpbi->biSize == sizeof(BITMAPINFOHEADER));
	return lpbi->biBitCount;  // DIBλ
}






/***************************** ڲʺ **************************/

/*************************************************************************
 *
 * Size()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * CSize				- ذͼߴCSizeĿ꣬ʧܣCSizeĿ
 *						  еĿȺ͸߶ȶ0
 *
 * 
 *
 * ȡͼĿȺ͸߶ȣΪλ
 *
 ************************************************************************/


CSize CBmpProc::Size() const
{ 
	if (m_mark == FALSE)
		return CSize(0,0);

	ASSERT(m_pInfo);
	ASSERT(DIBWidth((LPBITMAPINFOHEADER)m_pInfo));	// Ⱥ͸߶ȲΪ0
	ASSERT(DIBHeight((LPBITMAPINFOHEADER)m_pInfo));

	return CSize(DIBWidth((LPBITMAPINFOHEADER)m_pInfo), DIBHeight((LPBITMAPINFOHEADER)m_pInfo));
}



/*************************************************************************
 *
 * Rect()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * CRect				- ذͼߴCRectĿ꣬ʧܣCRectĿ
 *						  еݾ0
 *
 * 
 *
 * ȡͼĳߴݣΪλ
 *
 ************************************************************************/


CRect CBmpProc::Rect() const
{ 
	if (m_mark == FALSE)
		return CRect(0,0,0,0);

	ASSERT(m_pInfo);

	return CRect(CPoint(0, 0), Size()); 
}



/*************************************************************************
 *
 * Width()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * int					- ͼĿȣʧܷ0
 *
 * 
 *
 * ȡͼĿݣΪλ
 *
 ************************************************************************/


int CBmpProc::Width() const
{
	if (m_mark == FALSE)
		return 0;

	ASSERT(m_pInfo);

	return (int)DIBWidth((LPBITMAPINFOHEADER)m_pInfo);
}



/*************************************************************************
 *
 * Height()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * int					- ͼĸ߶ȣʧܷ0
 *
 * 
 *
 * ȡͼĸ߶ݣΪλ
 *
 ************************************************************************/


int CBmpProc::Height() const
{ 
	if (m_mark == FALSE)
		return 0;

	ASSERT(m_pInfo);

	return (int)DIBHeight((LPBITMAPINFOHEADER)m_pInfo);
}



/*************************************************************************
 *
 * ScanWidth()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * int					- ͼÿһɨеĿȣʧܷ0
 *
 * 
 *
 * ȡͼɨпȣֽΪλ
 *
 * עDIBλͼɨDWORDͶģDDBλͼɨWORD
 *
 ************************************************************************/


int CBmpProc::ScanWidth() const
{ 
	if (m_mark == FALSE)
		return 0;

	ASSERT(m_pInfo);

	return DIBSCANLINE_WIDTHBYTES(Width()*GetBitsPerPixel((LPBITMAPINFOHEADER)m_pInfo));
}



/*************************************************************************
 *
 * BitsPerPixel()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * int					- ͼÿռλʧܷ0
 *
 * 
 *
 * ȡͼÿռλĸ16ɫλͼÿռ4λ
 *
 ************************************************************************/


int CBmpProc::BitsPerPixel() const
{ 
	if (m_mark == FALSE)
		return 0;

	ASSERT(m_pInfo);

	return GetBitsPerPixel((LPBITMAPINFOHEADER)m_pInfo);
}



/*************************************************************************
 *
 * IsValid()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * BOOL					- дλͼ򷵻TRUE򷵻FALSE
 *
 * 
 *
 * жǷЧλͼ
 *
 ************************************************************************/


BOOL  CBmpProc::IsValid() const
{ 
	return m_mark;
}



/*************************************************************************
 *
 * GetImageType()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * int					- ͼͱ
 *
 * 
 *
 * ȡλͼԴͱ
 * 
 * עصֵCBmpProc::IT_MEMORYƵķб
 *     ֵ֮һ
 *
 * 		CBmpProc::IT_NULL,		 λͼ	0   ûλͼ
 *		CBmpProc::IT_DISKFILE,	 ļλͼ		1
 *		CBmpProc::IT_RESOURCE,	 Դλͼ		2
 *		CBmpProc::IT_MEMORY,	 ڴλͼ		3
 *		CBmpProc::IT_CLIP,		 λͼ	4
 *		CBmpProc::IT_CREATE		 λͼ	5
 *
 ************************************************************************/


int CBmpProc::GetImageType() const
{ 
	return (int)m_type; 
}



/*************************************************************************
 *
 * GetInAddInfo()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * DWORD				- Ϣ
 *
 * 
 *
 * ȡλͼĸϢ
 * 
 * עϢݻλͼԴ͵ĲͬͬλͼԴ
 *     CBmpProc::IT_RESOURCEʹõǱʶ򸽼Ϣ͵
 *     ʶֵ0û壩
 *
 ************************************************************************/


DWORD CBmpProc::GetInAddInfo() const
{ 
	return m_addInfo; 
}



/*************************************************************************
 *
 * GetFileName()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * const CString&		- ļ
 *
 * 
 *
 * ȡλͼļ
 * 
 * עҪñķֵıļƣʹSetFileName()
 *
 ************************************************************************/


const CString& CBmpProc::GetFileName() const
{ 
	return m_cFileName; 
}



/*************************************************************************
 *
 * SetFileName()
 * 
 * ˵
 *
 * LPSTR pSou			- µļ
 *
 * ֵ
 *
 * BOOL					- óɹTRUE򷵻FALSE
 *
 * 
 *
 * λͼļ
 * ԭûλͼִʧ
 * 
 ************************************************************************/


BOOL CBmpProc::SetFileName(LPSTR pSou)
{
	if (m_mark == FALSE)
		return FALSE;

	ASSERT(pSou);

	m_cFileName = pSou; 

	return TRUE;
}



/*************************************************************************
 *
 * GetObject()
 * 
 * ˵
 *
 * LPBITMAP lpBitmap	- ϢݵĽṹַ
 *
 * ֵ
 *
 * int					- ɹԻȡֽڸʧܣ0
 * 
 * 
 *
 * ȡλͼBITMAPϢ
 *
 * ע# ɹ֮BITMAPṹֻwidth,heightɫʽϢЧ
 *     # ԭûλͼʧܣ0
 * 
 ************************************************************************/


int CBmpProc::GetObject(LPBITMAP lpBitmap) const
{ 
	if (m_mark == FALSE)
		return 0;

	ASSERT(m_hObject);
	ASSERT(lpBitmap);

	return CGdiObject::GetObject(sizeof(BITMAP), (LPVOID)lpBitmap); 
}



/*************************************************************************
 *
 * GetVersion()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * WORD					- 汾
 * 
 * 
 *
 * ȡCBmpProcİ汾
 *
 * עֵеĸ8λ汾ţ8λӰ汾
 * 
 ************************************************************************/


WORD CBmpProc::GetVersion() const
{ 
	return (WORD)BMPPROC_VERSION; 
}



/*************************************************************************
 *
 * PasteAvailable()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * BOOL					- дDIBʽݣ򷵻TRUE
 *						  FALSE
 * 
 * 
 *
 * жϼǷDIBʽݡ
 *
 ************************************************************************/


BOOL CBmpProc::PasteAvailable()
{
	return (IsClipboardFormatAvailable(CF_DIB)) ? TRUE:FALSE;
}



/*************************************************************************
 *
 * IsFileExist()
 * 
 * ˵
 *
 * LPCTSTR lpFileName	- жϵļ·ƣļ
 *
 * ֵ
 *
 * BOOL					- ָļڷTRUE򷵻FALSE
 * 
 * 
 *
 * жָļǷ
 * 
 * ļԱд
 *
 ************************************************************************/


BOOL CBmpProc::IsFileExist(LPCTSTR lpFileName)
{
	CFile	file;
	BOOL	bExist = FALSE;	// ļTRUEFALSE

	// ȷָļǷ
	if (file.Open(lpFileName, CFile::modeReadWrite))
	{
		bExist = TRUE;
		file.Close();
	}

	return bExist;
}



/*************************************************************************
 *
 * GetHDib()
 * 
 * ˵
 *
 *
 * ֵ
 *
 * HANDLE				- ɹDIBڲʽڴ
 * 
 * 
 *
 * ȡλͼDIBڲʽڴ
 * 
 * # ԭûλͼNULL
 * # صڴGlobalAlloc()ģʹʱӦʱͷ
 * # صľ壬DIBͨ
 *
 ************************************************************************/


HANDLE CBmpProc::GetHDib() const
{ 
	// ԭûλͼNULL
	if (!IsValid())
		return NULL;

	ASSERT(m_pInfo);

	// DIBڲʽߴ磨dibsize
	DWORD infosize = CalculateDIBInfoSize((LPBITMAPINFOHEADER)m_pInfo);
	DWORD dibsize = CalculateDIBSize((LPBITMAPINFOHEADER)m_pInfo);

	// DIBڴ飬GMEM_DDESHAREʶʹþڼ
	HANDLE h = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, dibsize);
	if (!h)
		return NULL;

	LPSTR lp = (LPSTR)::GlobalLock(h);
	if (lp)
	{
		// DIBϢ
		::memcpy((void *)lp, (const void *)m_pInfo, (size_t)infosize);

		// ȡDIBλ
		HWND hWnd = ::GetDesktopWindow();
		ASSERT(hWnd);
		HDC hDC = ::GetDC(hWnd);
		if (!::GetDIBits(hDC,(HBITMAP)m_hObject,0,m_pInfo->bmiHeader.biHeight,\
				(LPVOID)((DWORD)lp+infosize),(LPBITMAPINFO)lp,DIB_RGB_COLORS))
		{
			::GlobalUnlock(h);
			::GlobalFree(h);
			::ReleaseDC(hWnd, hDC);
			return NULL;
		}
		::ReleaseDC(hWnd, hDC);
		::GlobalUnlock(h);

		return h;	// ɹ
	}

	::GlobalFree(h);

	return NULL;
}



/*************************************************************************
 *
 * IsValidDibFormat()
 * 
 * ˵
 *
 * WORD nBitsPerPixel	- жλֵ
 *
 * ֵ
 *
 * BOOL					- Чֵ򷵻TRUE򷵻FALSE
 * 
 * 
 *
 * жָλֵÿռλǷǺϷֵ
 * 
 * # CBmpProc൱ǰ֧1,4,8,16,24,32λʽλͼ
 *
 ************************************************************************/


BOOL CBmpProc::IsValidDibFormat(WORD nBitsPerPixel)
{
	// λϷ
	switch(nBitsPerPixel)
	{
	case	1:
	case	4:
	case	8:
	case	16:
	case	24:
	case	32:
		// ϸʽλͼǺϷ
		return TRUE;
	default:
		ASSERT(FALSE);	// ƴ
		break;
	}

	return FALSE;
}



/*************************************************************************
 *
 * ClearAndSetData()
 * 
 * ˵
 *
 * int type				- λͼԴ
 * DWORD addinfo		- λͼĸϢֵ
 * LPCTSTR lpFn			- λͼļַ
 * LPBITMAPINFO pInfo	- λͼϢַ
 * HBITMAP hBmp			- λͼλͼ
 *
 * ֵ
 *
 * BOOL					- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ԭλͼָλͼ
 * 
 * # ԭλͼ
 * # ָĲ뱣֤Ч
 *
 ************************************************************************/


BOOL CBmpProc::ClearAndSetData(int type, 
							   DWORD addinfo, 
							   LPCTSTR lpFn, 
							   LPBITMAPINFO pInfo, 
							   HBITMAP hBmp)
{
	ASSERT(pInfo);
	ASSERT(hBmp);

	// ԭλͼ
	if (m_mark == TRUE)
	{
		// ԭλͼ
		ASSERT((HBITMAP)m_hObject);
		HBITMAP hOldBmp = (HBITMAP)CGdiObject::Detach();
		ASSERT(hOldBmp);
		if (!CGdiObject::Attach((HGDIOBJ)hBmp))
		{
			// ʧܣָԭλͼ
			CGdiObject::Attach((HGDIOBJ)hOldBmp);
			return FALSE;
		}
		// ɹԭλͼãͷ
		::DeleteObject((HGDIOBJ)hOldBmp);

		m_type = type,			// λͼԴ
		m_addInfo = addinfo;	// Ϣ
		m_cFileName.Empty();
		m_cFileName = lpFn;		// ļ·
		ASSERT(m_pInfo);
		::free((void*)m_pInfo);
		m_pInfo = pInfo;		// DIBϢṹ

		return TRUE;
	}
	else	// ԭûλͼ
	{
		ASSERT(m_pInfo == NULL);
		ASSERT(m_hObject == NULL);

		if (!CGdiObject::Attach((HGDIOBJ)hBmp))
			return FALSE;

		m_mark = TRUE;			// Ч־
		m_type = type,			// λͼԴ
		m_addInfo = addinfo;	// Ϣ
		m_cFileName = lpFn;		// ļ·
		m_pInfo = pInfo;		// DIBϢṹ

		return TRUE;
	}
}



/*************************************************************************
 *
 * DrawTransparentInPoint()
 * 
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * COLORREF crColour		- ͼҪ˵ɫȱʡֵΪɫ
 * int x 					- ĿεϽ XȱʡֵΪ0
 * int y 					-           ''         YȱʡֵΪ0
 * CRect* crSou				- Դͼʾֵľ꣨ȱʡֵNULL
 * int mode					- 0򽫲ʾָɫ1ָ
 *						      ɫȱʡֵΪ0
 *
 * ֵ
 *
 * BOOL					- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * еͼ͸ĻĿ豸ָбҪԲѹ
 * 
 * 
 * ûͼʲôҲֱӷ
 * Ƶͼڵǰڣֱӷ
 * ڲcrSouΪNULLͼѹ
 * 
 ************************************************************************/


BOOL CBmpProc::DrawTransparentInPoint(CDC& dc, 
									  COLORREF crColour, 
									  int x, 
									  int y, 
									  CRect* crSou, 
									  int mode)
{
	// ûͼֱӷ 
	if (!IsValid())
		return TRUE;

	ASSERT(m_hObject);

	CRect DCRect(Rect());			// Ŀλ
	DCRect.OffsetRect(x, y);

	return DrawTransparentInRect(dc, crColour, &DCRect, crSou, mode);
}



/*************************************************************************
 *
 * DrawTransparentInRect()
 * 
 * ˵
 *
 * CDC& dc					- ʾλͼ豸
 * COLORREF crColour		- ͼҪ˵ɫȱʡֵΪɫ
 * CRect* crDest			- ĿݣȱʡֵNULL
 * CRect* crSou				- Դͼʾֵľ꣨ȱʡֵNULL
 * int mode					- 0򽫲ʾָɫ1ָ
 *						      ɫȱʡֵΪ0
 *
 * ֵ
 *
 * BOOL					- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * еͼ͸ĻĿ豸ָбҪԲѹ
 * 
 * 
 * ûͼʲôҲֱӷ
 * Ƶͼڵǰڣֱӷ
 * ڲcrDestcrSouNULL豸0,0λòε
 * λͼ
 * ڲcrDestcrSouĿȻ߶ֵͬƳͼΣ
 * ѹ
 * 
 ************************************************************************/


BOOL CBmpProc::DrawTransparentInRect(CDC& dc, 
							   COLORREF crColour, 
							   CRect* crDest, 
							   CRect* crSou, 
							   int mode)
{
	// ûͼֱӷ 
	if (!IsValid())
		return TRUE;

	ASSERT(m_hObject);

	// ȱʡεͼߴ
	CRect DCRect(Rect());			// Ŀλ
	CRect SORect(Rect());			// Դλ

	if (crDest)
		DCRect = *crDest;
	if (crSou)
		SORect = *crSou;

	// Ƶͼڵǰڣֱӷ
	if (!dc.RectVisible(&DCRect))
		return TRUE;

	COLORREF crOldBack;
	COLORREF crOldText;

	if (mode==0)
	{	// ȥָɫ
		crOldBack = dc.SetBkColor(RGB(255,255,255));
		crOldText = dc.SetTextColor(RGB(0,0,0));
	}
	else
	{	// ָɫ
		crOldBack = dc.SetBkColor(RGB(0,0,0));
		crOldText = dc.SetTextColor(RGB(255,255,255));
	}

	CDC dcImage, dcTrans;

	// ڴ豸
	dcImage.CreateCompatibleDC(&dc);
	dcTrans.CreateCompatibleDC(&dc);

	// ѡԭʼͼDC
	CBitmap* pOldBitmapImage = dcImage.SelectObject(this);

	// λͼ
	CBitmap bitmapTrans;
	int nWidth = SORect.Width();
	int nHeight = SORect.Height();
	bitmapTrans.CreateBitmap(nWidth, nHeight, 1, 1, NULL);

	// ѡλͼDC
	CBitmap* pOldBitmapTrans = dcTrans.SelectObject(&bitmapTrans);

	// ͼ񣨻ָɫ
	dcImage.SetBkColor(crColour);
	dcTrans.BitBlt(0, 0, nWidth, nHeight, &dcImage, SORect.left, SORect.top, SRCCOPY);

	// ʾ͸λͼ

	/* ĿDCģʽΪSTRETCH_DELETESCANSҲǲʾͼ */
	int srlold = dc.SetStretchBltMode(STRETCH_DELETESCANS);

	// ʾλͼ
	dc.StretchBlt(DCRect.left,DCRect.top,DCRect.Width(),DCRect.Height(),
		&dcImage,SORect.left,SORect.top,SORect.Width(),SORect.Height(),SRCINVERT);
	dc.StretchBlt(DCRect.left,DCRect.top,DCRect.Width(),DCRect.Height(),
		&dcTrans,SORect.left,SORect.top,SORect.Width(),SORect.Height(),SRCAND);
	dc.StretchBlt(DCRect.left,DCRect.top,DCRect.Width(),DCRect.Height(),
		&dcImage,SORect.left,SORect.top,SORect.Width(),SORect.Height(),SRCINVERT);

	// ָ豸ԭ
	dc.SetStretchBltMode(srlold);

	// ָ
	dcImage.SelectObject(pOldBitmapImage);
	dcTrans.SelectObject(pOldBitmapTrans);
	dc.SetBkColor(crOldBack);
	dc.SetTextColor(crOldText);

	return TRUE;
}
/*************************************************************************
 *
 * ExportRegion()
 * 
 * ˵
 *
 * COLORREF cTranColor		- ָҪ˵ɫȱʡֵǰɫ
 *
 * ֵ
 *
 * HRGN 					- ɹλͼ򷵻NULL
 * 
 * 
 *
 * λͼ
 * 
 * úǽָɫ֮ڣɫһ
 * ûͼʲôҲֱӷNULL
 * ʱ䲻ҪصʱӦDeleteObject()ͷ
 * 
 ************************************************************************/


HRGN CBmpProc::ExportRegion(COLORREF cTranColor)
{
	HRGN hRgn = NULL;

	// ûͼֱӷ
	if (!IsValid())
		return NULL;

	ASSERT(m_hObject);

	int wi, he;

	wi = Width();
	he = Height();

	// ڴ豸ڻȡλͼλ
	HDC hMemDC = ::CreateCompatibleDC(NULL);
	if (hMemDC)
	{
		BITMAPINFOHEADER bmi = {sizeof(BITMAPINFOHEADER), wi, he, 1, 32, BI_RGB, 0, 0, 0, 0, 0};
		VOID * pbits32; 
		// λͼ(Section)ȡλ
		HBITMAP hbm32 = ::CreateDIBSection(hMemDC, (BITMAPINFO *)&bmi, DIB_RGB_COLORS, &pbits32, NULL, 0);
		if (hbm32)
		{
			HBITMAP holdBmp = (HBITMAP)::SelectObject(hMemDC, hbm32);
			HDC hDC = ::CreateCompatibleDC(hMemDC);
			if (hDC)
			{
				BITMAP bm32;
				::GetObject(hbm32, sizeof(BITMAP), &bm32);
				while (bm32.bmWidthBytes % 4)	// DIBɨΪDWORD
					bm32.bmWidthBytes++;

				HBITMAP hob = (HBITMAP)::SelectObject(hDC, (HBITMAP)m_hObject);
				::BitBlt(hMemDC, 0, 0, wi, he, hDC, 0, 0, SRCCOPY);
				::SelectObject(hDC, hob);
				::DeleteDC(hDC);

				// θĲֵΪ200
				#define ALLOC_UNIT	200

				DWORD maxRects = ALLOC_UNIT;
				RGNDATA *pData = (RGNDATA *)CreateMemoryBlockFromAddress(NULL, sizeof(RGNDATAHEADER)+(sizeof(RECT)*maxRects));
				if (!pData)
				{
					::DeleteObject(::SelectObject(hMemDC, holdBmp));
					::DeleteDC(hMemDC);
					return NULL;
				}

				// ʼݽṹ
				pData->rdh.dwSize = sizeof(RGNDATAHEADER);
				pData->rdh.iType = RDH_RECTANGLES;
				pData->rdh.nCount = 0;
				pData->rdh.nRgnSize = 0;
				::SetRect(&pData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);

				// 
				BYTE *p32 = (BYTE *)bm32.bmBits + (bm32.bmHeight-1)*bm32.bmWidthBytes;
				for (int y = 0; y < he; y++)
				{
					for (int x = 0; x < wi; x++)
					{
						int x0 = x;
						LONG *p = (LONG *)p32 + x;
						while (x < wi)
						{	// ָҪ˵ɫ
							if (((*p)&0xFFFFFF)==((LONG)cTranColor&0xFFFFFF))
								break;
							p++;
							x++;
						}

						if (x > x0)	// з˵ɫ
						{
							if (pData->rdh.nCount >= maxRects)
							{	// ṹвµľݣ׷ڴ
								ASSERT(pData);
								ASSERT(pData->rdh.dwSize == sizeof(RGNDATAHEADER));
								maxRects += ALLOC_UNIT;
								RGNDATA *p = (RGNDATA *)CreateMemoryBlockFromAddress((LPVOID)pData, sizeof(RGNDATAHEADER)+(sizeof(RECT)*maxRects));
								::free((void*)pData);
								if (!p)
								{
									if (hRgn)
										::DeleteObject(hRgn);
									::DeleteObject(::SelectObject(hMemDC, holdBmp));
									::DeleteDC(hMemDC);
									return NULL;
								}
								ASSERT(p->rdh.dwSize == sizeof(RGNDATAHEADER));
								pData = p;
							}

							// ˢṹе
							RECT *pr = (RECT *)&pData->Buffer;
							SetRect(&pr[pData->rdh.nCount], x0, y, x, y+1);
							if (x0 < pData->rdh.rcBound.left)
								pData->rdh.rcBound.left = x0;
							if (y < pData->rdh.rcBound.top)
								pData->rdh.rcBound.top = y;
							if (x > pData->rdh.rcBound.right)
								pData->rdh.rcBound.right = x;
							if (y+1 > pData->rdh.rcBound.bottom)
								pData->rdh.rcBound.bottom = y+1;
							pData->rdh.nCount++;

							// ΪĺExtCreateRegion()Ҫݽṹеľθܳ4000
							// ȡֵһ롣
							if (pData->rdh.nCount == 2000)
							{
								HRGN h = ::ExtCreateRegion(NULL, sizeof(RGNDATAHEADER)+(sizeof(RECT)*maxRects), pData);
								if (hRgn)
								{
									::CombineRgn(hRgn, hRgn, h, RGN_OR);
									::DeleteObject(h);
								}
								else
									hRgn = h;
								pData->rdh.nCount = 0;
								::SetRect(&pData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);
							}
						}
					}
					// ָһе׵ַDIBɨǴµϣ
					p32 -= bm32.bmWidthBytes;
				}

				ASSERT(pData);

				// λͼȫָҪ˵ɫθ
				// 2000´ɴĹ
				HRGN hg = ::ExtCreateRegion(NULL, sizeof(RGNDATAHEADER)+(sizeof(RECT)*maxRects), pData);
				if (hRgn)
				{
					::CombineRgn(hRgn, hRgn, hg, RGN_OR);
					::DeleteObject(hg);
				}
				else
					hRgn = hg;

				::free((void*)pData);
			}
			::DeleteObject(::SelectObject(hMemDC, holdBmp));
		}
		::DeleteDC(hMemDC);
	}	

	return hRgn;
}



/*************************************************************************
 *
 * Fill()
 * 
 * ˵
 *
 * COLORREF crColour		- ָҪɫȱʡֵǰɫ
 * CRect *crArea			- ΣȱʡֵNULL
 *
 * ֵ
 *
 * BOOL 					- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * ָɫ䱾λͼָ򣨾Σ
 * 
 * ڲcrAreaΪNULLλͼ
 * ûͼֱӷFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::Fill(COLORREF crColour, CRect *crArea)
{
	// бλͼ
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	CRect	rect(Rect());

	if (crArea)
		rect = *crArea;

	// Դͼ
	CDC			compDC;
	CBitmap		*pOldBmp;

	// 뵱ǰʾ豸ݵڴ豸
	compDC.CreateCompatibleDC(NULL);
	pOldBmp	= compDC.SelectObject((CBitmap*)this);

	// ָɫ
	compDC.FillSolidRect((LPCRECT)&rect, crColour);

	compDC.SelectObject(pOldBmp);

	return TRUE;
}



/*************************************************************************
 *
 * ReSetColor()
 *
 * ˵
 *
 * COLORREF oldcolr			- 滻ľɫ
 * COLORREF newcolr			- Ҫ滻ȥµɫ
 * CRect *crArea			- Ҫ滻ķΧȱʡֵNULL
 *
 * ֵ
 *
 * BOOL 					- ɹTRUE򷵻FALSE
 * 
 * 
 *
 * һɫ滻һɫλͼָ
 * 
 * ڲcrAreaΪNULL滻λͼָɫ
 * ûͼֱӷFALSE
 * 
 ************************************************************************/


BOOL CBmpProc::ReSetColor(COLORREF oldcolr, COLORREF newcolr, CRect *crArea)
{
	// бλͼ
	if (!IsValid())
		return FALSE;

	ASSERT(m_pInfo);
	ASSERT(m_pInfo->bmiHeader.biSize == sizeof(BITMAPINFOHEADER));

	// ƱеλͼΪ
	CBmpProc tmp;
	
	tmp = *this;

	if (!tmp.IsValid())
		return FALSE;

	// ָΪµɫ
	Fill(newcolr, crArea);
	// ȥɫͼ
	CopyTran(tmp, oldcolr, crArea, crArea, 0);

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////
//
//ת
//
////////////////////////////////////////////////////////////////////////////////////
// GetRotatedBitmapNT	- Create a new bitmap with rotated image
// Returns		- Returns new bitmap with rotated image
// hBitmap		- Bitmap to rotate
// radians		- Angle of rotation in radians
// clrBack		- Color of pixels in the resulting bitmap that do
//			  not get covered by source pixels
HBITMAP GetRotatedBitmapNT( HBITMAP hBitmap, float radians, COLORREF clrBack )
{
	// Create a memory DC compatible with the display
	CDC sourceDC, destDC;
	sourceDC.CreateCompatibleDC( NULL );
	destDC.CreateCompatibleDC( NULL );

	// Get logical coordinates
	BITMAP bm;
	::GetObject( hBitmap, sizeof( bm ), &bm );

	float cosine = (float)cos(radians);
	float sine = (float)sin(radians);

	// Compute dimensions of the resulting bitmap
	// First get the coordinates of the 3 corners other than origin
	int x1 = (int)(bm.bmHeight * sine);
	int y1 = (int)(bm.bmHeight * cosine);
	int x2 = (int)(bm.bmWidth * cosine + bm.bmHeight * sine);
	int y2 = (int)(bm.bmHeight * cosine - bm.bmWidth * sine);
	int x3 = (int)(bm.bmWidth * cosine);
	int y3 = (int)(-bm.bmWidth * sine);

	int minx = min(0,min(x1, min(x2,x3)));
	int miny = min(0,min(y1, min(y2,y3)));
	int maxx = max(0,max(x1, max(x2,x3)));
	int maxy = max(0,max(y1, max(y2,y3)));

	int w = maxx - minx;
	int h = maxy - miny;

	// Create a bitmap to hold the result
	HBITMAP hbmResult = ::CreateCompatibleBitmap(CClientDC(NULL), w, h);

	HBITMAP hbmOldSource = (HBITMAP)::SelectObject( sourceDC.m_hDC, hBitmap );
	HBITMAP hbmOldDest = (HBITMAP)::SelectObject( destDC.m_hDC, hbmResult );

	// Draw the background color before we change mapping mode
	HBRUSH hbrBack = CreateSolidBrush( clrBack );
	HBRUSH hbrOld = (HBRUSH)::SelectObject( destDC.m_hDC, hbrBack );
	destDC.PatBlt( 0, 0, w, h, PATCOPY );
	::DeleteObject( ::SelectObject( destDC.m_hDC, hbrOld ) );

	// We will use world transform to rotate the bitmap
	SetGraphicsMode(destDC.m_hDC, GM_ADVANCED);
	XFORM xform;
	xform.eM11 = cosine;
	xform.eM12 = -sine;
	xform.eM21 = sine;
	xform.eM22 = cosine;
	xform.eDx = (float)-minx;
	xform.eDy = (float)-miny;

	SetWorldTransform( destDC.m_hDC, &xform );

	// Now do the actual rotating - a pixel at a time
	destDC.BitBlt(0,0,bm.bmWidth, bm.bmHeight, &sourceDC, 0, 0, SRCCOPY );

	// Restore DCs
	::SelectObject( sourceDC.m_hDC, hbmOldSource );
	::SelectObject( destDC.m_hDC, hbmOldDest );

	return hbmResult;
}
// GetRotatedBitmap	- Create a new bitmap with rotated image
// Returns		- Returns new bitmap with rotated image
// hBitmap		- Bitmap to rotate
// radians		- Angle of rotation in radians
// clrBack		- Color of pixels in the resulting bitmap that do
//			  not get covered by source pixels
// Note			- If the bitmap uses colors not in the system palette 
//			  then the result is unexpected. You can fix this by
//			  adding an argument for the logical palette.
HBITMAP GetRotatedBitmap( HBITMAP hBitmap, float radians, COLORREF clrBack )
{
	// Create a memory DC compatible with the display
	CDC sourceDC, destDC;
	sourceDC.CreateCompatibleDC( NULL );
	destDC.CreateCompatibleDC( NULL );

	// Get logical coordinates
	BITMAP bm;
	::GetObject( hBitmap, sizeof( bm ), &bm );

	float cosine = (float)cos(radians);
	float sine = (float)sin(radians);

	// Compute dimensions of the resulting bitmap
	// First get the coordinates of the 3 corners other than origin
	int x1 = (int)(-bm.bmHeight * sine);
	int y1 = (int)(bm.bmHeight * cosine);
	int x2 = (int)(bm.bmWidth * cosine - bm.bmHeight * sine);
	int y2 = (int)(bm.bmHeight * cosine + bm.bmWidth * sine);
	int x3 = (int)(bm.bmWidth * cosine);
	int y3 = (int)(bm.bmWidth * sine);

	int minx = min(0,min(x1, min(x2,x3)));
	int miny = min(0,min(y1, min(y2,y3)));
	//int maxx = max(x1, max(x2,x3));
	//int maxy = max(y1, max(y2,y3));
	int maxx = max(0,max(x1, max(x2,x3)));
	int maxy = max(0,max(y1, max(y2,y3)));

	int w = maxx - minx;
	int h = maxy - miny;

	// Create a bitmap to hold the result
	HBITMAP hbmResult = ::CreateCompatibleBitmap(CClientDC(NULL), w, h);

	HBITMAP hbmOldSource = (HBITMAP)::SelectObject( sourceDC.m_hDC, hBitmap );
	HBITMAP hbmOldDest = (HBITMAP)::SelectObject( destDC.m_hDC, hbmResult );

	// Draw the background color before we change mapping mode
	HBRUSH hbrBack = CreateSolidBrush( clrBack );
	HBRUSH hbrOld = (HBRUSH)::SelectObject( destDC.m_hDC, hbrBack );
	destDC.PatBlt( 0, 0, w, h, PATCOPY );
	::DeleteObject( ::SelectObject( destDC.m_hDC, hbrOld ) );

	// Set mapping mode so that +ve y axis is upwords
	sourceDC.SetMapMode(MM_ISOTROPIC);
	sourceDC.SetWindowExt(1,1);
	sourceDC.SetViewportExt(1,-1);
	sourceDC.SetViewportOrg(0, bm.bmHeight-1);

	destDC.SetMapMode(MM_ISOTROPIC);
	destDC.SetWindowExt(1,1);
	destDC.SetViewportExt(1,-1);
	destDC.SetWindowOrg(minx, maxy);

	// Now do the actual rotating - a pixel at a time
	// Computing the destination point for each source point
	// will leave a few pixels that do not get covered
	// So we use a reverse transform - e.i. compute the source point
	// for each destination point

	for( int y = miny; y < maxy; y++ )
	{
		for( int x = minx; x < maxx; x++ )
		{
			int sourcex = (int)(x*cosine + y*sine);
			int sourcey = (int)(y*cosine - x*sine);
			if( sourcex >= 0 && sourcex < bm.bmWidth && sourcey >= 0 
					&& sourcey < bm.bmHeight )
				destDC.SetPixel(x,y,sourceDC.GetPixel(sourcex,sourcey));
		}
	}

	// Restore DCs
	::SelectObject( sourceDC.m_hDC, hbmOldSource );
	::SelectObject( destDC.m_hDC, hbmOldDest );

	return hbmResult;
}
// GetRotatedBitmap	- Create a new bitmap with rotated image
// Returns		- Returns new bitmap with rotated image
// hDIB			- Device-independent bitmap to rotate
// radians		- Angle of rotation in radians
// clrBack		- Color of pixels in the resulting bitmap that do
//			  not get covered by source pixels
HANDLE GetRotatedBitmap( HANDLE hDIB, float radians, COLORREF clrBack )
{
	// Get source bitmap info
	BITMAPINFO &bmInfo = *(LPBITMAPINFO)hDIB ;
	int bpp = bmInfo.bmiHeader.biBitCount;		// Bits per pixel
	
	int nColors = bmInfo.bmiHeader.biClrUsed ? bmInfo.bmiHeader.biClrUsed : 
					1 << bpp;
	int nWidth = bmInfo.bmiHeader.biWidth;
	int nHeight = bmInfo.bmiHeader.biHeight;
	int nRowBytes = ((((nWidth * bpp) + 31) & ~31) / 8);

	// Make sure height is positive and biCompression is BI_RGB or BI_BITFIELDS
	DWORD &compression = bmInfo.bmiHeader.biCompression;
	if( nHeight < 0 || (compression!=BI_RGB && compression!=BI_BITFIELDS))
		return NULL;

	LPVOID lpDIBBits;
	if( bmInfo.bmiHeader.biBitCount > 8 )
		lpDIBBits = (LPVOID)((LPDWORD)(bmInfo.bmiColors +
			bmInfo.bmiHeader.biClrUsed) + 
			((compression == BI_BITFIELDS) ? 3 : 0));
	else
		lpDIBBits = (LPVOID)(bmInfo.bmiColors + nColors);

    
	// Compute the cosine and sine only once
	float cosine = (float)cos(radians);
	float sine = (float)sin(radians);

	// Compute dimensions of the resulting bitmap
	// First get the coordinates of the 3 corners other than origin
	int x1 = (int)(-nHeight * sine);
	int y1 = (int)(nHeight * cosine);
	int x2 = (int)(nWidth * cosine - nHeight * sine);
	int y2 = (int)(nHeight * cosine + nWidth * sine);
	int x3 = (int)(nWidth * cosine);
	int y3 = (int)(nWidth * sine);

	int minx = min(0,min(x1, min(x2,x3)));
	int miny = min(0,min(y1, min(y2,y3)));
	int maxx = max(x1, max(x2,x3));
	int maxy = max(y1, max(y2,y3));

	int w = maxx - minx;
	int h = maxy - miny;


	// Create a DIB to hold the result
	int nResultRowBytes = ((((w * bpp) + 31) & ~31) / 8);
	long len = nResultRowBytes * h;
	int nHeaderSize = ((LPBYTE)lpDIBBits-(LPBYTE)hDIB) ;
	HANDLE hDIBResult = GlobalAlloc(GMEM_FIXED,len+nHeaderSize);
	// Initialize the header information
	memcpy( (void*)hDIBResult, (void*)hDIB, nHeaderSize);
	BITMAPINFO &bmInfoResult = *(LPBITMAPINFO)hDIBResult ;
	bmInfoResult.bmiHeader.biWidth = w;
	bmInfoResult.bmiHeader.biHeight = h;
	bmInfoResult.bmiHeader.biSizeImage = len;

	LPVOID lpDIBBitsResult = (LPVOID)((LPBYTE)hDIBResult + nHeaderSize);

	// Get the back color value (index)
	ZeroMemory( lpDIBBitsResult, len );
	DWORD dwBackColor;
	switch(bpp)
	{
	case 1:	//Monochrome
		if( clrBack == RGB(255,255,255) )
			memset( lpDIBBitsResult, 0xff, len );
		break;
	case 4:
	case 8:	//Search the color table
		int i;
		for(i = 0; i < nColors; i++ )
		{
			if( bmInfo.bmiColors[i].rgbBlue ==  GetBValue(clrBack)
				&& bmInfo.bmiColors[i].rgbGreen ==  GetGValue(clrBack)
				&& bmInfo.bmiColors[i].rgbRed ==  GetRValue(clrBack) )
			{
				if(bpp==4) i = i | i<<4;
				memset( lpDIBBitsResult, i, len );
				break;
			}
		}
		// If not match found the color remains black
		break;
	case 16:
		// Windows95 supports 5 bits each for all colors or 5 bits for red & blue
		// and 6 bits for green - Check the color mask for RGB555 or RGB565
		if( *((DWORD*)bmInfo.bmiColors) == 0x7c00 )
		{
			// Bitmap is RGB555
			dwBackColor = ((GetRValue(clrBack)>>3) << 10) + 
					((GetRValue(clrBack)>>3) << 5) +
					(GetBValue(clrBack)>>3) ;
		}
		else
		{
			// Bitmap is RGB565
			dwBackColor = ((GetRValue(clrBack)>>3) << 11) + 
					((GetRValue(clrBack)>>2) << 5) +
					(GetBValue(clrBack)>>3) ;
		}
		break;
	case 24:
	case 32:
		dwBackColor = (((DWORD)GetRValue(clrBack)) << 16) | 
				(((DWORD)GetGValue(clrBack)) << 8) |
				(((DWORD)GetBValue(clrBack)));
		break;
	}


	// Now do the actual rotating - a pixel at a time
	// Computing the destination point for each source point
	// will leave a few pixels that do not get covered
	// So we use a reverse transform - e.i. compute the source point
	// for each destination point

	for( int y = 0; y < h; y++ )
	{
		for( int x = 0; x < w; x++ )
		{
			int sourcex = (int)((x+minx)*cosine + (y+miny)*sine);
			int sourcey = (int)((y+miny)*cosine - (x+minx)*sine);
			if( sourcex >= 0 && sourcex < nWidth && sourcey >= 0 
				&& sourcey < nHeight )
			{
				// Set the destination pixel
				switch(bpp)
				{
					BYTE mask;
				case 1:		//Monochrome
					mask = *((LPBYTE)lpDIBBits + nRowBytes*sourcey + 
						sourcex/8) & (0x80 >> sourcex%8);
					//Adjust mask for destination bitmap
					mask = mask ? (0x80 >> x%8) : 0;
					*((LPBYTE)lpDIBBitsResult + nResultRowBytes*(y) + 
								(x/8)) &= ~(0x80 >> x%8);
					*((LPBYTE)lpDIBBitsResult + nResultRowBytes*(y) + 
								(x/8)) |= mask;
					break;
				case 4:
					mask = *((LPBYTE)lpDIBBits + nRowBytes*sourcey + 
						sourcex/2) & ((sourcex&1) ? 0x0f : 0xf0);
					//Adjust mask for destination bitmap
					if( (sourcex&1) != (x&1) )
						mask = (mask&0xf0) ? (mask>>4) : (mask<<4);
					*((LPBYTE)lpDIBBitsResult + nResultRowBytes*(y) + 
							(x/2)) &= ~((x&1) ? 0x0f : 0xf0);
					*((LPBYTE)lpDIBBitsResult + nResultRowBytes*(y) + 
							(x/2)) |= mask;
					break;
				case 8:
					BYTE pixel ;
					pixel = *((LPBYTE)lpDIBBits + nRowBytes*sourcey + 
							sourcex);
					*((LPBYTE)lpDIBBitsResult + nResultRowBytes*(y) + 
							(x)) = pixel;
					break;
				case 16:
					DWORD dwPixel;
					dwPixel = *((LPWORD)((LPBYTE)lpDIBBits + 
							nRowBytes*sourcey + sourcex*2));
					*((LPWORD)((LPBYTE)lpDIBBitsResult + 
						nResultRowBytes*y + x*2)) = (WORD)dwPixel;
					break;
				case 24:
					dwPixel = *((LPDWORD)((LPBYTE)lpDIBBits + 
						nRowBytes*sourcey + sourcex*3)) & 0xffffff;
					*((LPDWORD)((LPBYTE)lpDIBBitsResult + 
						nResultRowBytes*y + x*3)) |= dwPixel;
					break;
				case 32:
					dwPixel = *((LPDWORD)((LPBYTE)lpDIBBits + 
						nRowBytes*sourcey + sourcex*4));
					*((LPDWORD)((LPBYTE)lpDIBBitsResult + 
						nResultRowBytes*y + x*4)) = dwPixel;
				}
			}
			else 
			{
				// Draw the background color. The background color
				// has already been drawn for 8 bits per pixel and less
				switch(bpp)
				{
				case 16:
					*((LPWORD)((LPBYTE)lpDIBBitsResult + 
						nResultRowBytes*y + x*2)) = 
						(WORD)dwBackColor;
					break;
				case 24:
					*((LPDWORD)((LPBYTE)lpDIBBitsResult + 
						nResultRowBytes*y + x*3)) |= dwBackColor;
					break;
				case 32:
					*((LPDWORD)((LPBYTE)lpDIBBitsResult + 
						nResultRowBytes*y + x*4)) = dwBackColor;
					break;
				}
			}
		}
	}

	return hDIBResult;
}

////////////////////////////////////////////////////////////////////////////////////
//
//רô
//
////////////////////////////////////////////////////////////////////////////////////
#include "pdfrlib.h"
LPSPAGE		lpCurrentPage = NULL;

void CBmpProc::DrawLines(int x0, int y0, int x1, int y1,int width,
			 COLORREF color,int style)
{
	if(lpCurrentPage)
	{
		LPSCONTENT	m_nContent;
		m_nContent = new SCONTENT;
		if(m_nContent == NULL)
			return;
		m_nContent->m_type = PDF_LINE;
		m_nContent->m_Lines = new SLINE;
		SLINE	&m_nLine = *m_nContent->m_Lines;
		m_nLine.x0 = x0;
		m_nLine.y0 = y0;
		m_nLine.x1 = x1;
		m_nLine.y1 = y1;
		m_nLine.width = width;
		m_nLine.color = color;
		m_nLine.style = style;
		lpCurrentPage->m_pageBlock.push_back(m_nContent);
	}
	else
	{
		CDC		compDC;
		CBitmap		*pOldBmp;
		compDC.CreateCompatibleDC(NULL);
		LOGBRUSH	logbrush;
		logbrush.lbColor = color;
		logbrush.lbHatch = 0;
		logbrush.lbStyle = BS_SOLID;
		HPEN m_pen_1 = ::ExtCreatePen(
			style|PS_GEOMETRIC|PS_JOIN_MITER|PS_ENDCAP_FLAT,
			width,
			&logbrush,NULL,NULL);
		CPen *m_pen = CPen::FromHandle(m_pen_1);
		CPen *oldpen = compDC.SelectObject(m_pen);
		pOldBmp	= compDC.SelectObject((CBitmap*)this);
		
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
		compDC.MoveTo(x0,y0);
		compDC.LineTo(x1,y1);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);
		
		compDC.SelectObject(pOldBmp);
		compDC.SelectObject(oldpen);

		::DeleteObject(m_pen_1);
#if 0
		CDC		compDC;
		CBitmap		*pOldBmp;
		compDC.CreateCompatibleDC(NULL);
		CPen m_pen(style,width,color);
		CPen *oldpen = compDC.SelectObject(&m_pen);
		pOldBmp	= compDC.SelectObject((CBitmap*)this);
		
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
		compDC.MoveTo(x0,y0);
		compDC.LineTo(x1,y1);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);
		
		compDC.SelectObject(pOldBmp);
		compDC.SelectObject(oldpen);
#endif
	}
}
void CBmpProc::FillPolygon(POINT* points,int npoints,int shape,int mode,
			   int width,COLORREF color)
{
	if(points == NULL || npoints <= 0)
		return;

	if(lpCurrentPage)
	{
		LPSCONTENT	m_nContent;
		m_nContent = new SCONTENT;
		if(m_nContent == NULL)
			return;
		m_nContent->m_type = PDF_POLYGON;
		m_nContent->m_Polygons = new SPOLYGON;

		SPOLYGON	&m_nPolygon = *m_nContent->m_Polygons;
		for(int i = 0; i < npoints; i++)
		{
			m_nPolygon.pots.push_back(points[i]);
		}
		m_nPolygon.shape = shape;
		m_nPolygon.mode	 = mode;
		m_nPolygon.brushmode = 0;
		m_nPolygon.color = color;
		m_nPolygon.width = width;
		lpCurrentPage->m_pageBlock.push_back(m_nContent);
	}
	else
	{
#if 0
		CDC		compDC;
		CBitmap		*pOldBmp;
		
		compDC.CreateCompatibleDC(NULL);
		pOldBmp	= compDC.SelectObject((CBitmap*)this);
		int oldfillmode = compDC.SetPolyFillMode(mode);
		
		CBrush m_Brush,*poldbrush;
		m_Brush.CreateSolidBrush(color);
		poldbrush = (CBrush*)compDC.SelectObject(&m_Brush);
		
		CPen m_pen(PS_SOLID,width,color);
		CPen *oldpen = compDC.SelectObject(&m_pen);

		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
		compDC.Polygon(points,npoints);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);
		
		compDC.SelectObject(oldpen);
		compDC.SelectObject(poldbrush);
		compDC.SetPolyFillMode(oldfillmode);
		compDC.SelectObject(pOldBmp);
#else
		CDC		compDC;
		CBitmap		*pOldBmp;
		compDC.CreateCompatibleDC(NULL);
		pOldBmp	= compDC.SelectObject((CBitmap*)this);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);

		CBrush m_Brush;
		m_Brush.CreateSolidBrush(color);

		CRgn m_nPolygon;
		m_nPolygon.CreatePolygonRgn(points,npoints,mode);

		compDC.FillRgn(&m_nPolygon,&m_Brush);

		m_nPolygon.DeleteObject();
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);
		compDC.SelectObject(pOldBmp);
		compDC.DeleteDC();
#endif
	}
}
void CBmpProc::TextOutEx( int x, int y, const char* lpszString, int nCount,
		       char *pszFontName,int nFontSizeWidth,int nFontSizeHeight,int isBold,
		       int isItalic,COLORREF m_clrFill,COLORREF m_clrStroke,
		       int m_iRender,double angle,BOOL isWMode16,
		       CONST CHAR* tocode,
		       CONST CHAR* fromcode)
{
/*	if(0)
	{//
		HCHARSET hCharSet = NULL;
		hCharSet = CHARSET_open(tocode,fromcode);
		if (hCharSet)
			CHARSET_conv(hCharSet,NULL,NULL,NULL,NULL);
		char outbuf[4096];
		char inbuf[4096];
		const char *pInbuf = lpszString;
		unsigned int	insize = nCount;
		strcpy(inbuf,pInbuf);
		char *outptr = outbuf;
		const char *inptr = inbuf;
		unsigned int   outsize = 4096;
		int res = CHARSET_conv(hCharSet,&inptr,&insize,&outptr,&outsize);
		if(outptr != outbuf)
		{
			*outptr = '\0';
			TextOut(x,y,outbuf,nCount,
				pszFontName,nFontSizeWidth,nFontSizeHeight,
				isBold,isItalic,
				m_color,angle,isWMode16);
		}
		if(hCharSet)
			CHARSET_close(hCharSet);
	}
	else
*/	{
		TextOut(x,y,lpszString,nCount,
			pszFontName,nFontSizeWidth,nFontSizeHeight,
			isBold,isItalic,m_clrFill,m_clrStroke,
			m_iRender,angle,isWMode16);
	}
}


#define MAPPINT_FONT_NAME_SIZE 32
class CFontMapping
{
public:
	CFontMapping();
	virtual ~CFontMapping();

public:
	BOOL LoadInitFile();
	BOOL GetFontName(LPCTSTR pPdfFontName, char* pWindosFontName);
	LPCTSTR GetDefaultFontName(void) const{return m_szDefaultFontName;}

private:
	int m_nMappingCount;
	char* m_pPdfFontName;
	char* m_pOsFontName;
	char m_szDefaultFontName[MAPPINT_FONT_NAME_SIZE];
};

CFontMapping::CFontMapping()
{
	m_nMappingCount = 0;
	m_pPdfFontName = NULL;
	m_pOsFontName = NULL;
	strcmp(m_szDefaultFontName, "lr ");
}

CFontMapping::~CFontMapping()
{
	if(m_pPdfFontName)
		delete m_pPdfFontName;
	if(m_pOsFontName)
		delete m_pOsFontName;
}

BOOL CFontMapping::LoadInitFile()
{
	LPCTSTR pAppName = "FontNameMapping";
	if(m_pPdfFontName)
		return TRUE;
	char szCurDir[_MAX_PATH];
	GetModuleFileName(NULL, szCurDir, _MAX_PATH);
	CString t = szCurDir;
	int pos = t.ReverseFind('\\');
	CString strInitFileName = t.Left(pos+1) + "config.ini";

	if(0 == (m_nMappingCount = GetPrivateProfileInt(pAppName,"FontCount",0,strInitFileName)))
		return FALSE;
	GetPrivateProfileString(pAppName, "DefaultFontName", "lr ", m_szDefaultFontName, MAPPINT_FONT_NAME_SIZE, strInitFileName);
	m_pPdfFontName = new char[MAPPINT_FONT_NAME_SIZE*m_nMappingCount];
	m_pOsFontName = new char[MAPPINT_FONT_NAME_SIZE*m_nMappingCount];
	for(int i=0; i<m_nMappingCount; i++)
	{
		CString strPdfKey; CString strOsKey;
		strPdfKey.Format("PdfFontName%d", i+1);
		strOsKey.Format("OsFontName%d", i+1);
		GetPrivateProfileString(pAppName, strPdfKey, "Default", m_pPdfFontName+i*MAPPINT_FONT_NAME_SIZE, MAPPINT_FONT_NAME_SIZE, strInitFileName);
		GetPrivateProfileString(pAppName, strOsKey, "Default", m_pOsFontName+i*MAPPINT_FONT_NAME_SIZE, MAPPINT_FONT_NAME_SIZE, strInitFileName);
	}
	return TRUE;
}

BOOL CFontMapping::GetFontName(LPCTSTR pPdfFontName, char* pWindosFontName)
{
	LoadInitFile();
	for(int i=0; i<m_nMappingCount; i++)
	{
		if(0!=strcmp(pPdfFontName, m_pPdfFontName+i*MAPPINT_FONT_NAME_SIZE))
			continue;
		strcpy(pWindosFontName, m_pOsFontName+i*MAPPINT_FONT_NAME_SIZE);
		return TRUE;
	}
	return FALSE;
}
int IsSpecialCharacter(unsigned char c0,unsigned char c1)
{
	if(((c0 >= 0x01 && c0 <= 0x0F) || c0 == 0xfc) && c1 == 0x30 )
		return 1;
	if(c0 == 0x09 && c1 == 0xff)//for ")" character
		return 1;
	//2002/04/18,for charactor
	if(c1 == 0xff)
		return 1;
	return 0;
}
extern void GetRotatedPos(double x,double y,double centerx,double centery,double* xp,double* yp,double angle);
#define PI 3.1415926535
#define RADIAN(angle) ((angle)*PI/180.0) //convert angle to radian
void RotatedPoint(int nFontWidth,int nFontHeight,double angle,int* xp,int* yp)
{
	int count = 8;
	double _angle = angle;
	_angle = (float)RADIAN(_angle);
	double cosa = cos(_angle);
	double sina = sin(_angle);
	*xp = *xp - sina*nFontWidth;
	*yp = *yp - cosa*nFontHeight;


	//*xp += sina*nFontHeight/5;
	//*yp += cosa*nFontWidth/5;
	angle = ((int)angle)%360;
	if(angle < 0)
		angle = 360 + angle;
	if(angle <= 45)
	{//ok
		*xp += nFontHeight/count;
		*yp += nFontWidth/count;
	}
	else if(angle <= 90+45)
	{
		*xp += nFontHeight/count;
		*yp -= nFontWidth/count;
	}
	else if(angle <= 180+45)
	{
		*xp -= nFontHeight/count;
		*yp += nFontWidth/count;
	}
	else if(angle <= 270+45)
	{//ok
		*xp -= nFontHeight/count;
		*yp += nFontWidth/count;
	}
	else if(angle <= 360)
	{
		*xp += nFontHeight/count;
		*yp += nFontWidth/count;
	}
	return;
}
void CBmpProc::TextOut( int x, int y, const char* lpszString, int nCount,
		       char *pszFontName1,int nFontSizeWidth,int nFontSizeHeight,
		       int isBold,int isItalic,COLORREF m_clrFill,COLORREF m_clrStroke,
		       int m_iRender,double angle,BOOL isWMode16)
{
	if(pszFontName1 == NULL || lpszString == NULL || nCount <= 0)
		return;

	angle = (float)(int)(angle+0.5);
	char pszFontName[200];
	strcpy(pszFontName,pszFontName1);

	CFont m_nFont,*pOldFont;
	LOGFONT sFont;
	memset(&sFont, 0, sizeof(LOGFONT));
	::GetObject(GetStockObject(SYSTEM_FONT),sizeof(LOGFONT),&sFont);
	sFont.lfHeight		= nFontSizeHeight;
	sFont.lfWidth		= abs(nFontSizeHeight-nFontSizeWidth)<4?0:nFontSizeWidth/2;
	sFont.lfItalic		= isItalic;
	sFont.lfWeight		= isBold?FW_BOLD:0;
	sFont.lfCharSet		= winCharSet;

	static CFontMapping fm;
	fm.GetFontName(pszFontName, pszFontName);
	//strcpy(pszFontName,"lr o");
	CString temptemp = (const unsigned short *)lpszString;
	//TRACE("%d\n",*(const unsigned short *)lpszString);
	//܂BwWindows 2000 Professional t
	int namelength = strlen(pszFontName);
	if(isWMode16)
	{
		if(pszFontName[0] == '@')
		{
			memmove(pszFontName,pszFontName+1,namelength);
			pszFontName[namelength] = 0;
		}
		unsigned char c0 = (unsigned char)lpszString[0];
		unsigned char c1 = (unsigned char)lpszString[1];
		if(IsSpecialCharacter(c0,c1))
		{//Symbol
			RotatedPoint(nFontSizeWidth,nFontSizeHeight,angle,&x,&y);
			memmove(pszFontName+1,pszFontName,namelength);
			pszFontName[0] = '@';
			pszFontName[namelength+1] = 0;
		}
	}
	else
	{
	}
//	RECT rect;
//	SetRect(&rect,x,y,x+nFontSizeWidth,y+nFontSizeHeight);
//	DrawLines(rect.left,rect.top,rect.right,rect.top,2,RGB(255,0,0),PS_SOLID);
//	DrawLines(rect.right,rect.top,rect.right,rect.bottom,2,RGB(255,0,0),PS_SOLID);
//	DrawLines(rect.right,rect.bottom,rect.left,rect.bottom,2,RGB(255,0,0),PS_SOLID);
//	DrawLines(rect.left,rect.bottom,rect.left,rect.top,2,RGB(255,0,0),PS_SOLID);

	namelength = strlen(pszFontName);
	if(namelength >= 2 && pszFontName[0] == '@')
	{
		sFont.lfEscapement	= 2700;
		sFont.lfOrientation	= 2700;
	}
	// kaku
	int angle1 = (int)(angle*10+sFont.lfEscapement+0.5);
	if(angle1 < 0)
		angle1 += 3600;
	else if(angle1 >= 3600)
		angle1 -= 3600;
	sFont.lfEscapement = sFont.lfOrientation = angle1;

	strcpy(sFont.lfFaceName,pszFontName);
	if(!m_nFont.CreateFontIndirect(&sFont))
	{
		strcpy(sFont.lfFaceName,fm.GetDefaultFontName());
		if(!m_nFont.CreateFontIndirect(&sFont))
			return;
	}

	if(lpCurrentPage)
	{
		LPSCONTENT	m_nContent;
		m_nContent = new SCONTENT;
		if(m_nContent == NULL)
			return;
		m_nContent->m_type = PDF_TEXT;
		m_nContent->m_Codes = new STEXT;
		
		STEXT	&m_nText = *m_nContent->m_Codes;
		m_nText.x	   = x;
		m_nText.y	   = y;
		//m_nText.szCode	   = lpszString;
		m_nText.szCode.resize(nCount*2+1);
		memcpy(m_nText.szCode.begin(),lpszString,nCount*2);
		m_nText.nCount	   = nCount;
		m_nText.szFontName = sFont.lfFaceName;
		m_nText.nFontWidth  = nFontSizeWidth;
		m_nText.nFontHeight = nFontSizeHeight;
		m_nText.m_bIsBold  = isBold;
		m_nText.m_bIsItalic= isItalic;
		m_nText.m_dAngle   = angle1;
		m_nText.color	   = m_clrFill;
		m_nText.style	   = 0;
		lpCurrentPage->m_pageBlock.push_back(m_nContent);
	}
	else if(1)//kaku
	{
		CDC		compDC;
		CBitmap		*pOldBmp;
		compDC.CreateCompatibleDC(NULL);
		pOldBmp	= compDC.SelectObject((CBitmap*)this);
		pOldFont = compDC.SelectObject(&m_nFont);
		COLORREF oldcolor = compDC.SetTextColor(m_clrFill);
		int oldmode = compDC.SetBkMode(TRANSPARENT);
		compDC.SetTextAlign(TA_BASELINE|TA_LEFT|TA_NOUPDATECP);
		//compDC.SetTextAlign(TA_BASELINE|TA_CENTER|TA_NOUPDATECP);
		compDC.SetMapMode(MM_TEXT);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);

		//ĵǰ
		switch(m_iRender)
		{
		case 0://fill text
			::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
			break;
		case 1://stroke text
			{
				CBrush br(RGB(255,255,255));
				CBrush *pOldBrush = compDC.SelectObject(&br);
				CPen pen(PS_SOLID, 1, m_clrStroke);
				CPen *pOldPen = compDC.SelectObject(&pen);

				compDC.BeginPath();
				::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
				compDC.EndPath();
				//·
				compDC.StrokeAndFillPath();

				compDC.SelectObject(pOldPen);
				compDC.SelectObject(pOldBrush);
				break;
			}
		case 2://fill and stroke text
			{
				//ĵǰˢ
				CBrush br(m_clrFill);
				CBrush *pOldBrush = compDC.SelectObject(&br);
				CPen pen(PS_SOLID, 2, m_clrStroke);
				CPen *pOldPen = compDC.SelectObject(&pen);

				compDC.BeginPath();
				::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
				compDC.EndPath();
				//·
				compDC.StrokeAndFillPath();

				compDC.SelectObject(pOldPen);
				compDC.SelectObject(pOldBrush);
				break;
			}
		case 3://invisible
				break;
		case 4://Fill text and add it to the clipping path
			{
				//ĵǰˢ
				CBrush br(HS_HORIZONTAL,m_clrFill);
				CBrush *pOldBrush = compDC.SelectObject(&br);
				CPen pen(PS_SOLID, 1, m_clrFill);
				CPen *pOldPen = compDC.SelectObject(&pen);

				compDC.BeginPath();
				::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
				compDC.EndPath();
				//·
				compDC.StrokeAndFillPath();

				compDC.SelectObject(pOldPen);
				compDC.SelectObject(pOldBrush);
				break;
			}
		case 5://Stroke text and add it to the clipping path
			{
				//ĵǰˢ
				CBrush br(HS_HORIZONTAL,RGB(255,255,255));
				CBrush *pOldBrush = compDC.SelectObject(&br);
				CPen pen(PS_SOLID, 1, m_clrStroke);
				CPen *pOldPen = compDC.SelectObject(&pen);

				compDC.BeginPath();
				::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
				compDC.EndPath();
				//·
				compDC.StrokeAndFillPath();

				compDC.SelectObject(pOldPen);
				compDC.SelectObject(pOldBrush);
				break;
			}
		case 6://Fill then stroke text and add it to the clipping path
			{
				//ĵǰˢ
				CBrush br(HS_HORIZONTAL,m_clrFill);
				CBrush *pOldBrush = compDC.SelectObject(&br);
				CPen pen(PS_SOLID, 1, m_clrStroke);
				CPen *pOldPen = compDC.SelectObject(&pen);

				compDC.BeginPath();
				::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
				compDC.EndPath();
				//·
				compDC.StrokeAndFillPath();

				compDC.SelectObject(pOldPen);
				compDC.SelectObject(pOldBrush);
				break;
			}
		case 7://Add text to the clipping path
			break;
		}

		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);
		compDC.SetBkMode(oldmode);
		compDC.SetTextColor(oldcolor);
		compDC.SelectObject(pOldFont);
		compDC.SelectObject(pOldBmp);
	}
	else
	{
		if(angle == 0.0)
		{
			CDC		compDC;
			CBitmap		*pOldBmp;
			compDC.CreateCompatibleDC(NULL);
			pOldBmp	= compDC.SelectObject((CBitmap*)this);
			pOldFont = compDC.SelectObject(&m_nFont);
			COLORREF oldcolor = compDC.SetTextColor(m_clrFill);
			int oldmode = compDC.SetBkMode(TRANSPARENT);
			if(m_hClipRegion)
				::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
			compDC.SetMapMode(MM_TEXT);
			//::TextOut(compDC.m_hDC,x,y,lpszString,nCount);
			::TextOutW(compDC.m_hDC,x,y,(const unsigned short *)lpszString,nCount);
			
			if(m_hClipRegion)
				::SelectClipRgn(compDC.m_hDC,NULL);
			compDC.SetBkMode(oldmode);
			compDC.SetTextColor(oldcolor);
			compDC.SelectObject(pOldFont);
			compDC.SelectObject(pOldBmp);
		}
		else
		{//ȡתͼ
			CDC	fontDC;
			CBitmap	fontBmp,*pFontBmp;
			fontDC.CreateCompatibleDC(NULL);
			int depth = fontDC.GetDeviceCaps(BITSPIXEL);
			pOldFont = fontDC.SelectObject(&m_nFont);
			COLORREF oldcolor = fontDC.SetTextColor(m_clrFill);
			int oldmode = fontDC.SetBkMode(TRANSPARENT);
			SIZE	fontSize;
			GetTextExtentPoint32W(fontDC.m_hDC,(const unsigned short *)lpszString,nCount,&fontSize);
			
			fontBmp.CreateBitmap(fontSize.cx,fontSize.cy,1,depth,NULL);
			pFontBmp = fontDC.SelectObject(&fontBmp);
			
			RECT rect;
			SetRect(&rect,0,0,fontSize.cx,fontSize.cy);
			fontDC.FillSolidRect(&rect, RGB(255,255,255));
			fontDC.SetMapMode(MM_TEXT);
			//fontDC.TextOut(0,0,lpszString,nCount);
			::TextOutW(fontDC.m_hDC,0,0,(const unsigned short *)lpszString,nCount);
			
			fontDC.SetBkMode(oldmode);
			fontDC.SetTextColor(oldcolor);
			fontDC.SelectObject(pOldFont);
			fontDC.SelectObject(pFontBmp);
			
			//The fontBmp is source text Bitmap
			double _angle = (float)RADIAN(angle);
			HBITMAP hRotatedBmp = NULL;
			if(angle == 0.0)
			{
				hRotatedBmp = HBITMAP(fontBmp);
			}
			else
			{
				hRotatedBmp = GetRotatedBitmap(HBITMAP(fontBmp),_angle,RGB(255,255,255));
				fontBmp.DeleteObject();
			}
			BITMAP bm;
			::GetObject( hRotatedBmp, sizeof( bm ), &bm );
#if 1//ת͸
			CBmpProc pRotateBmp;
			pRotateBmp.Attach(hRotatedBmp);
			{
				CDC		compDC;
				CBitmap		*pOldBmp;
				compDC.CreateCompatibleDC(NULL);
				pOldBmp	= compDC.SelectObject((CBitmap*)this);
				
				if(m_hClipRegion)
					::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
				
				CRect m_rcDest(x,y,x+bm.bmWidth,y+bm.bmHeight);
				//CRect m_rcDest(x,y,x+nFontSizeWidth,y+nFontSizeHeight);
				pRotateBmp.DrawTransparentInRect(compDC,CBPCOLOR_WHITE,&m_rcDest);
				if(m_hClipRegion)
					::SelectClipRgn(compDC.m_hDC,NULL);
				
				compDC.SelectObject(pOldBmp);
				compDC.DeleteDC();
			}
#else
			CBitmap *pRotateBmp = CBitmap::FromHandle(hRotatedBmp);
			pFontBmp = fontDC.SelectObject(pRotateBmp);
			{
				CDC		compDC;
				CBitmap		*pOldBmp;
				compDC.CreateCompatibleDC(NULL);
				pOldBmp	= compDC.SelectObject((CBitmap*)this);
				
				if(m_hClipRegion)
					::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
				compDC.BitBlt(x,y,bm.bmWidth,bm.bmHeight,&fontDC,0,0,SRCCOPY);
				if(m_hClipRegion)
					::SelectClipRgn(compDC.m_hDC,NULL);
				
				compDC.SelectObject(pOldBmp);
				compDC.DeleteDC();
			}
			fontDC.SelectObject(pFontBmp);
#endif
			fontDC.DeleteDC();
			::DeleteObject(hRotatedBmp);
		}
	}
}
void CBmpProc::DrawImage(int bitcount,COLORREF m_maskColor,
			 int width,int height,LPBYTE pData,
			 int x0,int y0,int w1,int h1,LPSTEXT  pText
			 )
{
	if(pData == NULL)
		return;

	typedef struct _tagBITMAPINFO {
		BITMAPINFOHEADER    bmiHeader;
		RGBQUAD             bmiColors[256];
	} _BITMAPINFO;
	BITMAPINFOHEADER ImageAttrib = {
		sizeof(BITMAPINFOHEADER),
			0,
			1,
			1,
			24,
			BI_RGB,
			0,
			0,
			0,
			0,
			0
	};
	ImageAttrib.biWidth = width;
	ImageAttrib.biHeight = height;
	ImageAttrib.biBitCount = bitcount;

	_BITMAPINFO	nBmpInfo;
	nBmpInfo.bmiHeader = ImageAttrib;
	{
		//ɫ
		nBmpInfo.bmiColors[0].rgbRed		= 255;
		nBmpInfo.bmiColors[0].rgbGreen		= 255;
		nBmpInfo.bmiColors[0].rgbBlue		= 255;
		nBmpInfo.bmiColors[0].rgbReserved	= 0;
		//ǰɫ
		nBmpInfo.bmiColors[1].rgbRed		= GetRValue(m_maskColor);
		nBmpInfo.bmiColors[1].rgbGreen		= GetGValue(m_maskColor);
		nBmpInfo.bmiColors[1].rgbBlue		= GetBValue(m_maskColor);
		nBmpInfo.bmiColors[1].rgbReserved	= 0;
	}
	if(lpCurrentPage)
	{
		LPSCONTENT	m_nContent;
		m_nContent = new SCONTENT;
		if(m_nContent == NULL)
			return;
		m_nContent->m_type = PDF_IMAGE;
		m_nContent->m_Images = new SIMAGE;

		SIMAGE	&m_nImage = *m_nContent->m_Images;
		memcpy(&m_nImage.nBitmapInfo,&nBmpInfo,sizeof(_BITMAPINFO));
		m_nImage.x	= x0;
		m_nImage.y	= y0;
		m_nImage.cx	= w1;
		m_nImage.cy	= h1;
		if(pText)
		{
			m_nImage.m_bIsText = 1;
			m_nImage.m_nImageText = *pText;
		}
		else
			m_nImage.m_bIsText = 0;
		int imgbytes = (width*bitcount+31)/32*4*height;
		m_nImage.pData.resize(imgbytes);
		memcpy(m_nImage.pData.begin(),pData,imgbytes);
		lpCurrentPage->m_pageBlock.push_back(m_nContent);
	}
	else
	{
#if	1//͸ͼ
		CDC		compDC;
		CBmpProc	*pOldBmp,m_srcbitmap;
		compDC.CreateCompatibleDC(NULL);
		m_srcbitmap.CreateCompatible(w1,h1,&compDC);

		pOldBmp	= (CBmpProc*)compDC.SelectObject(&m_srcbitmap);
		::StretchDIBits(compDC.m_hDC,0,0,w1,h1,0,0,width,height,pData,
			(BITMAPINFO*)&nBmpInfo,DIB_RGB_COLORS,SRCCOPY);
		compDC.SelectObject(pOldBmp);

		pOldBmp = (CBmpProc*)compDC.SelectObject((CBitmap*)this);
		CRect  crDest(x0,y0,x0+w1,y0+h1);
		CRect  crSou (0,0,w1,h1);

		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
		m_srcbitmap.DrawTransparentInRect(compDC,CBPCOLOR_WHITE,&crDest,&crSou);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);

		compDC.SelectObject(pOldBmp);
#else
		CDC		compDC;
		CBitmap		*pOldBmp;
		compDC.CreateCompatibleDC(NULL);
		pOldBmp = compDC.SelectObject((CBitmap*)this);
		
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,m_hClipRegion);
		::StretchDIBits(compDC.m_hDC,x0,y0,w1,h1,0,0,width,height,pData,
			(BITMAPINFO*)&nBmpInfo,DIB_RGB_COLORS,SRCCOPY);
		if(m_hClipRegion)
			::SelectClipRgn(compDC.m_hDC,NULL);

		compDC.SelectObject(pOldBmp);
#endif
	}
}
void CBmpProc::ChangeClipRegion(HRGN hClipRgn)
{
	if(lpCurrentPage)
	{
		LPSCONTENT	m_nContent;
		m_nContent = new SCONTENT;
		if(m_nContent == NULL)
			return;
		m_nContent->m_type = PDF_CLIPPINGRGN;

		if(hClipRgn == NULL)
		{
			m_nContent->m_ClippingRgn = NULL;
			lpCurrentPage->m_pageBlock.push_back(m_nContent);
		}
		else
		{
			m_nContent->m_ClippingRgn = new SCLIPPINGRGN;
			SCLIPPINGRGN &m_nClippingRgn = *m_nContent->m_ClippingRgn;
			int length = ::GetRegionData(hClipRgn,0,NULL);
			if(length <= 0)
				return;
			m_nClippingRgn.m_aryClipRegion.resize(length);
			::GetRegionData(hClipRgn,length,(LPRGNDATA)m_nClippingRgn.m_aryClipRegion.begin());
			lpCurrentPage->m_pageBlock.push_back(m_nContent);
		}
	}
}