// RasterImage.cpp : implementation file
//

#include "stdafx.h"
#include "win_pdf2htm.h"
#include "RasterImage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRasterImage property page

IMPLEMENT_DYNCREATE(CRasterImage, CPropertyPage)

CRasterImage::CRasterImage() : CPropertyPage(CRasterImage::IDD)
{
	//{{AFX_DATA_INIT(CRasterImage)
	m_szJPEGQuality = _T("");
	m_bGrayscale = FALSE;
	m_iJPGQuality = 75;
	//}}AFX_DATA_INIT
}

CRasterImage::~CRasterImage()
{
}

void CRasterImage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRasterImage)
	DDX_Control(pDX, IDC_SLIDER_JPEGQUALITY, m_ctrlJPEGQuality);
	DDX_Text(pDX, IDC_STATIC_JPEGQUALITY, m_szJPEGQuality);
	DDX_Check(pDX, IDC_CHECK_GRAYSCALE, m_bGrayscale);
	DDX_Slider(pDX, IDC_SLIDER_JPEGQUALITY, m_iJPGQuality);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRasterImage, CPropertyPage)
	//{{AFX_MSG_MAP(CRasterImage)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRasterImage message handlers

void CRasterImage::OnOK() 
{
	UpdateData();
	AfxGetApp()->WriteProfileInt("CRasterImage","m_iJPGQuality",m_iJPGQuality);
	AfxGetApp()->WriteProfileInt("CRasterImage","m_bGrayscale",m_bGrayscale);
	
	CPropertyPage::OnOK();
}

BOOL CRasterImage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_iJPGQuality = AfxGetApp()->GetProfileInt("CRasterImage","m_iJPGQuality",m_iJPGQuality);
	m_bGrayscale = AfxGetApp()->GetProfileInt("CRasterImage","m_bGrayscale",m_bGrayscale);
	m_szJPEGQuality.Format("%d%%",m_iJPGQuality);

	m_ctrlJPEGQuality.SetRange(1,100,TRUE);
	m_ctrlJPEGQuality.SetPos(m_iJPGQuality);

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRasterImage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateData();
	CSliderCtrl *pSliderCtrl = (CSliderCtrl *)pScrollBar;
	if(pSliderCtrl == &m_ctrlJPEGQuality)
		m_szJPEGQuality.Format("%d%%",m_iJPGQuality);
	UpdateData(FALSE);
	
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}
