//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "config.h"
#include "pdfrlib.h"
#include "BmpProc.h"

extern BOOL m_bForceContinuePages;
extern POINT m_pointLastPage;
//ͳ
extern vector<STEXT>	m_aryFont;
void __DrawLines(CDC *pDC,int x0, int y0, int x1, int y1,int width,
			 COLORREF color,int style)
{
	LOGBRUSH	logbrush;
	logbrush.lbColor = color;
	logbrush.lbHatch = 0;
	logbrush.lbStyle = BS_SOLID;
	HPEN m_pen_1 = ::ExtCreatePen(
		style|PS_GEOMETRIC|PS_JOIN_MITER|PS_ENDCAP_FLAT,
		width,
		&logbrush,NULL,NULL);
	CPen *m_pen = CPen::FromHandle(m_pen_1);
	CPen *oldpen = pDC->SelectObject(m_pen);
	
	pDC->MoveTo(x0,y0);
	pDC->LineTo(x1,y1);
	
	pDC->SelectObject(oldpen);

	::DeleteObject(m_pen_1);
}
void __FillPolygon(CDC *pDC,POINT* points,int npoints,int shape,int mode,
			   int width,COLORREF color)
{
	if(points == NULL || npoints <= 0)
		return;

	CBrush m_Brush;
	m_Brush.CreateSolidBrush(color);
	
	CRgn m_nPolygon;
	m_nPolygon.CreatePolygonRgn(points,npoints,mode);
	
	pDC->FillRgn(&m_nPolygon,&m_Brush);
	
	m_nPolygon.DeleteObject();
}

void __TextOut(CDC *pDC,int x, int y, const char* lpszString, int nCount,
		       const char *pszFontName,int nFontWidth,int nFontHeight,
		       int isBold,int isItalic,COLORREF m_color,
		       int angle,BOOL IsNoText)
{
	if(pszFontName == NULL || lpszString == NULL || nCount <= 0)
		return;

	//ıֻͼתΪͼ
	if(IsNoText && angle == 0)
		return;
	CFont m_nFont,*pOldFont;
	LOGFONT sFont;
	memset(&sFont, 0, sizeof(LOGFONT));

	sFont.lfHeight		= nFontHeight;
	sFont.lfWidth		= nFontHeight==nFontWidth?0:nFontWidth/2;
	sFont.lfItalic		= isItalic;
	sFont.lfWeight		= isBold?FW_BOLD:0;
	sFont.lfEscapement = sFont.lfOrientation = angle;
	sFont.lfCharSet		= DEFAULT_CHARSET;
	strcpy(sFont.lfFaceName,pszFontName);
	if(!m_nFont.CreateFontIndirect(&sFont))
	{
		strcpy(sFont.lfFaceName,"Arial");
		if(!m_nFont.CreateFontIndirect(&sFont))
			return;
	}

	pOldFont = pDC->SelectObject(&m_nFont);
	COLORREF oldcolor = pDC->SetTextColor(m_color);
	int oldmode = pDC->SetBkMode(TRANSPARENT);
	
	UINT oldAlign = pDC->SetTextAlign(TA_BASELINE|TA_LEFT|TA_NOUPDATECP);
	int oldmap = pDC->SetMapMode(MM_TEXT);

	::TextOutW(pDC->m_hDC,x,y,(const unsigned short *)lpszString,nCount);

	pDC->SetMapMode(oldmap);
	pDC->SetTextAlign(oldAlign);
	pDC->SetBkMode(oldmode);
	pDC->SetTextColor(oldcolor);
	pDC->SelectObject(pOldFont);
}
void __DrawImage(CDC *pDC, LPBITMAPINFO2 pBitmapInfo,LPBYTE pData,int x0,int y0,int w1,int h1)
{
	//::SelectClipRgn(pDC->m_hDC,NULL);

	CDC		compDC;
	CBmpProc	*pOldBmp,m_srcbitmap;
	compDC.CreateCompatibleDC(NULL);
	m_srcbitmap.CreateCompatible(w1,h1,&compDC);

	pOldBmp	= (CBmpProc*)compDC.SelectObject(&m_srcbitmap);
	compDC.SetStretchBltMode(COLORONCOLOR);
	::StretchDIBits(compDC.m_hDC,0,0,w1,h1,
		0,0,pBitmapInfo->bmiHeader.biWidth,pBitmapInfo->bmiHeader.biHeight,
		pData,(BITMAPINFO*)pBitmapInfo,DIB_RGB_COLORS,SRCCOPY);
	compDC.SelectObject(pOldBmp);

	CRect  crDest(x0,y0,x0+w1,y0+h1);
	CRect  crSou (0,0,w1,h1);

	m_srcbitmap.DrawTransparentInRect(*pDC,CBPCOLOR_WHITE,&crDest,&crSou);
}
void DrawObjects(CDC *pDC,LPSPAGE ptrPage)
{
	::SelectClipRgn(pDC->m_hDC,NULL);

	if(ptrPage)
	{
		int nsize = ptrPage->m_pageBlock.size();
		for(int i = 0; i < nsize; i++)
		{
			switch(ptrPage->m_pageBlock[i]->m_type)
			{
			case PDF_CLIPPINGRGN:
				{
					if(ptrPage->m_pageBlock[i]->m_ClippingRgn == NULL)
					{
						::SelectClipRgn(pDC->m_hDC,NULL);
					}
					else
					{
						SCLIPPINGRGN &m_ClipRegion = *ptrPage->m_pageBlock[i]->m_ClippingRgn;
						int length = m_ClipRegion.m_aryClipRegion.size();
						if(length >= 0)
						{
							HRGN m_hClipRegion = ::ExtCreateRegion(
								NULL,length,(LPRGNDATA)m_ClipRegion.m_aryClipRegion.begin()
								);
							if(m_hClipRegion)
								::SelectClipRgn(pDC->m_hDC,m_hClipRegion);
							DeleteObject(m_hClipRegion);
						}
					}
					break;
				}
			case PDF_TEXT:
				{
					STEXT &m_Codes = *ptrPage->m_pageBlock[i]->m_Codes;
					__TextOut(pDC,
						m_Codes.x,
						m_Codes.y,
						m_Codes.szCode.c_str(),
						m_Codes.nCount,
						m_Codes.szFontName.c_str(),
						m_Codes.nFontWidth,
						m_Codes.nFontHeight,
						m_Codes.m_bIsBold,
						m_Codes.m_bIsItalic,
						m_Codes.color,
						m_Codes.m_dAngle,
						TRUE
						);
				}
				break;
			case PDF_IMAGE:
				{
					SIMAGE	&m_Images = *ptrPage->m_pageBlock[i]->m_Images;
					__DrawImage(pDC,
						&m_Images.nBitmapInfo,
						m_Images.pData.begin(),
						m_Images.x,
						m_Images.y,
						m_Images.cx,
						m_Images.cy
						);
				}
				break;
			case PDF_LINE:
				{
					SLINE	&m_Lines = *ptrPage->m_pageBlock[i]->m_Lines;
					__DrawLines(pDC,
						m_Lines.x0, 
						m_Lines.y0,
						m_Lines.x1,
						m_Lines.y1,
						m_Lines.width,
						m_Lines.color,
						m_Lines.style
						);
				}
				break;
			case PDF_POLYGON:
				{
					SPOLYGON &m_Polygons = *ptrPage->m_pageBlock[i]->m_Polygons;
					__FillPolygon(pDC,
						m_Polygons.pots.begin(),
						m_Polygons.pots.size(),
						m_Polygons.shape,
						m_Polygons.mode,
						m_Polygons.width,
						m_Polygons.color
						);
				}
				break;
			}
		}
	}
}
VOID	WINAPI 	DeleteUnusePageObject(LPSPAGE lpPageObj)
{
	if(lpPageObj)
	{
		for(int i = 0; i < lpPageObj->m_pageBlock.size(); i++)
		{
			switch(lpPageObj->m_pageBlock[i]->m_type)
			{
			case PDF_TEXT:
				{
					break;
				}
			case PDF_IMAGE:
				{
					if(lpPageObj->m_pageBlock[i]->m_Images)
						delete lpPageObj->m_pageBlock[i]->m_Images;
					delete lpPageObj->m_pageBlock[i];
					lpPageObj->m_pageBlock.erase(lpPageObj->m_pageBlock.begin()+i);
					i--;
					break;
				}
			case PDF_LINE:
				{
					if(lpPageObj->m_pageBlock[i]->m_Lines)
						delete lpPageObj->m_pageBlock[i]->m_Lines;
					delete lpPageObj->m_pageBlock[i];
					lpPageObj->m_pageBlock.erase(lpPageObj->m_pageBlock.begin()+i);
					i--;
					break;
				}
			case PDF_POLYGON:
				{
					if(lpPageObj->m_pageBlock[i]->m_Polygons)
						delete lpPageObj->m_pageBlock[i]->m_Polygons;
					delete lpPageObj->m_pageBlock[i];
					lpPageObj->m_pageBlock.erase(lpPageObj->m_pageBlock.begin()+i);
					i--;
					break;
				}
			case PDF_CLIPPINGRGN:
				{
					if(lpPageObj->m_pageBlock[i]->m_ClippingRgn)
						delete lpPageObj->m_pageBlock[i]->m_ClippingRgn;
					delete lpPageObj->m_pageBlock[i];
					lpPageObj->m_pageBlock.erase(lpPageObj->m_pageBlock.begin()+i);
					i--;
					break;
				}
			}
		}
	}
}

void WriteToHtmlFile(LPSPAGE ptrPage,LPARY_HTMLINK m_pHtmLink,
		     CString strHtmName, CString strImageName)
{
	if(!m_bForceContinuePages)
	{
		m_aryFont.clear();
	}
	DeleteUnusePageObject(ptrPage);
	int nsize = ptrPage->m_pageBlock.size();
	for(int i = 0; i < nsize; i++)
	{
		if(ptrPage->m_pageBlock[i]->m_type == PDF_TEXT)
		{
			STEXT &m_Codes = *ptrPage->m_pageBlock[i]->m_Codes;
			if(m_Codes.m_dAngle != 0)
				continue;

			BOOL	bFound = FALSE;
			for(int iii = 0; iii < m_aryFont.size(); iii++)
			{
				//СȷΨһ
//2004-03-14
				if(//m_aryFont[iii].nFontWidth == m_Codes.nFontWidth && 
					m_aryFont[iii].nFontHeight == m_Codes.nFontHeight && 
					m_aryFont[iii].szFontName == m_Codes.szFontName
					&& m_aryFont[iii].color == m_Codes.color
					&& m_aryFont[iii].m_bIsItalic == m_Codes.m_bIsItalic
					&& m_aryFont[iii].m_bIsBold == m_Codes.m_bIsBold
					)
				{
					bFound = TRUE;
					break;
				}
			}
			if(!bFound)
				m_aryFont.push_back(m_Codes);
		}
	}
	FILE	*m_pFile = NULL;
	if(m_bForceContinuePages)
	{
		char path_buffer[_MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_PATH];
		char ext[_MAX_EXT];
		_splitpath(strHtmName, drive, dir, fname, ext );
		_makepath(path_buffer,drive, dir,"index",".htm");
		//дļͷ
		m_pFile = fopen(path_buffer,"a");
	}
	else
		m_pFile = fopen(strHtmName,"w");
	if(m_pFile == NULL)
	{
		CString errormsg;
		errormsg = "Create file error [";
		errormsg += strHtmName;
		errormsg += "]!";
		AfxMessageBox(errormsg);
		return;
	}
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(strHtmName, drive, dir, fname, ext );

	fprintf(m_pFile,"%s","<html>\n<head>\n<title>");
	fprintf(m_pFile,"%s",fname);
	fprintf(m_pFile,"%s","</title>\n\n");
	//fputs("<meta http-equiv=\"page-enter\" content=\"revealtrans(duration=1, transition=5)\">\n",m_pFile);
	//fputs("<meta http-equiv=\"page-exit\" content=\"revealtrans(duration=1, transition=5)\">\n",m_pFile);
	fputs("<script language=\"javascript\"> \n\
<!-- hide \n\
function killerrors() { \n\
return true; \n\
} \n\
window.onerror = killerrors; \n\
// --> \n\
</script>\n",m_pFile);
	fprintf(m_pFile,"%s","<style type=\"text/css\">\n<!--\n");
	//дļ
	for(int iii = 0; iii < m_aryFont.size(); iii++)
	{
		//.ft0{font-size:27px;font-family:Times;color:#000000;}
		CString m_strFontAttrib;
		m_strFontAttrib.Format(
			".ft%d{font-style:%s;font-weight:%s;font-size:%dpx;font-family:%s;color:#%02x%02x%02x;}\n",
			iii,
			m_aryFont[iii].m_bIsItalic?"italic":"normal",
			m_aryFont[iii].m_bIsBold?"bold":"normal",
//2004-03-14
			//m_aryFont[iii].nFontWidth,
			m_aryFont[iii].nFontHeight,
			m_aryFont[iii].szFontName.c_str(),
			GetRValue(m_aryFont[iii].color),
			GetGValue(m_aryFont[iii].color),
			GetBValue(m_aryFont[iii].color)
			);
		fprintf(m_pFile,"%s",m_strFontAttrib);
	}
	COLORREF m_clBackground = AfxGetApp()->GetProfileInt("CHTMLPage","m_clBackground",RGB(255,255,255));
	fprintf(m_pFile,"-->\n</style>\n</head>\n<body vlink=\"#FFFFFF\" link=\"#FFFFFF\" bgcolor=\"#%02x%02x%02x\">\n",
		GetRValue(m_clBackground),GetGValue(m_clBackground),GetBValue(m_clBackground));
	fputs("\n\
<script language=\"JavaScript\">\n\
var currentpos,timer; \n\
function initialize() \n\
{ \n\
timer=setInterval(\"scrollwindow()\",10);\n\
} \n\
function sc(){\n\
clearInterval(timer); \n\
}\n\
function scrollwindow() \n\
{ \n\
currentpos=document.body.scrollTop; \n\
window.scroll(0,++currentpos); \n\
if (currentpos != document.body.scrollTop) \n\
sc();\n\
} \n\
document.onmousedown=sc\n\
document.ondblclick=initialize\n\
</script>\n",m_pFile);

	//<div style="position:absolute;top:0;left:0"><img width="359" height="362" src="f:\xuehenghengheng.htm-2_1.bmp"></div>
	//дͼͼ
	SIZE size;
	size.cx = ptrPage->m_Width;
	size.cy = ptrPage->m_Height;

	_splitpath( strImageName, drive, dir, fname, ext );
	strImageName = fname;
	strImageName += ext;
   
	CString m_strImage;
	int nlinksize = 0;
	if(m_pHtmLink && m_bForceContinuePages == FALSE)
		nlinksize = m_pHtmLink->size();

	if(nlinksize <= 0)
		m_strImage.Format("<div style=\"position:absolute;top:%d;left:0\"><img width=\"%d\" height=\"%d\" src=\"%s\"></div>\n",
			m_pointLastPage.y, size.cx,size.cy,strImageName);
	else
	{
		m_strImage.Format("<div style=\"position:absolute;top:%d;left:0\"><map name=\"FPMap0\">\n",
			m_pointLastPage.y);
		CString temp;
		for(int i = 0; i < nlinksize; i++)
		{
			CRect rect;
			SetRect(&rect,(*m_pHtmLink)[i].xMin,
				m_pointLastPage.y+(*m_pHtmLink)[i].yMin,
				(*m_pHtmLink)[i].xMax,
				m_pointLastPage.y+(*m_pHtmLink)[i].yMax
				);
			CString m_strGotoPage;
			m_strGotoPage = (*m_pHtmLink)[i].szDest.c_str();
			if(m_strGotoPage.Left(strlen("actionGoTo:")) == "actionGoTo:")
			{
				m_strGotoPage.Replace("actionGoTo:",NULL);
				int m_iGotoPage = atoi(m_strGotoPage);

				char drive[_MAX_DRIVE];
				char dir[_MAX_DIR];
				char fname[_MAX_PATH];
				char ext[_MAX_EXT];
				_splitpath(strHtmName, drive, dir, fname, ext );

				CString m_strHtmlFile;
				m_strHtmlFile.Format("pg_%04d%s",m_iGotoPage,ext);
				m_strGotoPage = m_strHtmlFile;
			}
			else if(m_strGotoPage.Left(strlen("actionURI:")) == "actionURI:")
			{
				m_strGotoPage.Replace("actionURI:",NULL);
			}
			temp.Format("<area href=\"%s\" shape=\"rect\" coords=\"%d,%d,%d,%d\">\n",
				m_strGotoPage,rect.left,rect.top,rect.right,rect.bottom);
			m_strImage += temp;
		}
		m_strImage += "</map>\n";
		temp.Format("<img width=\"%d\" height=\"%d\" src=\"%s\" usemap=\"#FPMap0\"></div>\n",
			size.cx,size.cy,strImageName);
		m_strImage += temp;
	}
	//BOOL m_bForceContinuePages = AfxGetApp()->GetProfileInt("GenerateInOneHTMLPage","Flag",0);
	BOOL m_bRemovePics = AfxGetApp()->GetProfileInt("m_bRemovePics","Flag",0);
	if(!m_bForceContinuePages)
		fprintf(m_pFile,"%s",m_strImage);
	else if(!m_bRemovePics)
		fprintf(m_pFile,"%s",m_strImage);
	BOOL m_bAutoSpace = AfxGetApp()->GetProfileInt("PDF2HTM","CheckSpaces",1);

	//<div style="position:absolute;top:23;left:55"><nobr><span class="ft0">ʹõƬζˮֲⶨǵ</span></nobr></div>
	//дı
	STEXT m_LastCodes;
	memset(&m_LastCodes,0,sizeof(STEXT));
	char szCurDir[_MAX_PATH];
	GetModuleFileName(NULL, szCurDir, _MAX_PATH);
	CString t = szCurDir;
	int pos = t.ReverseFind('\\');
	CString strInitFileName = t.Left(pos+1) + "config.ini";
	int  m_uCharDistance = GetPrivateProfileInt("PDF2HTM","CharSpaces",50,strInitFileName);

	nsize = ptrPage->m_pageBlock.size();
	for(i = 0; i < nsize; i++)
	{
		if(ptrPage->m_pageBlock[i]->m_type == PDF_TEXT)
		{
			STEXT &m_Codes = *ptrPage->m_pageBlock[i]->m_Codes;
			if(m_Codes.m_dAngle != 0)
				continue;

			int m_iFound = -1;
			for(int iii = 0; iii < m_aryFont.size(); iii++)
			{
				//СȷΨһ
//2004-03-14
				if(//m_aryFont[iii].nFontWidth == m_Codes.nFontWidth && 
					m_aryFont[iii].nFontHeight == m_Codes.nFontHeight && 
					m_aryFont[iii].szFontName == m_Codes.szFontName
					&& m_aryFont[iii].color == m_Codes.color
					&& m_aryFont[iii].m_bIsBold == m_Codes.m_bIsBold
					&& m_aryFont[iii].m_bIsItalic == m_Codes.m_bIsItalic
					)
				{
					m_iFound = iii;
					break;
				}
			}
			if(m_iFound == -1)
				continue;
			fprintf(m_pFile,"<div style=\"position:absolute;top:%d;left:%d\"><nobr><span class=\"ft%d\">",
				m_pointLastPage.y + m_Codes.y-m_Codes.nFontHeight+2,m_Codes.x,m_iFound);

			BOOL writecharflag = TRUE;
			do
			{
				char buf[16];
				memset(buf,0,16);
				if(writecharflag)
				{
					if(m_Codes.x == m_LastCodes.x && m_Codes.y == m_LastCodes.y
						&& m_Codes.szCode == m_LastCodes.szCode)
					{
					}
					else
					{
						float space = m_LastCodes.nFontHeight;
						float ddd = m_Codes.x - (m_LastCodes.x+m_LastCodes.nFontWidth);
						int addSpace = (space == 0?0:ddd>0.15*space);
						m_LastCodes = m_Codes;
						int destCount = WideCharToMultiByte(CP_ACP,0,
							(const unsigned short *)m_Codes.szCode.c_str(),
							m_Codes.nCount,buf,16,
							NULL,NULL
							);
//						if(buf[0] == '?')
//							buf[0] = '.';
						{
							WORD dwCode = MAKEWORD(buf[1],buf[0]);
							switch(dwCode)
							{
							case 0xA1AE:
							case 0xA1AF:
								buf[0] = '\'';
								buf[1] = 0;
								break;
							case 0xA1A7:
							case 0xA1A8:
							case 0xA1B0:
							case 0xA1B1:
								buf[0] = '"';
								buf[1] = 0;
								break;
							}
						}
						if(m_bAutoSpace && addSpace)
							fputc(0x20,m_pFile);
						switch(buf[0])
						{
						case '<':
							fputs("&lt;",m_pFile);
							break;
						case '>':
							fputs("&gt;",m_pFile);
							break;
						case ' ':
							//fputs("&nbsp;",m_pFile);
							fputc(0x20,m_pFile);
							break;
						case '&':
							fputs("&amp;",m_pFile);
							break;
						case '"':
							fputs("&quot;",m_pFile);
							break;
						default:
							fputs(buf,m_pFile);
						}
					}
				}
				if(m_uCharDistance == 0)
					break;
				if(i+1 < nsize && ptrPage->m_pageBlock[i+1]->m_type == PDF_TEXT)
				{
					i++;
					STEXT &m_Codes1 = *ptrPage->m_pageBlock[i]->m_Codes;
					if(m_Codes1.m_dAngle != 0)
					{
						i--;
						break;
					}
					int distance = m_Codes1.x-m_Codes.x;//-m_Codes.nFontWidth;
					if(distance <= 0 || distance > m_uCharDistance)
					{
						i--;
						break;
					}
					int yy1 = m_Codes1.y-m_Codes1.nFontHeight+2;
					int yy  = m_Codes.y-m_Codes.nFontHeight+2;
//2004-03-14
					if(
						//m_Codes1.nFontWidth == m_Codes.nFontWidth && 
						m_Codes1.nFontHeight == m_Codes.nFontHeight && 
						m_Codes1.szFontName == m_Codes.szFontName
						&& m_Codes1.color == m_Codes.color
						&& abs(yy1-yy) < max(m_Codes1.nFontHeight,m_Codes.nFontHeight)
						&& m_Codes1.x > m_Codes.x
						)
					{
						WORD nCode1 = *(LPWORD)&m_Codes1.szCode[0];
						WORD nCode  = *(LPWORD)&m_Codes.szCode[0];
						m_Codes = m_Codes1;
						if(
							//ҪжӰЧص
							//(nCode1 == nCode && abs(m_Codes1.x-m_Codes.x) < 5))
							//|| 
							//ʼпո󣬲ҿոļرСʱո
							//(nCode1 == 0x20 && abs(m_Codes1.x+m_Codes1.nFontWidth-(m_Codes.x+m_Codes.nFontWidth)) < 2))
							0)
						{
							writecharflag = FALSE;
						}
						else
							writecharflag = TRUE;
					}
					else
					{
						i--;
						break;
					}
				}
				else
					break;
			}while(1);
			fputs("</span></nobr></div>\n",m_pFile);
		}
	}

	if(!m_bForceContinuePages)
	{
		fputs("<script language=\"javascript\">\n\
			var currentZoom = parent.ltop.currentZoom;\n\
			if(currentZoom != undefined)\n\
				document.body.style.zoom=currentZoom/100;\n\
			</script>\n",m_pFile);
	}
	fprintf(m_pFile,"%s","</body>\n</html>");
	fclose(m_pFile);
	//ShellExecute(NULL,"open",strHtmName,NULL,NULL,SW_SHOWNORMAL);
}
int NTSystemCommand(const char *command)
{
	char
		local_command[2048];
	
	DWORD
		child_status;
	
	int
		status;
	
	PROCESS_INFORMATION
		process_info;
	
	STARTUPINFO
		startup_info;
	
	unsigned int
		background_process;
	
	if (command == (char *) NULL)
		return(-1);
	GetStartupInfo(&startup_info);
	startup_info.dwFlags=STARTF_USESHOWWINDOW;
	startup_info.wShowWindow=SW_HIDE;
	(void) strcpy(local_command,command);
	background_process=command[strlen(command)-1] == '&';
	if (background_process)
		local_command[strlen(command)-1]='\0';
	if (command[strlen(command)-1] == '|')
		local_command[strlen(command)-1]='\0';
	else
		startup_info.wShowWindow=SW_HIDE;
	status=CreateProcess((LPCTSTR) NULL,local_command,
		(LPSECURITY_ATTRIBUTES) NULL,(LPSECURITY_ATTRIBUTES) NULL,(BOOL) FALSE,
		(DWORD) NORMAL_PRIORITY_CLASS,(LPVOID) NULL,(LPCSTR) NULL,&startup_info,
		&process_info);
	if (status == 0)
		return(-1);
	if (background_process)
		return(status == 0);
	status=WaitForSingleObject(process_info.hProcess,INFINITE);
	if (status != WAIT_OBJECT_0)
		return(status);
	status=GetExitCodeProcess(process_info.hProcess,&child_status);
	if (status == 0)
		return(-1);
	CloseHandle(process_info.hProcess);
	CloseHandle(process_info.hThread);
	return((int) child_status);
}
INT WINAPI PDF_ConvertToHtmlFile(LPSPAGE ptrPage,
				 LPARY_HTMLINK	m_pHtmLink,
				 LPCTSTR pszHtmlFile)
{
	if(ptrPage == NULL && pszHtmlFile == NULL)
		return -1;
	SIZE size;
	size.cx = ptrPage->m_Width;
	size.cy = ptrPage->m_Height;

	HDC m_hDC = ::GetDC(NULL);
	CDC *pDC = CDC::FromHandle(m_hDC);

	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(pszHtmlFile, drive, dir, fname, ext );

	char m_strBmpName[_MAX_PATH];
	_makepath(m_strBmpName,drive, dir,fname,".bmp");
	char m_strJpgName[_MAX_PATH];
	_makepath(m_strJpgName,drive, dir,fname,".jpg");

	CBmpProc	m_bmpSrc1;
	CBitmap		*pOldBmp;
	CDC		compDC;
	if(m_bmpSrc1.CreateCompatible(size.cx,size.cy,pDC))
	{
		compDC.CreateCompatibleDC(pDC);
		pOldBmp	= compDC.SelectObject(&m_bmpSrc1);

		CRect rect(0,0,size.cx,size.cy);
		//CBrush brush(RGB(255,255,255));
		COLORREF m_clBackground = AfxGetApp()->GetProfileInt("CHTMLPage","m_clBackground",RGB(255,255,255));
		CBrush brush(m_clBackground);

		compDC.FillRect(&rect,&brush);

		compDC.SetStretchBltMode(COLORONCOLOR);
		DrawObjects(&compDC,ptrPage);

		compDC.SelectObject(pOldBmp);

		m_bmpSrc1.Save(m_strBmpName,24);
	}
	ReleaseDC(NULL,m_hDC);

	int m_iJPGQuality = AfxGetApp()->GetProfileInt("CRasterImage","m_iJPGQuality",75);
	int m_bGrayscale = AfxGetApp()->GetProfileInt("CRasterImage","m_bGrayscale",0);
	//תJPGļ
	GetModuleFileName(NULL,path_buffer,_MAX_PATH);
	_splitpath(path_buffer, drive, dir, fname, ext );
	_makepath( path_buffer, drive, dir,"","");
	if(path_buffer[strlen(path_buffer)-1] != '\\')
		strcat(path_buffer,"\\");
	strcat(path_buffer,"jpeg.exe");

	CString m_strCommandLine;
	m_strCommandLine = path_buffer;
	m_strCommandLine += " -outfile ";
	m_strCommandLine += "\"";
	m_strCommandLine += m_strJpgName;
	m_strCommandLine += "\"";

	if(m_bGrayscale)
		m_strCommandLine += " -grayscale";
	if(m_iJPGQuality > 0 && m_iJPGQuality <= 100)
	{
		CString m_strQuality;
		m_strQuality.Format(" -quality %d",m_iJPGQuality);
		m_strCommandLine += m_strQuality;
	}
	m_strCommandLine += " ";
	m_strCommandLine += "\"";
	m_strCommandLine += m_strBmpName;
	m_strCommandLine += "\"";
	NTSystemCommand(m_strCommandLine);

	DeleteFile(m_strBmpName);
	//ΪHtmlʽ
	WriteToHtmlFile(ptrPage,m_pHtmLink,pszHtmlFile,m_strJpgName);

	if(m_bForceContinuePages)
	{
		m_pointLastPage.y += size.cy + 10;
	}
	return 1;
}
