//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "pdfrlib.h"

#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include "parseargs.h"
#include "GString.h"
#include "gmem.h"
#include "Object.h"
#include "Stream.h"
#include "Array.h"
#include "Dict.h"
#include "XRef.h"
#include "Catalog.h"
#include "Page.h"
#include "PDFDoc.h"
#include "PBMOutputDev.h"
#include "TextOutputDev.h"
#include "Error.h"
#include "config.h"
#include "BmpProc.h"

//BOOL APIENTRY DllMain( HANDLE hModule, 
//		      DWORD  ul_reason_for_call, 
//		      LPVOID lpReserved
//		      )
//{
//	return TRUE;
//}

///////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////
#define		VERSION		(float)(1.3)
#define		PRODECT_DATE	"20020108"
typedef struct SPDFCOREtag
{
	FLOAT		version;
	CHAR		szDate[16];
	PDFDoc		*doc;
	GString		*fileName;
	GString		*ownerPW, *userPW;
	INT		dpi;
	PBMOutputDev	*pbmOut;
}SPDFCORE,*LPSPDFCORE;

extern LPSPAGE		lpCurrentPage;
extern CBmpProc		m_hDIB;

BOOL CHECK_VALIDATE()
{
	return TRUE;
}


char szDllPathName[MAX_PATH];
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	return TRUE;
}

HPDF	WINAPI 	PDF_Open(LPCTSTR pszFileName,LPCTSTR pszOwnPass,LPCTSTR pszUserPass,INT dpi)
{
	GetModuleFileName(NULL,szDllPathName,MAX_PATH);
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	_splitpath(szDllPathName, drive, dir, fname, ext );
	_makepath( szDllPathName, drive, dir,"","");
	if(szDllPathName[strlen(szDllPathName)-1] != '\\')
		strcat(szDllPathName,"\\");

	if(CHECK_VALIDATE() == FALSE)
		return NULL;

	if(pszFileName == NULL || pszFileName[0] == NULL)
		return NULL;

	LPSPDFCORE lpPDFCore = new SPDFCORE;
	if(lpPDFCore == NULL)
		return NULL;
	lpPDFCore->version	= VERSION;
	lstrcpy(lpPDFCore->szDate,PRODECT_DATE);
	lpPDFCore->fileName	= new GString(pszFileName);
	lpPDFCore->dpi		= dpi;
	lpCurrentPage		= NULL;
	
	char *pbmRoot = "c:\\tmp";
	// init error file
	char szDllPathName2[MAX_PATH];
	strcpy(szDllPathName2,"config.lst");

	globalParams = new GlobalParams(szDllPathName2);
//		globalParams->setErrQuiet(quiet);
	// open PDF file
	if (pszOwnPass && pszOwnPass[0]) 
		lpPDFCore->ownerPW = new GString(pszOwnPass);
	else 
		lpPDFCore->ownerPW = NULL;
	if (pszUserPass && pszUserPass[0])
		lpPDFCore->userPW = new GString(pszUserPass);
	else 
		lpPDFCore->userPW = NULL;
	lpPDFCore->doc = new PDFDoc(lpPDFCore->fileName, lpPDFCore->ownerPW, lpPDFCore->userPW);
	if (!lpPDFCore->doc->isOk())
	{
		if (lpPDFCore->userPW)
			delete lpPDFCore->userPW;
		if (lpPDFCore->ownerPW)
			delete lpPDFCore->ownerPW;
		delete lpPDFCore->doc;
		delete lpPDFCore;
		return NULL;
	}
	lpPDFCore->pbmOut = PBMOutputDev::makePBMOutputDev(NULL, pbmRoot);
	lpPDFCore->pbmOut->startDoc(lpPDFCore->doc->getXRef());
	return (HPDF)lpPDFCore;
}
VOID	WINAPI 	PDF_Close(HPDF m_hPDF)
{
	LPSPDFCORE lpPDFCore = (LPSPDFCORE)m_hPDF;
	if(lpPDFCore == NULL || lpPDFCore->version != VERSION)
		return;

	PBMOutputDev::killPBMOutputDev(lpPDFCore->pbmOut);
	if (lpPDFCore->userPW)
		delete lpPDFCore->userPW;
	if (lpPDFCore->ownerPW)
		delete lpPDFCore->ownerPW;
	delete lpPDFCore->doc;
	delete lpPDFCore;
	delete globalParams;
	Object::memCheck(stderr);
	gMemReport(stderr);

	m_hDIB.Clear();
}

INT	WINAPI 	PDF_GetPageCount(HPDF m_hPDF)
{
	LPSPDFCORE lpPDFCore = (LPSPDFCORE)m_hPDF;
	if(lpPDFCore == NULL || lpPDFCore->version != VERSION)
		return -1;

	return lpPDFCore->doc->getNumPages();
}
BOOL	WINAPI PDF_GetBookmark(HPDF m_hPDF,LPSTR szFileName,INT size)
{
	LPSPDFCORE lpPDFCore = (LPSPDFCORE)m_hPDF;
	if(lpPDFCore == NULL || lpPDFCore->version != VERSION)
		return FALSE;
	if(szFileName == NULL || size <= 0)
		return FALSE;
	if(lpPDFCore->doc->getBookmark(szFileName,size) == gTrue)
		return TRUE;
	return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////
//
//
// ȡ߼Ԫصĺ
//
//
///////////////////////////////////////////////////////////////////////////////////
LPSPAGE	WINAPI 	PDF_GetPageObjectEx(HPDF m_hPDF,INT no)
{
	LPSPDFCORE lpPDFCore = (LPSPDFCORE)m_hPDF;
	if(lpPDFCore == NULL || lpPDFCore->version != VERSION)
		return NULL;

	if(no >= 1 && no <= lpPDFCore->doc->getNumPages())
	{
		lpCurrentPage = new SPAGE;
		lpCurrentPage->m_DPI		= lpPDFCore->dpi;
		lpPDFCore->pbmOut->DeleteAllLinks();
		lpPDFCore->doc->displayPage(lpPDFCore->pbmOut, no, lpPDFCore->dpi,0,gTrue);
		lpCurrentPage->m_Width		= lpPDFCore->pbmOut->getWidth();
		lpCurrentPage->m_Height		= lpPDFCore->pbmOut->getHeight();
		lpCurrentPage->m_No		= no;
		lpCurrentPage->m_Num		= lpPDFCore->doc->getNumPages();
		lpCurrentPage->m_PDFVersion	= lpPDFCore->doc->getPDFVersion();
		return lpCurrentPage;
	}
	return NULL;
}
LPSPAGE	WINAPI 	PDF_GetPageObject(HPDF m_hPDF,INT no)
{
	return PDF_GetPageObjectEx(m_hPDF,no);
}
VOID	WINAPI 	PDF_DestroyPageObject(LPSPAGE lpPageObj)
{
	if(lpPageObj)
	{
		int nsize = lpPageObj->m_pageBlock.size();
		for(int i = 0; i < nsize; i++)
		{
			switch(lpPageObj->m_pageBlock[i]->m_type)
			{
			case PDF_TEXT:
				{
					if(lpPageObj->m_pageBlock[i]->m_Codes)
						delete lpPageObj->m_pageBlock[i]->m_Codes;
					break;
				}
			case PDF_IMAGE:
				{
					if(lpPageObj->m_pageBlock[i]->m_Images)
						delete lpPageObj->m_pageBlock[i]->m_Images;
					break;
				}
			case PDF_LINE:
				{
					if(lpPageObj->m_pageBlock[i]->m_Lines)
						delete lpPageObj->m_pageBlock[i]->m_Lines;
					break;
				}
			case PDF_POLYGON:
				{
					if(lpPageObj->m_pageBlock[i]->m_Polygons)
						delete lpPageObj->m_pageBlock[i]->m_Polygons;
					break;
				}
			case PDF_CLIPPINGRGN:
				{
					if(lpPageObj->m_pageBlock[i]->m_ClippingRgn)
						delete lpPageObj->m_pageBlock[i]->m_ClippingRgn;
					break;
				}
			}
			delete lpPageObj->m_pageBlock[i];
		}
		delete lpPageObj;
	}
	lpPageObj = NULL;
}
///////////////////////////////////////////////////////////////////////////////////
//
//
// ȡͼ
//
//
///////////////////////////////////////////////////////////////////////////////////
HANDLE	WINAPI 	PDF_GetPageBmpEx(HPDF m_hPDF,INT no)
{
	LPSPDFCORE lpPDFCore = (LPSPDFCORE)m_hPDF;
	if(lpPDFCore == NULL || lpPDFCore->version != VERSION)
		return NULL;

	if(no >= 1 && no <= lpPDFCore->doc->getNumPages())
	{
		lpCurrentPage = NULL;
		lpPDFCore->doc->displayPage(lpPDFCore->pbmOut, no, lpPDFCore->dpi,0,gTrue);
		return m_hDIB.GetHDib();
	}
	return NULL;
}
HANDLE	WINAPI PDF_GetPageBmp(HPDF m_hPDF,INT no)
{
	return PDF_GetPageBmpEx(m_hPDF,no);
}
VOID	WINAPI 	PDF_DestroyPageBmp(HANDLE hBmp)
{
	if(hBmp)
		::GlobalFree(hBmp);
	hBmp = NULL;
}

///////////////////////////////////////////////////////////////////////////////////
//
//
//  ȡϢĺ
//
//
///////////////////////////////////////////////////////////////////////////////////
LPARY_HTMLINK	WINAPI PDF_GetPageHtmLink(HPDF m_hPDF,INT no)
{
	LPSPDFCORE lpPDFCore = (LPSPDFCORE)m_hPDF;
	if(lpPDFCore == NULL || lpPDFCore->version != VERSION)
		return NULL;

	if(lpPDFCore->doc->getCurrentPage() != no)
		return NULL;
	vector<SHTMLINK> *m_paryHtmLinkOld = lpPDFCore->pbmOut->getHtmLink();
	if(m_paryHtmLinkOld == NULL)
		return NULL;
	LPARY_HTMLINK m_paryHtmLink = new ARY_HTMLINK;
	if(m_paryHtmLink == NULL)
		return NULL;
	int oldSize = m_paryHtmLinkOld->size();
	for(int i = 0; i < oldSize; i++)
	{
		SHTMLLINK htmlink;
		htmlink.xMin	= (*m_paryHtmLinkOld)[i].xMin;
		htmlink.xMax	= (*m_paryHtmLinkOld)[i].xMax;
		htmlink.yMin	= (*m_paryHtmLinkOld)[i].yMin;
		htmlink.yMax	= (*m_paryHtmLinkOld)[i].yMax;
		htmlink.szDest	= (*m_paryHtmLinkOld)[i].szDest;
		m_paryHtmLink->push_back(htmlink);
	}
	return m_paryHtmLink;
}
VOID		WINAPI PDF_DestroyHtmLink(LPARY_HTMLINK m_paryHtmLink)
{
	if(m_paryHtmLink)
		delete m_paryHtmLink;
	m_paryHtmLink = NULL;
}
#define IS_WIN30_DIB(lpbi)  ((*(LPDWORD)(lpbi)) != 12)
#define WIDTHBYTES(bits)    (((bits) + 31) / 32 * 4)
WORD  _DIBNumColors(LPSTR lpbi)
{
	WORD wBitCount;  // DIB bit count
	if (IS_WIN30_DIB(lpbi))
	{
		DWORD dwClrUsed;
		
		dwClrUsed = ((LPBITMAPINFOHEADER)lpbi)->biClrUsed;
		if (dwClrUsed != 0)
			return (WORD)dwClrUsed;
	}
	
	if (IS_WIN30_DIB(lpbi))
		wBitCount = ((LPBITMAPINFOHEADER)lpbi)->biBitCount;
	else
		wBitCount = ((LPBITMAPCOREHEADER)lpbi)->bcBitCount;
	
	switch (wBitCount)
	{
	case 1:
		return 2;
		
	case 4:
		return 16;
		
	case 8:
		return 256;
		
	default:
		return 0;
	}
}

WORD  _PaletteSize(LPSTR lpbi)
{
	if (IS_WIN30_DIB (lpbi))
		return (WORD)(_DIBNumColors(lpbi) * sizeof(RGBQUAD));
	else
		return (WORD)(_DIBNumColors(lpbi) * sizeof(RGBTRIPLE));
}

BOOL	WINAPI PDF_WriteToBMPFile(HANDLE m_hDIBInfo,LPCTSTR pszBmpFile)
{
	BITMAPFILEHEADER bmfHdr; // Header for Bitmap file
	LPBITMAPINFOHEADER lpBI;   // Pointer to DIB info structure
	DWORD dwDIBSize;
	
	if (m_hDIBInfo == NULL || pszBmpFile == NULL || pszBmpFile[0] == 0)
		return FALSE;
   
	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) m_hDIBInfo);
	if (lpBI == NULL)
		return FALSE;
   
	if (!IS_WIN30_DIB(lpBI))
	{
		::GlobalUnlock((HGLOBAL) m_hDIBInfo);
		return FALSE;       // It's an other-style DIB (save not supported)
	}
   
	bmfHdr.bfType = DIB_HEADER_MARKER;  // "BM"
	dwDIBSize = *(LPDWORD)lpBI + ::_PaletteSize((LPSTR)lpBI);  // Partial Calculation
   
	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
	{
		dwDIBSize += lpBI->biSizeImage;
	}
	else
	{
		DWORD dwBmBitsSize;  // Size of Bitmap Bits only
		dwBmBitsSize = WIDTHBYTES((lpBI->biWidth)*((DWORD)lpBI->biBitCount)) * lpBI->biHeight;
		dwDIBSize += dwBmBitsSize;
		lpBI->biSizeImage = dwBmBitsSize;
	}
	bmfHdr.bfSize = dwDIBSize + sizeof(BITMAPFILEHEADER);
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + lpBI->biSize
		+ _PaletteSize((LPSTR)lpBI);

	FILE *file = fopen(pszBmpFile,"wb");
	if(file)
	{
		// Write the file header
		fwrite((LPSTR)&bmfHdr,1,sizeof(BITMAPFILEHEADER),file);
		fwrite(lpBI,1, dwDIBSize,file);
		fclose(file);
	}
	::GlobalUnlock((HGLOBAL) m_hDIBInfo);
	return TRUE;
}
BOOL WINAPI PDF_WriteToSVGFile(LPSPAGE ptrPage,LPCTSTR pszFileName)
{
	if(ptrPage == NULL)
		return FALSE;
	if(pszFileName == NULL || pszFileName[0] == 0)
		return FALSE;
	char szSVGBegin[] = 
	"<?xml version=\"1.0\" standalone=\"no\"?>\n"
	"<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20000303 Stylable//EN\"\n"
	"\t\"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\n"
	"<svg>\n";
	char szSVGEnd[] = "\n</svg>";

	FILE *file = fopen(pszFileName,"w");
	if(file == NULL)
		return FALSE;
	fputs(szSVGBegin,file);
	int nsize = ptrPage->m_pageBlock.size();
	for(int i = 0; i < nsize; i++)
	{
		switch(ptrPage->m_pageBlock[i]->m_type)
		{
		case PDF_CLIPPINGRGN:
				break;
		case PDF_TEXT:
			{
//<text x="250" y="150" font-family="Verdana" font-size="55" fill="blue" >Hello, out there</text>
				STEXT &m_Codes = *ptrPage->m_pageBlock[i]->m_Codes;
				//fprintf(file,"%d,%d",m_Codes.x,m_Codes.y,
				//	m_Codes.x,m_Codes.y,//
				//	m_Codes.szCode.c_str(),//ַ
				//	m_Codes.nCount,m_Codes.szFontName.c_str(),
				//	m_Codes.nFontWidth,m_Codes.nFontHeight,
				//	m_Codes.m_bIsBold,m_Codes.m_bIsItalic,
				//	m_Codes.color,m_Codes.m_dAngle,IsNoText
				//	);
				char buf[1024];
				memset(buf,0,1024);
				int destCount = WideCharToMultiByte(CP_ACP,0,
					(unsigned short *)m_Codes.szCode.begin(),
					m_Codes.nCount,buf,1024,
					NULL,NULL
					);
				if(destCount <= 0)
					continue;
				BYTE r,g,b;
				r = GetRValue(m_Codes.color);
				g = GetGValue(m_Codes.color);
				b = GetBValue(m_Codes.color);
				fprintf(file,"<text x=\"%d\" y=\"%d\" font-family=\"%s\" font-size=\"%d\" fill=\"#%02x%02x%02x\" >%s</text>\n",
					m_Codes.x,m_Codes.y,"",m_Codes.nFontHeight,r,g,b,
					buf
					);
			}
			break;
		case PDF_IMAGE:
			{
				//SIMAGE	&m_Images = *ptrPage->m_pageBlock[i]->m_Images;
				//__DrawImage(pDC,&m_Images.nBitmapInfo,
				//	m_Images.pData.begin(),m_Images.x,
				//	m_Images.y,m_Images.cx,m_Images.cy
				//	);
			}
			break;
		case PDF_LINE:
			{
//	<line x1="100" y1="300" x2="300" y2="100" stroke-width="5" stroke="green"/>
				SLINE	&m_Lines = *ptrPage->m_pageBlock[i]->m_Lines;
/*				fprintf(file,"LINE:%d,%d,%d,%d,%d,%d,%d\n",
					m_Lines.x0,m_Lines.y0,m_Lines.x1,m_Lines.y1,
					m_Lines.width,m_Lines.color,m_Lines.style
					);
*/
				BYTE r,g,b;
				r = GetRValue(m_Lines.color);
				g = GetGValue(m_Lines.color);
				b = GetBValue(m_Lines.color);
				fprintf(file,"<line x1=\"%d\" y1=\"%d\" x2=\"%d\" y2=\"%d\" stroke-width=\"%d\" stroke=\"#%02x%02x%02x\"/>\n",
					m_Lines.x0,m_Lines.y0,m_Lines.x1,m_Lines.y1,
					m_Lines.width,r,g,b
					);
			}
			break;
		case PDF_POLYGON:
			{
//	<polygon fill="#ff0000" stroke="blue" stroke-width="10"
//		points="350,75 379,161 469,161 397,215 423,301 350,250 277,301 303,215 231,161 321,161" />
				SPOLYGON &m_Polygons = *ptrPage->m_pageBlock[i]->m_Polygons;
/*
				fprintf(file,"POLYGON:%d,%d,",m_Polygons.color,m_Polygons.mode);
				for(int i = 0; i < m_Polygons.pots.size(); i++)
				{
					fprintf(file,"(%d,%d)",m_Polygons.pots[i].x,m_Polygons.pots[i].y);
				}
				fputc('\n',file);
*/
				BYTE r,g,b;
				r = GetRValue(m_Polygons.color);
				g = GetGValue(m_Polygons.color);
				b = GetBValue(m_Polygons.color);
				fprintf(file,"<polygon fill=\"#%02x%02x%02x\" ",r,g,b);
				fputs("points=\"",file);
				for(int i = 0; i < m_Polygons.pots.size(); i++)
				{
					fprintf(file,"%d,%d",m_Polygons.pots[i].x,m_Polygons.pots[i].y);
					if(i < m_Polygons.pots.size()-1)
						fputc(' ',file);
				}
				fputs("\" />\n",file);
			}
			break;
		}
	}
	fputs(szSVGEnd,file);
	fclose(file);
	return TRUE;
}
