//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Registry.h"
#include "registerman.h"
#include "win_pdf2htm.h"
#include "win_pdf2htmDlg.h"
#include "OptionsDlg.h"
#include "DialogRegP2H.h"
#include "WriteDir.h"
#include "sbdestination.h"
#include "winsock.h"
#include <afxinet.h>
#include "parseargs.h"
#include <time.h>
#include <direct.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include "HyperLink.h"
#include "PropertySheetWithLogoDlg.h"
#include "CommandUsage.h"
#include "Html2pdf.h"
#include <string>
using namespace std;
#include "ShellFileOp.h"
#include "HTMLPage.h"
#include "PDFPassword.h"
#include "RasterImage.h"
#include "Hyperlinks.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern char szMailTo[];
extern char szEnglishHomepage[];
extern char szEnglishRegister[];

enum CONVERTTYPE{PDF2HTM,PDF2BMP};
CONVERTTYPE	m_convertType = PDF2HTM;

extern BOOL WINAPI ShowRegisterDlg(BOOL _IsRegistered,HWND hWnd);
extern INT  WINAPI CheckSerialNo();
extern BOOL	IsRegistered;

//ͬܵע־
BOOL	IsRegisteredHTM = TRUE;
BOOL	IsRegisteredBMP = TRUE;

extern int PASCAL FAR WSAStartup(WORD wVersionRequired, LPWSADATA lpWSAData);
extern int PASCAL FAR connect (SOCKET s, const struct sockaddr FAR *name, int namelen);
extern unsigned long PASCAL FAR inet_addr (const char FAR * cp);
extern u_short PASCAL FAR htons (u_short hostshort);
extern HINSTANCE MyGotoURL(LPCTSTR url, int showcmd);

//δעûֻܴ5ҳPDFļ
#define UNREGISTER_MAX_PAGES	5

//в
int firstPage = 0;
int lastPage = 100000;
int zoomratio = -1;
BOOL printHelp = FALSE;
BOOL m_bAutoExit = FALSE;
BOOL m_bWithoutShowMainWnd = FALSE;
BOOL m_bOverwriteWithoutPrompt = FALSE;
BOOL m_bTmpRemovePics = FALSE;
BOOL m_bForceContinuePages = FALSE;
POINT m_pointLastPage;
vector<STEXT>	m_aryFont;
int  m_uCharSpaces = -1;
char m_szUserPassword[100] = "";
char m_szOwnerPassword[100] = "";
int  m_iJpegQuality = 75;
BOOL m_bGrayscale = FALSE;

static char PDFFileName[260] = "";
static char HTMFileName[260] = "";
static ArgDesc argDesc[] = {
	{"-f",      argInt,      &firstPage,     0,			"First page to convert"},
	{"-l",      argInt,      &lastPage,      0,			"Last page to convert"},
	{"-z",      argInt,      &zoomratio,     -1,			"Zoom Ratio"},
	{"-c",      argFlag,     &m_bForceContinuePages, 0,             "Generate in one continuous html page"},
	{"-d",	    argFlag,	 &m_bTmpRemovePics, 0,			"Remove pics"},
	{"-b",	    argInt,	 &m_uCharSpaces, -1,			"Set space between characters"},
	{"-j",	    argInt,	 &m_iJpegQuality, 0,			"Set JPEG quality"},
	{"-g",	    argFlag,	 &m_bGrayscale, 0,			"Set JPEG grayscale"},
	{"-u",      argString,   m_szUserPassword,sizeof(m_szUserPassword),	"User password"},
	{"-w",      argString,   m_szOwnerPassword,sizeof(m_szOwnerPassword),	"Owner password"},
	{"-q",      argFlag,     &m_bAutoExit,   0,			"Exit after convert"},
	{"-m",      argFlag,     &m_bWithoutShowMainWnd,   0,		"Run without window"},
	{"-r",      argFlag,     &m_bOverwriteWithoutPrompt,   0,	"Overwrite an existing destination file without prompting to confirm"},
	{"-i",      argString,   PDFFileName,    sizeof(PDFFileName),	"PDF file will be convert"},
	{"-o",      argString,   HTMFileName,    sizeof(HTMFileName),	"HTM file will be generate"},
	{"-h",      argFlag,     &printHelp,     0,			"Print usage information"},
	{"-?",      argFlag,     &printHelp,     0,			"Print usage information"},
	{NULL}
};

static char szUsage[] = {
	"Usage: PDF2HTML [Option] <PDF File> [<HTM File>]\r\n"
	"-f <page number> : First page to be converted\r\n"
	"-l <page number> : Last page to be converted\r\n"
	"-z <zoom ratio>  : Set zoom ratio when conversion, the range is from 50 to 200\r\n"
	"-c               : Generate in one continuous html page\r\n"
	"-d               : Remove pictures from the continuous html page\r\n"
	"-b <space number>: Space between characters\r\n"
	"-j <jpeg quality>: Set jpeg quality, from 1 to 100\r\n"
	"-g               : Set jpeg grayscale\r\n"
	"-u <user password>         : User password\r\n"
	"-w <owner password>        : Owner password\r\n"
	"-q               : Exit after converting\r\n"
	"-m               : Run without window\r\n"
	"-r               : Overwrite an existing destination file without prompting to confirm\r\n"
	"-i <input PDF file name>   : PDF file will be converted\r\n"
	"-o <output HTML file name> : HTML file will be generated\r\n"
	"-h or -?         : Print usage information\r\n"
	"\r\n"
	"For example: \r\n"
	"       PDF2HTML -q -f 5 -l 8 -i c:\\a.pdf -o c:\\a.htm\r\n"
	"       PDF2HTML -q -m -r -i \"c:\\a.pdf\" -o \"c:\\a.htm\"\r\n"
	"       PDF2HTML -q -m -r -c -d -i c:\\a.pdf -o c:\\a.htm\r\n"
	"       PDF2HTML -q -m -r -u user -w owner -i c:\\a.pdf -o c:\\a.htm\r\n"
};
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_HyperEmailLink;
	CHyperLink	m_HyperHomePageLink;
	CString	m_szRegisterInfo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_szRegisterInfo = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATIC_MAILTO, m_HyperEmailLink);
	DDX_Control(pDX, IDC_STATIC_HOMEPAGE, m_HyperHomePageLink);
	DDX_Text(pDX, IDC_EDIT_INFO, m_szRegisterInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWin_pdf2htmDlg dialog

CWin_pdf2htmDlg::CWin_pdf2htmDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWin_pdf2htmDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWin_pdf2htmDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWin_pdf2htmDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWin_pdf2htmDlg)
	DDX_Control(pDX, IDC_STATIC_PDFVER, m_ctrlPDFVer);
	DDX_Control(pDX, IDC_PROGRESS_PAGE, m_wndPageProgress);
	DDX_Control(pDX, IDC_PROGRESS_FILES, m_wndFileProgress);
	DDX_Control(pDX, IDC_EXPLORER_PDFIMAGE, m_ctrlPDFImage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWin_pdf2htmDlg, CDialog)
	//{{AFX_MSG_MAP(CWin_pdf2htmDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_FILE_PREFERENCES, OnFilePreferences)
	ON_COMMAND(IDM_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(IDM_FILE_OPEN, OnUpdateFileOpen)
	ON_COMMAND(IDM_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(IDM_FILE_EXIT, OnFileExit)
	ON_COMMAND(IDM_HELP_SUPPORT, OnHelpSupport)
	ON_WM_DROPFILES()
	ON_COMMAND(IDM_FILE_TOP, OnFileTop)
	ON_UPDATE_COMMAND_UI(IDM_FILE_TOP, OnUpdateFileTop)
	ON_WM_MOUSEMOVE()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_RBUTTONUP()
	ON_COMMAND(IDM_HELP_HELP, OnHelpHelp)
	ON_BN_CLICKED(IDPAUSE, OnPause)
	ON_BN_CLICKED(IDCLOSE, OnClose)
	ON_COMMAND(IDM_HELP_REGISTER, OnHelpRegister)
	ON_COMMAND(IDM_HELP_PRODUCTLIST, OnHelpProductlist)
	ON_COMMAND(IDM_HELP_BUYNOW, OnHelpBuynow)
	ON_COMMAND(IDM_HELP_PDF2HTM_ONWEB, OnHelpPdf2htmOnweb)
	ON_COMMAND(IDM_TOOLS_PDF2HTM, OnToolsPdf2htm)
	ON_COMMAND(IDM_TOOLS_PDF2BMP, OnToolsPdf2bmp)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//
//ļм߳
//
/////////////////////////////////////////////////////////////////////////////
BOOL		g_bStrActive;
static DWORD	WINAPI NetBarListenThread(LPVOID  lpData)
{
	CWin_pdf2htmDlg* m_pMainDlg = (CWin_pdf2htmDlg*)lpData;
	CString m_strHtmlFile;
	while(g_bStrActive)
	{
		while(g_bStrActive && m_pMainDlg->m_aryPDF2HTMFile.GetSize() > 0)
		{
			BOOL m_bConversionOK = TRUE;
			//closeťıΪstop
			m_pMainDlg->GetDlgItem(IDCLOSE)->SetWindowText("Stop");
			//ʼȡеĵһ
			SCORECONVERT& m_coreConvert = m_pMainDlg->m_aryPDF2HTMFile[0];
			m_strHtmlFile=m_coreConvert.szHTMName;//ȡǰļ
			//жļǷ
			CFileFind FindHtm;
			UINT ReturnMsg;
			//ļѾ
			if (FindHtm.FindFile((LPCTSTR)m_coreConvert.szHTMName))
			{
				if(m_bOverwriteWithoutPrompt)
					ReturnMsg = IDYES;
				else
					ReturnMsg = AfxMessageBox(m_coreConvert.szHTMName+" existed,override? Select Cancel to skip the file.",MB_YESNOCANCEL);
				if (ReturnMsg == IDNO)//ûѡNoûѡļ
				{
					char sFilter[100];
					char szTitle[20];
					switch(m_convertType)
					{
					case PDF2HTM:strcpy(szTitle,"htm");strcpy(sFilter,"HTM Files (*.HTM)|*.HTM|All Files (*.*)|*.*||");break;
					case PDF2BMP:strcpy(szTitle,"bmp");strcpy(sFilter,"BMP Files (*.BMP)|*.BMP|All Files (*.*)|*.*||");break;
					}
					CFileDialog m_dlgFile(FALSE,szTitle,NULL,
					OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_ALLOWMULTISELECT,sFilter,NULL);
					if(m_dlgFile.DoModal() == IDOK)
					{
						m_coreConvert.szHTMName=m_dlgFile.GetPathName();

						char path_buffer[_MAX_PATH];
						char drive[_MAX_DRIVE];
						char dir[_MAX_DIR];
						char fname[_MAX_PATH];
						char ext[_MAX_EXT];
						_splitpath(m_coreConvert.szHTMName, drive, dir, fname, ext );
						_makepath(path_buffer,drive, dir,fname,"");
						if(path_buffer[strlen(path_buffer)-1] != '\\')
							strcat(path_buffer,"\\");
						strcat(path_buffer,"index.htm");
						m_coreConvert.szHTMName=path_buffer;
					}
				}
				if (ReturnMsg != IDCANCEL)//ûѡcancelļ,ûѡȡתļ
				{
					m_bConversionOK = m_pMainDlg->ConvertPDF2HTML(m_coreConvert.szPDFName,m_coreConvert.szHTMName);
				}
			}
			else//ԭļֱת
			{
				m_bConversionOK = m_pMainDlg->ConvertPDF2HTML(m_coreConvert.szPDFName,m_coreConvert.szHTMName);
			}
			
			//ɾʹź־
			if(IsRegistered)
			{
				EnterCriticalSection(&m_pMainDlg->nCriticalSection);
				if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() > 0)
					m_pMainDlg->m_aryPDF2HTMFile.RemoveAt(0);
				LeaveCriticalSection(&m_pMainDlg->nCriticalSection);
				//תԺʾʾϢ
				if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() == 0)
				{
					if(m_bAutoExit)
						ExitProcess(0);
					else
						m_pMainDlg->MessageBox("Convert Finished!","PDF2HTM software",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST|MB_SYSTEMMODAL);
				}
			}
			else
			{//δע汾,̽ʣļȫ
				AfxMessageBox("Convert finished! Your softerware is not registered, you can only process one file and five pages in one time! The registered version hasn't these limitations.");
			
				EnterCriticalSection(&m_pMainDlg->nCriticalSection);
				m_pMainDlg->m_aryPDF2HTMFile.RemoveAll();
				LeaveCriticalSection(&m_pMainDlg->nCriticalSection);
			}
		
			if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() == 0)
			{
				int m_bPreview = AfxGetApp()->GetProfileInt("Preview","Flag",0);
				if(m_bPreview && m_bConversionOK)
				{
					MyGotoURL(m_strHtmlFile,SW_SHOWNORMAL);
				}
			}
		}
		
		//ļΪգʾ
		if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() == 0)
		{
			//closeťıΪClose
			m_pMainDlg->GetDlgItem(IDCLOSE)->SetWindowText("Close");
			m_pMainDlg->m_wndFileProgress.SetPos(0);
			m_pMainDlg->GetDlgItem(IDC_STATIC_FILENAME)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_TOTALPAGES)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_TOTALFILES)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_FILESIZE)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_VERSION)->SetWindowText("");
		}
		Sleep(100);
	}
	return 0;
}

void CWin_pdf2htmDlg::UpdateTitle()
{
	HMENU hMenu = ::GetMenu(m_hWnd);

	char szTitle[200];
	switch(m_convertType)
	{
	case PDF2HTM:
		strcpy(szTitle,"PDF2HTML v1.6");
		CheckMenuItem(hMenu,IDM_TOOLS_PDF2HTM,MF_CHECKED);
		CheckMenuItem(hMenu,IDM_TOOLS_PDF2BMP,MF_UNCHECKED);
		break;
	case PDF2BMP:
		strcpy(szTitle,"PDF2BMP v1.6");
		CheckMenuItem(hMenu,IDM_TOOLS_PDF2HTM,MF_UNCHECKED);
		CheckMenuItem(hMenu,IDM_TOOLS_PDF2BMP,MF_CHECKED);
		break;
	}
	AfxGetApp()->WriteProfileInt("m_convertType","type",m_convertType);
	if(!IsRegistered)
		strcat(szTitle," (Trial version)");
	SetWindowText(szTitle);
}
//ʼԻ
BOOL CWin_pdf2htmDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CHAR	szExeDir[MAX_PATH];
	GetModuleFileName(AfxGetInstanceHandle(),szExeDir,MAX_PATH);
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
	_splitpath(szExeDir, drive, dir, fname, ext );
	_makepath(szExeDir, drive, dir,"pdf2html",".ani");
	hAniCursor = LoadCursorFromFile(szExeDir);
	DragAcceptFiles();

	m_wndPageProgress.SetRange(0,100);
	m_wndPageProgress.ShowPercent();
	m_wndFileProgress.SetRange(0,100);
	m_wndFileProgress.ShowPercent();

	int topmost = AfxGetApp()->GetProfileInt("WindowsTopMost","Flag",0);
	if(topmost)
	{
		::SetWindowPos( m_hWnd, HWND_TOPMOST, 0, 0, 0, 0,
				 SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		UINT dwStyle = ::GetWindowLong(m_hWnd,GWL_EXSTYLE);
		HMENU hMenu = ::GetMenu(m_hWnd);
		CheckMenuItem(hMenu,IDM_FILE_TOP,(dwStyle&WS_EX_TOPMOST?MF_CHECKED:MF_UNCHECKED));
	}
	//ź
	InitializeCriticalSection(&nCriticalSection);
	//߳
	g_bStrActive = TRUE;
	DWORD dwThreadId;
	hNetBarThread = CreateThread(NULL,0,NetBarListenThread,this,0,&dwThreadId);
	if(hNetBarThread == NULL)
	{
		::MessageBox(NULL,"CreateThread error.","Error",MB_OK|MB_ICONSTOP);
		return FALSE;
	}

	cSpawn.Init(AfxGetInstanceHandle());
	cSpawn.SetBarImage(IDB_BMP_MENU,21);
	//cSpawn.SetBackBitmap(IDB_BMP_MENU);
	cSpawn.LoadToolBarResource(IMAGEVIEW_TOOLBARID);

	m_ctrlPDFVer
		.SetTextColor(RGB(255,255,0))
		.SetBkColor(RGB(0,0,0))
		.SetFontBold(TRUE)
		//.SetBorder(TRUE)
		.SetSunken(TRUE);

////////////////////////////////////////////////////////////////////////////
	{
		CHAR	szPDFImageUrl[MAX_PATH];
		GetModuleFileName(AfxGetInstanceHandle(),szPDFImageUrl,MAX_PATH);
		CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
		_splitpath(szPDFImageUrl, drive, dir, fname, ext );
		_makepath(szPDFImageUrl, drive, dir,"","");
		if(szExeDir[strlen(szPDFImageUrl)-1] != '\\')
		strcat(szPDFImageUrl,"\\");

		strcat(szPDFImageUrl,"pdf2html.htm");
	
		
		COleVariant varEmpty;
		m_ctrlPDFImage.Navigate(szPDFImageUrl, &varEmpty, &varEmpty,&varEmpty, &varEmpty );
	}
///////////////////////////////////////////////////////////////////////////////////
	IsRegisteredHTM = TRUE;
	IsRegisteredBMP = TRUE;
	AfxGetApp()->WriteProfileInt("Register","IsRegisteredHTM",IsRegisteredHTM);
	AfxGetApp()->WriteProfileInt("Register","IsRegisteredBMP",IsRegisteredBMP);

	IsRegistered = TRUE;
	if(CheckSerialNo())
	{
		IsRegistered = FALSE;
		IsRegistered = ShowRegisterDlg(IsRegistered,m_hWnd);
	}
	HMENU hMenu = ::GetMenu(m_hWnd);
	if(IsRegistered)
		EnableMenuItem(hMenu,IDM_HELP_REGISTER,MF_GRAYED);

	m_convertType = (CONVERTTYPE)AfxGetApp()->GetProfileInt("m_convertType","type",PDF2HTM);
	UpdateTitle();

	if(IsRegisteredHTM == FALSE)
		DeleteMenu(hMenu,IDM_TOOLS_PDF2HTM,MF_BYCOMMAND);
	if(IsRegisteredBMP == FALSE)
		DeleteMenu(hMenu,IDM_TOOLS_PDF2BMP,MF_BYCOMMAND);

	// parse args
	int argc = __argc;
	char **argv = __argv;
	if(argc > 1)
	{
		GBool ok;
		ok = parseArgs(argDesc, &argc, argv);
		if (!ok || printHelp)
		{
			//string strUsage;
			//printUsage(strUsage,"PDF2HTM", "<PDFFile> [<HTMFile>]", argDesc);
			CCommandUsage dlg;
			dlg.m_szUsage = szUsage;
			dlg.DoModal();
			exit(1);
		}
		if(m_iJpegQuality > 0 && m_iJpegQuality < 100)
			AfxGetApp()->WriteProfileInt("CRasterImage","m_iJPGQuality",m_iJpegQuality);
		AfxGetApp()->WriteProfileInt("CRasterImage","m_bGrayscale",m_bGrayscale);
		if(m_szUserPassword[0])
			AfxGetApp()->WriteProfileString("CPDFPassword","m_szUserPassword",m_szUserPassword);
		if(m_szOwnerPassword[0])
			AfxGetApp()->WriteProfileString("CPDFPassword","m_szOwnerPassword",m_szOwnerPassword);

		if(zoomratio >= 50 && zoomratio <= 200)
			AfxGetApp()->WriteProfileInt("ZoomRatio","Zoom",zoomratio);
		AfxGetApp()->WriteProfileInt("GenerateInOneHTMLPage","Flag",m_bForceContinuePages);
		AfxGetApp()->WriteProfileInt("m_bRemovePics","Flag",m_bTmpRemovePics);
		if(m_uCharSpaces >= 0 && m_uCharSpaces <= 50)
		{
			char szCurDir[_MAX_PATH];
			GetModuleFileName(NULL, szCurDir, _MAX_PATH);
			CString t = szCurDir;
			int pos = t.ReverseFind('\\');
			CString strInitFileName = t.Left(pos+1) + "config.ini";

			char buffer[50];
			sprintf(buffer,"%d",m_uCharSpaces);
			WritePrivateProfileString("PDF2HTM","CharSpaces",buffer,strInitFileName);
		}
		if(firstPage != 0 || lastPage != 100000)
		{
			AfxGetApp()->WriteProfileInt("PageRangeType","Type",1);
			AfxGetApp()->WriteProfileInt("PageRange","From",firstPage);
			AfxGetApp()->WriteProfileInt("PageRange","To",lastPage);
		}
		if(m_bWithoutShowMainWnd)
		{
			ShowWindow(SW_SHOWMINIMIZED);
		}
		m_convertType = PDF2HTM;
		if(PDFFileName[0])
		{
			char path_buffer[_MAX_PATH];
			char drive[_MAX_DRIVE];
			char dir[_MAX_DIR];
			char fname[_MAX_PATH];
			char ext[_MAX_EXT];

			SCORECONVERT m_coreConvert;
			m_coreConvert.szPDFName = PDFFileName;
			if(HTMFileName[0])
			{
				_splitpath(HTMFileName, drive, dir, fname, ext );
				_makepath(path_buffer,drive, dir,fname,"");
				if(path_buffer[strlen(path_buffer)-1] != '\\')
					strcat(path_buffer,"\\");
				strcat(path_buffer,"index.htm");
				m_coreConvert.szHTMName = path_buffer;
			}
			else
			{
				_splitpath(PDFFileName, drive, dir, fname, ext );
				_makepath(path_buffer,drive, dir,fname,"");
				if(path_buffer[strlen(path_buffer)-1] != '\\')
					strcat(path_buffer,"\\");
				strcat(path_buffer,"index.htm");
				m_coreConvert.szHTMName = path_buffer;
			}
			EnterCriticalSection(&nCriticalSection);
			m_aryPDF2HTMFile.Add(m_coreConvert);
			LeaveCriticalSection(&nCriticalSection);
		}
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CWin_pdf2htmDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWin_pdf2htmDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWin_pdf2htmDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWin_pdf2htmDlg::OnFilePreferences() 
{
	CPropertySheetWithLogoDlg m_dlgOption("Preferences");
	m_dlgOption.SetLogoText("PDF2HTML");
	m_dlgOption.m_psh.dwFlags &= ~PSH_HASHELP;
	m_dlgOption.m_psh.dwFlags |= PSH_NOAPPLYNOW;

	COptionsDlg	m_dlgFirstPage;
	m_dlgFirstPage.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgFirstPage);

	CHtml2pdf	m_dlgPDF2HTM;
	m_dlgPDF2HTM.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgPDF2HTM);

	CPDFPassword	m_dlgPDFPass;
	m_dlgPDFPass.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgPDFPass);

	CHTMLPage	m_dlgHTMLpage;
	m_dlgHTMLpage.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgHTMLpage);

	CRasterImage	m_dlgRasterImage;
	m_dlgRasterImage.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgRasterImage);

	CHyperlinks	m_dlgHyperlinks;
	m_dlgHyperlinks.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgHyperlinks);

	if(m_dlgOption.DoModal() == IDOK)
	{
		m_dlgFirstPage.SaveSetting();
		m_dlgPDF2HTM.SaveSetting();
		return;
	}
	
	
//	COptionsDlg	m_dlgOption;
//	if(m_dlgOption.DoModal() != IDOK)
//		return;
}


//////////////////////Ϸļ///////////////////////////////

void CWin_pdf2htmDlg::OnDropFiles(HDROP hDropInfo )
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	CHAR	FileName[MAX_PATH] ;
	int	NumOfFiles = 0 ;
	
	memset(FileName,0,MAX_PATH);
	NumOfFiles = DragQueryFile ((HDROP) hDropInfo, 0xffffffff, NULL, 0) ;

	for(INT i = 0; i < NumOfFiles; i++)//stop/close
	{
		DragQueryFile((HDROP) hDropInfo, i, FileName,MAX_PATH);
		//ӽļУʹź־
		EnterCriticalSection(&nCriticalSection);
		SCORECONVERT m_coreConvert;
		m_coreConvert.szPDFName = FileName;

		_splitpath(FileName, drive, dir, fname, ext );
		_makepath(path_buffer,drive, dir,fname,"");
		if(path_buffer[strlen(path_buffer)-1] != '\\')
			strcat(path_buffer,"\\");
		strcat(path_buffer,"index.htm");

		m_coreConvert.szHTMName = path_buffer;
		m_aryPDF2HTMFile.Add(m_coreConvert);
		LeaveCriticalSection(&nCriticalSection);
	}
	DragFinish ((HDROP) hDropInfo) ;

}


/////////////////////////////////////////////////////////////////////
////////////////////////////////////////ļ//////////////////////
void CWin_pdf2htmDlg::OnFileOpen() 
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	char *m_pChBuf = NULL;
	char sFilterPDF[] = "PDF Files (*.PDF)|*.pdf|All Files (*.*)|*.*||";

	char sFilter[100];
	char szTitle[20];
	switch(m_convertType)
	{
	case PDF2HTM:strcpy(szTitle,"htm");strcpy(sFilter,"HTM Files (*.HTM)|*.HTM|All Files (*.*)|*.*||");break;
	case PDF2BMP:strcpy(szTitle,"bmp");strcpy(sFilter,"BMP Files (*.BMP)|*.BMP|All Files (*.*)|*.*||");break;
	}
	if ( ( m_pChBuf	= ( char * ) malloc( 1024*100 )) == NULL )
		return;
	memset(m_pChBuf,0,1024*100);

	CFileDialog DlgFile(TRUE,"PDF","",
	OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_ALLOWMULTISELECT,sFilterPDF,NULL);
	DlgFile.m_ofn.lpstrTitle = "Open PDF Files";
	DlgFile.m_ofn.lpstrFile = m_pChBuf;
	DlgFile.m_ofn.nMaxFile = 20000;
	DlgFile.m_ofn.nFilterIndex = 0;
	DlgFile.m_ofn.lpstrInitialDir = AfxGetApp()->GetProfileString("FilePath","LastOpenPath","C:\\");

	CString m_szFileName;

	if ( DlgFile.DoModal() == IDOK)
	{
		//
		//ѡ񵥸ļҪûṩΪļƣǶ
		//ļֱ
		//
		char* pChBuf = m_pChBuf;
		pChBuf += strlen( pChBuf ) + 1;
		if ( *pChBuf == 0 )		//only one file
		{
			_splitpath(m_pChBuf, drive, dir, fname, ext );
			_makepath(path_buffer,drive, dir,"","");
			AfxGetApp()->WriteProfileString("FilePath","LastOpenPath",path_buffer);

			CFileDialog m_dlgFile(FALSE,szTitle,fname,
				OFN_HIDEREADONLY|OFN_ALLOWMULTISELECT,sFilter,NULL);
			if(m_dlgFile.DoModal() == IDOK)
			{
				CString strHtmlFileName = m_dlgFile.GetPathName();
				//ӽļУʹź־
				EnterCriticalSection(&nCriticalSection);
				SCORECONVERT m_coreConvert;
				m_coreConvert.szPDFName = m_pChBuf;

				_splitpath(strHtmlFileName, drive, dir, fname, ext );
				_makepath(path_buffer,drive, dir,fname,"");
				if(path_buffer[strlen(path_buffer)-1] != '\\')
					strcat(path_buffer,"\\");
				strcat(path_buffer,"index.htm");

				m_coreConvert.szHTMName = path_buffer;				

				m_aryPDF2HTMFile.Add(m_coreConvert);
				LeaveCriticalSection(&nCriticalSection);
			}
			free(m_pChBuf);
			return;
		}
		//
		CSBDestination sb(m_hWnd,IDS_BROWDIRTITLE_E);
		sb.SetFlags(BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT);
		CString pathstr = AfxGetApp()->GetProfileString("htmSaveDefaultDirectory","Path","");
		sb.SetInitialSelection(pathstr);
		CString strSaveHtmDirectory;
		if (sb.SelectFolder())
		{
			strSaveHtmDirectory = sb.GetSelectedFolder();
			AfxGetApp()->WriteProfileString("htmSaveDefaultDirectory","Path",strSaveHtmDirectory);
		}
		else
			return;
		AfxGetApp()->WriteProfileString("FilePath","LastOpenPath",m_pChBuf);
		//ӽļУʹź־
		EnterCriticalSection(&nCriticalSection);
		POSITION pos = DlgFile.GetStartPosition();
		while(pos)
		{
			m_szFileName = DlgFile.GetNextPathName(pos);
			_splitpath(m_szFileName, drive, dir, fname, ext );

			CString strHtmlFileName = strSaveHtmDirectory;
			if(strHtmlFileName[strHtmlFileName.GetLength()-1] != '\\')
				strHtmlFileName += "\\";
			strHtmlFileName += fname;
			strHtmlFileName += ".";
			strHtmlFileName += szTitle;

			SCORECONVERT m_coreConvert;
			m_coreConvert.szPDFName = m_szFileName;

			_splitpath(strHtmlFileName, drive, dir, fname, ext );
			_makepath(path_buffer,drive, dir,fname,"");
			if(path_buffer[strlen(path_buffer)-1] != '\\')
				strcat(path_buffer,"\\");
			strcat(path_buffer,"index.htm");
			
			m_coreConvert.szHTMName = path_buffer;
			m_aryPDF2HTMFile.Add(m_coreConvert);
		}
		LeaveCriticalSection(&nCriticalSection);

	}
	free(m_pChBuf);
}

void CWin_pdf2htmDlg::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CWin_pdf2htmDlg::OnHelpAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CWin_pdf2htmDlg::OnFileExit() 
{
	OnCancel();
}

//Close buttom
void CWin_pdf2htmDlg::OnCancel() 
{
	if(MessageBox("Do you want exit?","PDF2HTML",MB_YESNO) == IDYES)
		ExitProcess(0);
}
void CWin_pdf2htmDlg::OnHelpSupport() 
{
	ShellExecute(NULL,"open",szMailTo,NULL,NULL,SW_SHOWNORMAL);
}
BOOL CombineTwoFile(const char* filedest,const char *filesrc)
{
	FILE *filedest1 = fopen(filedest,"a");
	if(filedest1 == NULL)
		return FALSE;
	FILE *filesrc1 = fopen(filesrc,"r");
	if(filesrc1 == NULL)
	{
		fclose(filedest1);
		return FALSE;
	}
	char line[1024];
	while(fgets( line, 1024, filesrc1 ))
	{
		fputs(line,filedest1);
	}

	fclose(filesrc1);
	fclose(filedest1);
	return TRUE;
}
BOOL CWin_pdf2htmDlg::ConvertPDF2HTML(CString m_strPDFFile, CString m_strHtmlFile)
{
	m_bForceContinuePages = AfxGetApp()->GetProfileInt("GenerateInOneHTMLPage","Flag",0);

	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char FileName[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(m_strPDFFile, drive, dir, FileName, ext );

	CString m_strHtmlFileStore = m_strHtmlFile;
	CString	m_strPDFName;
	CString	m_strVersion;
	CString	m_strFileSize;
	CString	m_strTotalPageInfo;
	CString	m_strTotalFiles;
	m_strPDFName = _T("");
	m_strVersion = _T("");
	m_strFileSize = _T("");
	m_strTotalPageInfo = _T("");
	m_strTotalFiles = _T("");
	//-------------------------
	CString m_ImgFilePath;
	CString m_CssFilePath;
	CString m_MainHtmName;
	CString m_HtmRootPath;

	m_MainHtmName = FileName;
	//=====ȡļϢ================================================
	HANDLE  FileHwnd;
	HRESULT  Hresult;
	WIN32_FIND_DATA FileInfo; 
	FileHwnd = FindFirstFile((LPCTSTR)m_strPDFFile, &FileInfo);
	Hresult = FindClose(FileHwnd);              
	//=================================================================
	m_strPDFName = m_strPDFFile;
	m_strVersion = _T("");
	m_strFileSize = _T("");
	GetDlgItem(IDC_STATIC_FILENAME)->SetWindowText(m_strPDFName);

	struct _stat buf;
	if(_stat(m_strPDFName, &buf ) == 0)
	{
		if(buf.st_size/1024 < 1024)
		{//KB
			m_strFileSize.Format("%d<%.2fK>",buf.st_size,buf.st_size/1024.0);
		}
		else
			m_strFileSize.Format("%d<%.2fM>",buf.st_size,buf.st_size/1024.0/1024.0);
	}
	GetDlgItem(IDC_STATIC_FILESIZE)->SetWindowText(m_strFileSize);

	//ϵ
	int m_iZoomRatio = AfxGetApp()->GetProfileInt("ZoomRatio","Zoom",100);
	switch(m_convertType)
	{
	case PDF2HTM:
		{
			//յĲm_strHtmlFileΪûָļ·ļ
			//ҪûָĿ¼½һĿ¼htmĿ¼
			int nFound = m_strHtmlFile.ReverseFind('\\');
			//½CssimgĿ¼
			m_CssFilePath=m_strHtmlFile.Left(nFound);
			//HtmĿ¼
			m_HtmRootPath=m_CssFilePath;
			//htmĿ¼
			WriteDirectory(m_HtmRootPath); 
			//WriteDirectory(m_ImgFilePath); 
			//WriteDirectory(m_CssFilePath);

			if(!m_bForceContinuePages)
			{
				CString destgifname;
				char srcfilesdirectory[MAX_PATH];
				char srcgifname[MAX_PATH];
				char srchtmlname[MAX_PATH];
				char fname[_MAX_PATH];
				destgifname = m_CssFilePath+"\\";
			
				GetModuleFileName(AfxGetInstanceHandle(),srcfilesdirectory,MAX_PATH);
				_splitpath(srcfilesdirectory, drive, dir, fname, ext );
				_makepath(srcgifname, drive, dir,"pg_*.gif", "" );
				_makepath(srchtmlname, drive, dir,"pg_*.htm", "" );

				{
					CShellFileOp shOp;
					shOp.SetParent(m_hWnd);
					shOp.SetFlags(FOF_FILESONLY|FOF_SILENT|FOF_NOCONFIRMATION|FOF_NOERRORUI
						|FOF_NOCONFIRMMKDIR|FOF_ALLOWUNDO);//|FOF_MULTIDESTFILES);
					shOp.SetMaxCount(SH_SRC_FILE,1);
					shOp.AddFile(SH_SRC_FILE,LPCTSTR(srcgifname));
					shOp.AddFile(SH_SRC_FILE,LPCTSTR(srchtmlname));
					shOp.AddFile(SH_DEST_FILE,LPCTSTR(destgifname));
					shOp.CopyFiles();
				}
			}
			break;
		}
	}
	int m_iPageFrom = 1,m_iPageTo = 100000;
	int m_iPageRange = AfxGetApp()->GetProfileInt("PageRangeType","Type",0);
	if(m_iPageRange == 1)
	{//ָ˿ʼҳͽҳ
		m_iPageFrom = AfxGetApp()->GetProfileInt("PageRange","From",1);
		m_iPageTo = AfxGetApp()->GetProfileInt("PageRange","To",100000);
		if(m_iPageFrom > m_iPageTo || m_iPageFrom < 0 || m_iPageTo < 0)
		{
			if(!m_bWithoutShowMainWnd)
				AfxMessageBox("Page range is incorrect,Please check it in option dialog,and try again.");
			return FALSE;
		}
	}

	CString m_szOwnerPassword = AfxGetApp()->GetProfileString("CPDFPassword","m_szOwnerPassword");
	CString m_szUserPassword = AfxGetApp()->GetProfileString("CPDFPassword","m_szUserPassword");
	HPDF	m_hPDF = PDF_Open(LPCTSTR(m_strPDFFile),m_szOwnerPassword,m_szUserPassword,m_iZoomRatio);
	if(m_hPDF)
	{
		//ǰPDFҳ
		int m_PageCount= PDF_GetPageCount(m_hPDF);
		if(m_iPageRange == 1)
		{//ָ˿ʼҳͽҳ
			m_iPageFrom = max(1,m_iPageFrom);
			m_iPageTo = min(m_PageCount,m_iPageTo);
		}
		else
		{//all pages
			m_iPageFrom = 1;
			m_iPageTo = m_PageCount;
		}
		if(!IsRegistered)
			m_iPageTo = min(m_iPageTo,UNREGISTER_MAX_PAGES);
		else
		{//ϵͳѾעᣬȻעеÿһ
			switch(m_convertType)
			{
			case PDF2HTM:
				if(!IsRegisteredHTM)
					m_iPageTo = min(m_iPageTo,UNREGISTER_MAX_PAGES);
				break;
			case PDF2BMP:
				if(!IsRegisteredBMP)
					m_iPageTo = min(m_iPageTo,UNREGISTER_MAX_PAGES);
				break;
			default:
				m_iPageTo = m_iPageFrom;
			}
		}
		if(m_iPageFrom > m_iPageTo)
		{
			CString strErrMessage;
			strErrMessage.Format("The '%s' file only contain %d pages, please correct the page range in the setting dialog and try again.",LPCTSTR(m_strPDFFile),m_PageCount);
			if(!m_bWithoutShowMainWnd)
				AfxMessageBox(strErrMessage);
			return FALSE;
		}

		if(m_convertType == PDF2HTM)
		{
			WriteMainHtm(m_HtmRootPath,m_MainHtmName,m_iPageFrom,m_iPageTo);
			WriteIndexHtm(m_CssFilePath,m_MainHtmName,m_iPageFrom,m_iPageTo);
			WriteNavHtm(m_CssFilePath,m_MainHtmName,m_iPageFrom,m_iPageTo);
			WriteBmarkHtm(m_hPDF,m_CssFilePath,m_MainHtmName,m_iPageFrom,m_iPageTo);
		}

		if(m_bForceContinuePages)
			DeleteFile(m_strHtmlFile);

		//ҳжϱ־
		m_bTerminateProcessPage = FALSE;

		m_pointLastPage.x = m_pointLastPage.y = 0;
		m_aryFont.clear();

		for(int page = m_iPageFrom;  !m_bTerminateProcessPage && g_bStrActive && page <= m_iPageTo; page++)
		{
			//淴Ӧ------------------------------------
			//ļ
			int totalFiles = m_aryPDF2HTMFile.GetSize();
			m_strTotalFiles.Format("%d files",totalFiles);
			GetDlgItem(IDC_STATIC_TOTALFILES)->SetWindowText(m_strTotalFiles);
			m_wndFileProgress.SetPos(99/totalFiles);
			//ҳ
			//m_strTotalPageInfo.Format("page %d of %d",page,m_PageCount);
			m_strTotalPageInfo.Format("page %d of %d",page-m_iPageFrom+1,(m_iPageTo-m_iPageFrom+1));
			GetDlgItem(IDC_STATIC_TOTALPAGES)->SetWindowText(m_strTotalPageInfo);
			//m_wndPageProgress.SetPos((page*100-1)/m_PageCount);
			m_wndPageProgress.SetPos(((page-m_iPageFrom+1)*100-1)/(m_iPageTo-m_iPageFrom+1));
			//Ĵ-------------------------------------------
			switch(m_convertType)
			{
			case PDF2BMP:
				{
					char m_strBmpFile[MAX_PATH];
					sprintf(m_strBmpFile,"%s_%03d.bmp",m_strPDFFile,page);
					HANDLE	m_hDIBInfo = PDF_GetPageBmp(m_hPDF,page);
					if(!m_bTerminateProcessPage && g_bStrActive && m_hDIBInfo)
						PDF_WriteToBMPFile(m_hDIBInfo,m_strBmpFile);
					if(m_hDIBInfo)
						PDF_DestroyPageBmp(m_hDIBInfo);
					m_hDIBInfo = NULL;
					break;
				}
			case PDF2HTM:
				{
					LPSPAGE	ptrPage = PDF_GetPageObject(m_hPDF,page);
					if(ptrPage)
					{
						m_strVersion.Format("%%PDF-%.1f",ptrPage->m_PDFVersion);
						GetDlgItem(IDC_STATIC_VERSION)->SetWindowText(m_strVersion);
					}
					if(!m_bTerminateProcessPage && g_bStrActive && ptrPage)
						ConvertPdfPage2HTML(m_hPDF,m_iPageFrom,ptrPage,m_strHtmlFile);
					if(ptrPage)
						PDF_DestroyPageObject(ptrPage);
					ptrPage = NULL;
					break;
				}
			}
		}
		PDF_Close(m_hPDF);
	}
	else
	{
		if(!m_bWithoutShowMainWnd)
		{
			CString strErrMessage;
			strErrMessage.Format("Can't extract the information from the '%s' file, "
				"this pdf file perhaps been encrypted, please double check this pdf file.",
				LPCTSTR(m_strPDFFile));
			AfxMessageBox(strErrMessage);
		}
	}
	m_wndPageProgress.SetPos(0);

	if(m_bForceContinuePages && m_convertType == PDF2HTM)
	{
		CString m_strAllHTMFiles = m_HtmRootPath+"\\"+"pg_*.htm";
		{
			CShellFileOp shOp;
			shOp.SetParent(m_hWnd);
			shOp.SetFlags(FOF_FILESONLY|FOF_SILENT|FOF_NOCONFIRMATION|FOF_NOERRORUI
				|FOF_NOCONFIRMMKDIR|FOF_ALLOWUNDO);//|FOF_MULTIDESTFILES);
			shOp.SetMaxCount(SH_SRC_FILE,1);
			shOp.AddFile(SH_SRC_FILE,m_strAllHTMFiles);
			shOp.DeleteFiles();
		}

		BOOL m_bRemovePics = AfxGetApp()->GetProfileInt("m_bRemovePics","Flag",0);
		if(m_bRemovePics)
		{
			CString m_strSrcFileName = m_HtmRootPath+"\\index.htm";
			CString m_strDesFileName = m_HtmRootPath+".htm";
			CopyFile(m_strSrcFileName,m_strDesFileName,FALSE);
			
			m_strSrcFileName = m_HtmRootPath;
			CShellFileOp shOp;
			shOp.SetParent(m_hWnd);
			shOp.SetFlags(FOF_FILESONLY|FOF_SILENT|FOF_NOCONFIRMATION|FOF_NOERRORUI
				|FOF_NOCONFIRMMKDIR);//|FOF_MULTIDESTFILES);
			shOp.SetMaxCount(SH_SRC_FILE,1);
			shOp.AddFile(SH_SRC_FILE,m_HtmRootPath);
			shOp.DeleteFiles();
			//_rmdir(m_HtmRootPath);
		}
	}
	return TRUE;
}

void CWin_pdf2htmDlg::ConvertPdfPage2HTML(HPDF m_hPDF,int firstpage,LPSPAGE ptrPage, CString m_strHtmlFileName)
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(m_strHtmlFileName, drive, dir, fname, ext );
	_makepath(path_buffer,drive, dir,"pg","");
	CString m_strHtmlFile;
	m_strHtmlFile = path_buffer;
	sprintf(path_buffer,"_%04d",ptrPage->m_No-firstpage+1);
	m_strHtmlFile += path_buffer;
	m_strHtmlFile += ext;

	LPARY_HTMLINK lpHtmLink = NULL;
	BOOL m_bEnableLinks = AfxGetApp()->GetProfileInt("CHyperlinks","m_bEnableLinks",TRUE);
	if(m_bEnableLinks)
		lpHtmLink = PDF_GetPageHtmLink(m_hPDF,ptrPage->m_No);
	PDF_ConvertToHtmlFile(ptrPage,lpHtmLink,m_strHtmlFile);
	if(lpHtmLink)
		PDF_DestroyHtmLink(lpHtmLink);
}

typedef BOOL (WINAPI * OCRFUNC)(LPSTR,char*,int,int,char,char);
int OCRForImage(CString m_strBMPFile,CString m_strTempFileStore)
{
	return TRUE;
}

void CWin_pdf2htmDlg::OnFileTop() 
{
	DWORD dwStyle = GetWindowLong (m_hWnd,GWL_EXSTYLE);
	if(dwStyle & WS_EX_TOPMOST)
		::SetWindowPos( m_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
			       SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	else
		::SetWindowPos( m_hWnd, HWND_TOPMOST, 0, 0, 0, 0,
				 SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	dwStyle = ::GetWindowLong(m_hWnd,GWL_EXSTYLE);
	HMENU hMenu = ::GetMenu(m_hWnd);
	CheckMenuItem(hMenu,IDM_FILE_TOP,(dwStyle&WS_EX_TOPMOST?MF_CHECKED:MF_UNCHECKED));
	AfxGetApp()->WriteProfileInt("WindowsTopMost","Flag",dwStyle&WS_EX_TOPMOST?1:0);
}

void CWin_pdf2htmDlg::OnUpdateFileTop(CCmdUI* pCmdUI) 
{
}
void CWin_pdf2htmDlg::ExportRSC(CString PathName,char *RID,char *RSCDIR,CString FileName)
{
}
void CWin_pdf2htmDlg::WriteMainHtm(CString CssPathName,CString MainHtmName,int firstpage, int lastpage)
{
	CString StrText;
	CString szFirstpage;
	szFirstpage.Format("pg_%04d.htm",1);

	CString strIndexPage = "pg_index.htm";
	CString strNavPage = "pg_nav.htm";
	CString strFirstPage = szFirstpage;

	int m_iPageTitle = AfxGetApp()->GetProfileInt("CHTMLPage","m_iPageTitle",0);
	CString m_szPageTitle = AfxGetApp()->GetProfileString("CHTMLPage","m_szPageTitle");
	if(m_iPageTitle == 1)
		MainHtmName = m_szPageTitle;

	CString m_szPageKeywords = AfxGetApp()->GetProfileString("CHTMLPage","m_szPageKeywords");
	CString m_szPageKeywords2;
	if(m_szPageKeywords.GetLength() > 0)
	{
		m_szPageKeywords2 = "\n<meta name=\"keywords\" content=\"";
		m_szPageKeywords2 += m_szPageKeywords;
		m_szPageKeywords2 += "\">\n";
	}

	CString tempstr;
	tempstr.Format("<html><head><title>%s</title>%s\
<script language=\"javascript\">\n\
var firstpage = %d;\n\
var lastpage = %d;\n\
</script></head>\n\
<frameset rows=\"30,*\" framespacing=\"1\" border=\"0\" frameborder=\"0\">\n\
    <frame name=\"ltop\" scrolling=\"no\" target=\"lbottom\" src=\"%s\">\n\
    <frameset name = \"leftpane\" cols=\"150,*\">\n\
	<frame name=\"lbottom\" target=\"contents\" src=\"%s\">\n\
	<frame name=\"contents\" src=\"%s\">\n\
    </frameset>\n\
\
  <noframes>\n\
  <body>\n\
  	<p>This page uses frames, but your browser doesn't support them.</p>\n\
  </body>\n\
  </noframes>\n\
</frameset></html>\n",
LPCTSTR(MainHtmName),m_szPageKeywords2,
1,lastpage-firstpage+1,
LPCTSTR(strNavPage),LPCTSTR(strIndexPage),LPCTSTR(strFirstPage));

	StrText = tempstr;

	FILE *stream;
	stream = fopen(CssPathName+"\\index.htm", "w" );//ļ
	if(stream)
	{
		fprintf(stream,StrText);
		fclose(stream);
	}
}
void CWin_pdf2htmDlg::WriteIndexHtm(CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
	int m_bHomepageURL = AfxGetApp()->GetProfileInt("CHTMLPage","m_bHomepageURL",0);
	CString m_strHomepageURL = AfxGetApp()->GetProfileString("CHTMLPage","m_strHomepageURL");
	if(!m_bHomepageURL || m_strHomepageURL.GetLength() == 0)
		return;
	CString m_strHomepageURL2;
	m_strHomepageURL2 = "<html><body><table><tr><td><img src=\"pg_page.gif\"><a href=\"";
	m_strHomepageURL2 += m_strHomepageURL;
	m_strHomepageURL2 += "\"target=\"_top\">Home</a></td></tr></table></body></html>";

	CssPathName += "\\";
	CssPathName += "pg_index.htm";
	FILE *stream = fopen(CssPathName, "a" );//ļ
	if(stream)
	{
		fputs(LPCTSTR(m_strHomepageURL2),stream);
		fclose(stream);
	}
}
extern char *getLine(char *buf, int size, FILE *f);
struct SPAGENODE{
	int level;
	CString bookmarkname;
	int pageno;
};
int ReadBookmark(HPDF m_hPDF,vector<SPAGENODE>& m_aryBookmark)
{
	char szFileName[MAX_PATH];
	if(PDF_GetBookmark(m_hPDF,szFileName,MAX_PATH) == TRUE)
	{
		FILE *fBookmarkFile;
		if((fBookmarkFile = fopen(szFileName,"r")) != NULL)
		{
			int nestDepth = 0;
			int m_nNodeList = -1;
			CString m_strLine;
			//while(fBookmarkFile.ReadString(m_strLine))
			char textline[4096];
			while(fgets(textline,4096,fBookmarkFile))
			{
				m_strLine = textline;
				m_strLine.Remove('\r');
				m_strLine.Remove('\n');
				int m_nTabCount = 0;//Tab
				int length = m_strLine.GetLength();
				if(length <= 0)
					continue;
				char *splitStr = "<>,";
				int i;// = m_strLine.Find(splitStr,0);
				const char *ppp1 = LPCTSTR(m_strLine);
				const char *ppp = strstr(ppp1,splitStr);
				if(ppp == NULL)
					i = -1;
				else
					i = ppp - ppp1;
				CString m_strText;//ǩ
				if(i == -1)
					m_strText = m_strLine;
				else
					m_strText = m_strLine.Left(i);
				m_strText.TrimLeft('\t');
				CString m_strPageNO = "1";
				if(i == -1)
				{
				}
				else
				{
					int first = i+strlen(splitStr);
					for(i = first; i < length; i++)
						if(m_strLine[i] == ',')
							break;
					if(i-first > 0)
						m_strPageNO = m_strLine.Mid(first,i-first);
				}
				while(m_strLine[m_nTabCount] == '\t')
					m_nTabCount++;
				//if(m_strText.GetLength() > 0)
				{
					//Ŀ¼
					//m_nNodeList++;
					int pageno = atoi(m_strPageNO);
					SPAGENODE m_nPageNode;
					m_nPageNode.bookmarkname = m_strText;
					m_nPageNode.level = m_nTabCount;
					m_nPageNode.pageno = pageno;
					m_nPageNode.bookmarkname.Replace("\"","&quot;");
					m_nPageNode.bookmarkname.Replace("<","&lt;");
					m_nPageNode.bookmarkname.Replace(">","&gt;");
					m_aryBookmark.push_back(m_nPageNode);
				}
			}
			fclose(fBookmarkFile);
		}
	}
	return m_aryBookmark.size();
}
void CWin_pdf2htmDlg::WriteBmarkHtm(HPDF m_hPDF,CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
	CString StrText;
	StrText.Format("root0 = gFld(\"%s\", \"\")\n",MainHtmName);

	vector<SPAGENODE> m_aryBookmark;
	if(ReadBookmark(m_hPDF,m_aryBookmark) > 0)
	{
		int nsize = m_aryBookmark.size();
		for(int i = 0; i < nsize; i++)
		{
			if((i+1 < nsize) && (m_aryBookmark[i].level < m_aryBookmark[i+1].level))
			{
				CString szNode;
				szNode.Format("root%d = insFld(root%d, gFld(\"%s\", \"%d\"))\n",
					m_aryBookmark[i].level+1,m_aryBookmark[i].level,
					LPCTSTR(m_aryBookmark[i].bookmarkname),
					m_aryBookmark[i].pageno-firstpage+1>0?m_aryBookmark[i].pageno-firstpage+1:0);
				StrText += szNode;
			}
			else
			{
				CString szNode;
				szNode.Format("insDoc(root%d, gLnk(2,\"%s\", \"%d\"))\n",
					m_aryBookmark[i].level,
					LPCTSTR(m_aryBookmark[i].bookmarkname),
					m_aryBookmark[i].pageno-firstpage+1>0?m_aryBookmark[i].pageno-firstpage+1:0);
				StrText += szNode;
			}
		}
	}
	else
	{
		StrText += "root0 = gFld(\"Your pdf file doesn't contain bookmarks\", \"\")\n";
	}

/////////////////////////

/////////////////////////
	StrText += "</script><script>initializeDocument()</script></head>\n\
<body bgcolor=white  style=\"border-right: 2 solid #CCCCCC\">\n\
</body>\n\
</html>";

	FILE *stream;
	stream = fopen(CssPathName+"\\pg_bmark.htm", "a" );//ļ
	if(stream)
	{
		fprintf(stream,StrText);
		fclose(stream);
	}
}
void CWin_pdf2htmDlg::WriteNavHtm(CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
/*	CString m_strFirstPage;
	m_strFirstPage.Format("%d",firstpage);
	CString m_strLastPage;
	m_strLastPage.Format("%d",lastpage);

	FILE *stream;
	stream = fopen(CssPathName+"\\pg_nav.htm", "w" );//ļ
	if(stream)
	{
		int bufflen = sizeof(szNavBuffer)/sizeof(char*);
		for(int i = 0; i < bufflen; i++)
			fputs(szNavBuffer[i],stream);
		fclose(stream);
	}
*/
}

void CWin_pdf2htmDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_aryPDF2HTMFile.GetSize() > 0)
	{
		CString m_strPause;
		GetDlgItem(IDPAUSE)->GetWindowText(m_strPause);
		if(m_strPause == "Pause")//ǰͣ״̬
			SetCursor(hAniCursor);
	}
	//CDialog::OnMouseMove(nFlags, point);
}
void CWin_pdf2htmDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	g_bStrActive = FALSE;
	if(hNetBarThread)
	{
		if(WaitForSingleObject(hNetBarThread,5000) == WAIT_TIMEOUT)
		{
			TerminateThread(hNetBarThread,0);
		}
		CloseHandle(hNetBarThread);
		hNetBarThread = NULL;
	}
	//ɾź
	DeleteCriticalSection(&nCriticalSection);
}

int CWin_pdf2htmDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetTimer(100,5,NULL);
	
	return 0;
}

BOOL CWin_pdf2htmDlg::PreTranslateMessage(MSG* pMsg) 
{
	switch(pMsg->message)
	{
	case WM_KEYDOWN:
	case WM_CHAR:
	case WM_SYSCHAR:
	case WM_SYSKEYDOWN:
		{
			if(MyCheckKeyDown(pMsg->hwnd,pMsg->wParam,pMsg->lParam))
				return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

LRESULT CWin_pdf2htmDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(MenuPreTranslateMessage(cSpawn,m_hWnd,
		message,wParam,lParam) == TRUE)
		return 1;
	
	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_HyperEmailLink.SetURL(szMailTo);
	m_HyperEmailLink.SetUnderline(FALSE);
	
	m_HyperHomePageLink.SetURL("http://www.verypdf.com/");
	m_HyperHomePageLink.SetUnderline(FALSE);

	char szVersion[] = "PDF2HTML version 1.6";
	SetWindowText(szVersion);
	GetDlgItem(IDC_VERSION)->SetWindowText(szVersion);

	m_szRegisterInfo.Format(
		"PDF2HTML Version 1.6\r\n"
		"Register type: %s\r\n"
		"PDF2HTM function: %s\r\n",
		IsRegistered?"Registered":"Unregister",
		IsRegisteredHTM?"Yes":"No"
		);
	m_szRegisterInfo += "\r\n";
	m_szRegisterInfo += "PDF2HTML v1.6 is licensed under ";
	m_szRegisterInfo += "the GNU General Public License (GPL).  ";
	m_szRegisterInfo += "See the 'COPYING' file for details. \r\nPortions of ";
	m_szRegisterInfo += "this software are copyright 1996-2002 Glyph & Cog, LLC.\r\n";


	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWin_pdf2htmDlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	POINT	CurPos;
	GetCursorPos(&CurPos);
	CMenu *m_menuSub = GetMenu()->GetSubMenu(0);
	m_menuSub->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		CurPos.x,CurPos.y+2,this);
//	CDialog::OnRButtonUp(nFlags, point);
}
BOOL CWin_pdf2htmDlg::MyCheckKeyDown(HWND hWnd,WPARAM wParam, LPARAM lParam)
{
	switch (wParam)
	{
	case VK_F1:
		OnHelpHelp();
		return TRUE;
	case VK_ESCAPE:
		OnFileExit();
		return TRUE;
	case 'F':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFileOpen();
		return TRUE;
	case 'D':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFilePreferences();
		return TRUE;
	case 'Q':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFileExit();
		return TRUE;
	case 'T':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFileTop();
		return TRUE;
	}
	return FALSE;
}

void CWin_pdf2htmDlg::OnHelpHelp() 
{
	ShellOpen("help.html");
}

void CWin_pdf2htmDlg::OnPause() 
{
	// TODO: Add your control notification handler code here
	CString m_strPause;
	GetDlgItem(IDPAUSE)->GetWindowText(m_strPause);
	if(m_strPause == "Pause")
	{
		SuspendThread(hNetBarThread);
		GetDlgItem(IDPAUSE)->SetWindowText("Resume");
		GetDlgItem(IDCLOSE)->EnableWindow(FALSE);
	}
	else if(m_strPause == "Resume")
	{
		ResumeThread(hNetBarThread);
		GetDlgItem(IDPAUSE)->SetWindowText("Pause");
		GetDlgItem(IDCLOSE)->EnableWindow(TRUE);
	}
}

void CWin_pdf2htmDlg::OnClose() 
{
	CString m_strClose;
	GetDlgItem(IDCLOSE)->GetWindowText(m_strClose);
	if(m_strClose == "Stop")
	{//ǰڴ
		if (MessageBox("Are you sure to stop?","PDF2HTML",MB_YESNO)==IDYES)
		{
			//ҳжϱ־ֹͣǰļת
			m_bTerminateProcessPage = TRUE;
			//ļУֹʣPDFļĴ
			EnterCriticalSection(&nCriticalSection);
			m_aryPDF2HTMFile.RemoveAll();
			LeaveCriticalSection(&nCriticalSection);
		}
	}
	else if(m_strClose == "Close")
	{
		if(MessageBox("Do you want exit?","PDF2HTML",MB_YESNO) == IDYES)
			ExitProcess(0);

	}
}
void CWin_pdf2htmDlg::OnHelpRegister() 
{
	IsRegistered = ShowRegisterDlg(IsRegistered,m_hWnd);
}

void CWin_pdf2htmDlg::WinHelp(DWORD dwData, UINT nCmd) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//CDialog::WinHelp(dwData, nCmd);
}

void CWin_pdf2htmDlg::OnHelpProductlist() 
{
	ShellOpen("product.pdf");
}

void CWin_pdf2htmDlg::ShellOpen(LPCTSTR lpDoc)
{
	CHAR	szExeDir[MAX_PATH];
	GetModuleFileName(AfxGetInstanceHandle(),szExeDir,MAX_PATH);
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
	_splitpath(szExeDir, drive, dir, fname, ext );
	_makepath(szExeDir, drive, dir,"","");
	if(szExeDir[strlen(szExeDir)-1] != '\\')
		strcat(szExeDir,"\\");
	strcat(szExeDir,lpDoc);
	ShellExecute(m_hWnd,"open",szExeDir,NULL,NULL,SW_SHOWNORMAL);
}

void CWin_pdf2htmDlg::OnHelpBuynow() 
{
	MyGotoURL(szEnglishRegister,SW_SHOWNORMAL);
}

void CWin_pdf2htmDlg::OnHelpPdf2htmOnweb() 
{
	MyGotoURL(szEnglishHomepage,SW_SHOWNORMAL);
}

void CWin_pdf2htmDlg::OnToolsPdf2htm() 
{
	m_convertType = PDF2HTM;
	UpdateTitle();
}

void CWin_pdf2htmDlg::OnToolsPdf2bmp() 
{
	m_convertType = PDF2BMP;
	UpdateTitle();
}


void CWin_pdf2htmDlg::OnTimer(UINT nIDEvent) 
{
	if(m_bWithoutShowMainWnd)
		ShowWindow(SW_HIDE);
	CDialog::OnTimer(nIDEvent);
}
